/*!-----------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Version: 0.35.0-dev.20221217(212670ceb460441b3ebed29e6ca30aa1e9bdde85)
 * Released under the MIT license
 * https://github.com/microsoft/vscode/blob/main/LICENSE.txt
 *-----------------------------------------------------------*/(function(){var Q=["require","exports","vs/editor/common/core/range","vs/editor/common/core/position","vs/base/common/strings","vs/base/common/platform","vs/editor/common/diff/algorithms/diffAlgorithm","vs/base/common/event","vs/base/common/errors","vs/base/common/assert","vs/base/common/lifecycle","vs/base/common/objects","vs/base/common/uri","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/diff/diff","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/diff/linesDiffComputer","vs/base/common/stopwatch","vs/nls","vs/base/common/arrays","vs/base/common/cache","vs/base/common/codicons","vs/base/common/diff/diffChange","vs/base/common/functional","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/hash","vs/base/common/types","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/algorithms/joinSequenceDiffs","vs/editor/common/diff/algorithms/myersDiffAlgorithm","vs/editor/common/diff/algorithms/utils","vs/editor/common/diff/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/smartLinesDiffComputer","vs/editor/common/diff/standardLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/nls!vs/base/common/platform","vs/base/common/process","vs/base/common/path","vs/base/common/cancellation","vs/editor/common/tokenizationRegistry","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/nls!vs/base/common/worker/simpleWorker","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],J=function(T){for(var r=[],A=0,e=T.length;A<e;A++)r[A]=Q[T[A]];return r},Ee=this,Re=typeof global=="object"?global:{},se;(function(T){T.global=Ee;var r=function(){function A(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}return Object.defineProperty(A.prototype,"isWindows",{get:function(){return this._detect(),this._isWindows},enumerable:!1,configurable:!0}),Object.defineProperty(A.prototype,"isNode",{get:function(){return this._detect(),this._isNode},enumerable:!1,configurable:!0}),Object.defineProperty(A.prototype,"isElectronRenderer",{get:function(){return this._detect(),this._isElectronRenderer},enumerable:!1,configurable:!0}),Object.defineProperty(A.prototype,"isWebWorker",{get:function(){return this._detect(),this._isWebWorker},enumerable:!1,configurable:!0}),Object.defineProperty(A.prototype,"isElectronNodeIntegrationWebWorker",{get:function(){return this._detect(),this._isElectronNodeIntegrationWebWorker},enumerable:!1,configurable:!0}),A.prototype._detect=function(){this._detected||(this._detected=!0,this._isWindows=A._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof T.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")},A._isWindows=function(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1},A}();T.Environment=r})(se||(se={}));var se;(function(T){var r=function(){function E(l,p,C){this.type=l,this.detail=p,this.timestamp=C}return E}();T.LoaderEvent=r;var A=function(){function E(l){this._events=[new r(1,"",l)]}return E.prototype.record=function(l,p){this._events.push(new r(l,p,T.Utilities.getHighPerformanceTimestamp()))},E.prototype.getEvents=function(){return this._events},E}();T.LoaderEventRecorder=A;var e=function(){function E(){}return E.prototype.record=function(l,p){},E.prototype.getEvents=function(){return[]},E.INSTANCE=new E,E}();T.NullLoaderEventRecorder=e})(se||(se={}));var se;(function(T){var r=function(){function A(){}return A.fileUriToFilePath=function(e,E){if(E=decodeURI(E).replace(/%23/g,"#"),e){if(/^file:\/\/\//.test(E))return E.substr(8);if(/^file:\/\//.test(E))return E.substr(5)}else if(/^file:\/\//.test(E))return E.substr(7);return E},A.startsWith=function(e,E){return e.length>=E.length&&e.substr(0,E.length)===E},A.endsWith=function(e,E){return e.length>=E.length&&e.substr(e.length-E.length)===E},A.containsQueryString=function(e){return/^[^\#]*\?/gi.test(e)},A.isAbsolutePath=function(e){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(e)},A.forEachProperty=function(e,E){if(e){var l=void 0;for(l in e)e.hasOwnProperty(l)&&E(l,e[l])}},A.isEmpty=function(e){var E=!0;return A.forEachProperty(e,function(){E=!1}),E},A.recursiveClone=function(e){if(!e||typeof e!="object"||e instanceof RegExp||!Array.isArray(e)&&Object.getPrototypeOf(e)!==Object.prototype)return e;var E=Array.isArray(e)?[]:{};return A.forEachProperty(e,function(l,p){p&&typeof p=="object"?E[l]=A.recursiveClone(p):E[l]=p}),E},A.generateAnonymousModule=function(){return"===anonymous"+A.NEXT_ANONYMOUS_ID+++"==="},A.isAnonymousModule=function(e){return A.startsWith(e,"===anonymous")},A.getHighPerformanceTimestamp=function(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=T.global.performance&&typeof T.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?T.global.performance.now():Date.now()},A.NEXT_ANONYMOUS_ID=1,A.PERFORMANCE_NOW_PROBED=!1,A.HAS_PERFORMANCE_NOW=!1,A}();T.Utilities=r})(se||(se={}));var se;(function(T){function r(E){if(E instanceof Error)return E;var l=new Error(E.message||String(E)||"Unknown Error");return E.stack&&(l.stack=E.stack),l}T.ensureError=r;var A=function(){function E(){}return E.validateConfigurationOptions=function(l){function p(o){if(o.phase==="loading"){console.error('Loading "'+o.moduleId+'" failed'),console.error(o),console.error("Here are the modules that depend on it:"),console.error(o.neededBy);return}if(o.phase==="factory"){console.error('The factory function of "'+o.moduleId+'" has thrown an exception'),console.error(o),console.error("Here are the modules that depend on it:"),console.error(o.neededBy);return}}if(l=l||{},typeof l.baseUrl!="string"&&(l.baseUrl=""),typeof l.isBuild!="boolean"&&(l.isBuild=!1),typeof l.paths!="object"&&(l.paths={}),typeof l.config!="object"&&(l.config={}),typeof l.catchError>"u"&&(l.catchError=!1),typeof l.recordStats>"u"&&(l.recordStats=!1),typeof l.urlArgs!="string"&&(l.urlArgs=""),typeof l.onError!="function"&&(l.onError=p),Array.isArray(l.ignoreDuplicateModules)||(l.ignoreDuplicateModules=[]),l.baseUrl.length>0&&(T.Utilities.endsWith(l.baseUrl,"/")||(l.baseUrl+="/")),typeof l.cspNonce!="string"&&(l.cspNonce=""),typeof l.preferScriptTags>"u"&&(l.preferScriptTags=!1),l.nodeCachedData&&typeof l.nodeCachedData=="object"&&(typeof l.nodeCachedData.seed!="string"&&(l.nodeCachedData.seed="seed"),(typeof l.nodeCachedData.writeDelay!="number"||l.nodeCachedData.writeDelay<0)&&(l.nodeCachedData.writeDelay=1e3*7),!l.nodeCachedData.path||typeof l.nodeCachedData.path!="string")){var C=r(new Error("INVALID cached data configuration, 'path' MUST be set"));C.phase="configuration",l.onError(C),l.nodeCachedData=void 0}return l},E.mergeConfigurationOptions=function(l,p){l===void 0&&(l=null),p===void 0&&(p=null);var C=T.Utilities.recursiveClone(p||{});return T.Utilities.forEachProperty(l,function(o,f){o==="ignoreDuplicateModules"&&typeof C.ignoreDuplicateModules<"u"?C.ignoreDuplicateModules=C.ignoreDuplicateModules.concat(f):o==="paths"&&typeof C.paths<"u"?T.Utilities.forEachProperty(f,function(S,t){return C.paths[S]=t}):o==="config"&&typeof C.config<"u"?T.Utilities.forEachProperty(f,function(S,t){return C.config[S]=t}):C[o]=T.Utilities.recursiveClone(f)}),E.validateConfigurationOptions(C)},E}();T.ConfigurationOptionsUtil=A;var e=function(){function E(l,p){if(this._env=l,this.options=A.mergeConfigurationOptions(p),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){var C=this.options.nodeRequire.main.filename,o=Math.max(C.lastIndexOf("/"),C.lastIndexOf("\\"));this.options.baseUrl=C.substring(0,o+1)}}return E.prototype._createIgnoreDuplicateModulesMap=function(){this.ignoreDuplicateModulesMap={};for(var l=0;l<this.options.ignoreDuplicateModules.length;l++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[l]]=!0},E.prototype._createSortedPathsRules=function(){var l=this;this.sortedPathsRules=[],T.Utilities.forEachProperty(this.options.paths,function(p,C){Array.isArray(C)?l.sortedPathsRules.push({from:p,to:C}):l.sortedPathsRules.push({from:p,to:[C]})}),this.sortedPathsRules.sort(function(p,C){return C.from.length-p.from.length})},E.prototype.cloneAndMerge=function(l){return new E(this._env,A.mergeConfigurationOptions(l,this.options))},E.prototype.getOptionsLiteral=function(){return this.options},E.prototype._applyPaths=function(l){for(var p,C=0,o=this.sortedPathsRules.length;C<o;C++)if(p=this.sortedPathsRules[C],T.Utilities.startsWith(l,p.from)){for(var f=[],S=0,t=p.to.length;S<t;S++)f.push(p.to[S]+l.substr(p.from.length));return f}return[l]},E.prototype._addUrlArgsToUrl=function(l){return T.Utilities.containsQueryString(l)?l+"&"+this.options.urlArgs:l+"?"+this.options.urlArgs},E.prototype._addUrlArgsIfNecessaryToUrl=function(l){return this.options.urlArgs?this._addUrlArgsToUrl(l):l},E.prototype._addUrlArgsIfNecessaryToUrls=function(l){if(this.options.urlArgs)for(var p=0,C=l.length;p<C;p++)l[p]=this._addUrlArgsToUrl(l[p]);return l},E.prototype.moduleIdToPaths=function(l){if(this._env.isNode){var p=this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(l);if(p)return this.isBuild()?["empty:"]:["node|"+l]}var C=l,o;if(!T.Utilities.endsWith(C,".js")&&!T.Utilities.isAbsolutePath(C)){o=this._applyPaths(C);for(var f=0,S=o.length;f<S;f++)this.isBuild()&&o[f]==="empty:"||(T.Utilities.isAbsolutePath(o[f])||(o[f]=this.options.baseUrl+o[f]),!T.Utilities.endsWith(o[f],".js")&&!T.Utilities.containsQueryString(o[f])&&(o[f]=o[f]+".js"))}else!T.Utilities.endsWith(C,".js")&&!T.Utilities.containsQueryString(C)&&(C=C+".js"),o=[C];return this._addUrlArgsIfNecessaryToUrls(o)},E.prototype.requireToUrl=function(l){var p=l;return T.Utilities.isAbsolutePath(p)||(p=this._applyPaths(p)[0],T.Utilities.isAbsolutePath(p)||(p=this.options.baseUrl+p)),this._addUrlArgsIfNecessaryToUrl(p)},E.prototype.isBuild=function(){return this.options.isBuild},E.prototype.shouldInvokeFactory=function(l){return!!(!this.options.isBuild||T.Utilities.isAnonymousModule(l)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[l])},E.prototype.isDuplicateMessageIgnoredFor=function(l){return this.ignoreDuplicateModulesMap.hasOwnProperty(l)},E.prototype.getConfigForModule=function(l){if(this.options.config)return this.options.config[l]},E.prototype.shouldCatchError=function(){return this.options.catchError},E.prototype.shouldRecordStats=function(){return this.options.recordStats},E.prototype.onError=function(l){this.options.onError(l)},E}();T.Configuration=e})(se||(se={}));var se;(function(T){var r=function(){function o(f){this._env=f,this._scriptLoader=null,this._callbackMap={}}return o.prototype.load=function(f,S,t,w){var h=this;if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new E;else if(this._env.isElectronRenderer){var m=f.getConfig().getOptionsLiteral().preferScriptTags;m?this._scriptLoader=new A:this._scriptLoader=new l(this._env)}else this._env.isNode?this._scriptLoader=new l(this._env):this._scriptLoader=new A;var L={callback:t,errorback:w};if(this._callbackMap.hasOwnProperty(S)){this._callbackMap[S].push(L);return}this._callbackMap[S]=[L],this._scriptLoader.load(f,S,function(){return h.triggerCallback(S)},function(y){return h.triggerErrorback(S,y)})},o.prototype.triggerCallback=function(f){var S=this._callbackMap[f];delete this._callbackMap[f];for(var t=0;t<S.length;t++)S[t].callback()},o.prototype.triggerErrorback=function(f,S){var t=this._callbackMap[f];delete this._callbackMap[f];for(var w=0;w<t.length;w++)t[w].errorback(S)},o}(),A=function(){function o(){}return o.prototype.attachListeners=function(f,S,t){var w=function(){f.removeEventListener("load",h),f.removeEventListener("error",m)},h=function(L){w(),S()},m=function(L){w(),t(L)};f.addEventListener("load",h),f.addEventListener("error",m)},o.prototype.load=function(f,S,t,w){if(/^node\|/.test(S)){var h=f.getConfig().getOptionsLiteral(),m=p(f.getRecorder(),h.nodeRequire||T.global.nodeRequire),L=S.split("|"),y=null;try{y=m(L[1])}catch(u){w(u);return}f.enqueueDefineAnonymousModule([],function(){return y}),t()}else{var _=document.createElement("script");_.setAttribute("async","async"),_.setAttribute("type","text/javascript"),this.attachListeners(_,t,w);var g=f.getConfig().getOptionsLiteral().trustedTypesPolicy;g&&(S=g.createScriptURL(S)),_.setAttribute("src",S);var v=f.getConfig().getOptionsLiteral().cspNonce;v&&_.setAttribute("nonce",v),document.getElementsByTagName("head")[0].appendChild(_)}},o}();function e(o){var f=o.getConfig().getOptionsLiteral().trustedTypesPolicy;try{var S=f?self.eval(f.createScript("","true")):new Function("true");return S.call(self),!0}catch{return!1}}var E=function(){function o(){this._cachedCanUseEval=null}return o.prototype._canUseEval=function(f){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=e(f)),this._cachedCanUseEval},o.prototype.load=function(f,S,t,w){if(/^node\|/.test(S)){var h=f.getConfig().getOptionsLiteral(),m=p(f.getRecorder(),h.nodeRequire||T.global.nodeRequire),L=S.split("|"),y=null;try{y=m(L[1])}catch(v){w(v);return}f.enqueueDefineAnonymousModule([],function(){return y}),t()}else{var _=f.getConfig().getOptionsLiteral().trustedTypesPolicy,g=/^((http:)|(https:)|(file:))/.test(S)&&S.substring(0,self.origin.length)!==self.origin;if(!g&&this._canUseEval(f)){fetch(S).then(function(v){if(v.status!==200)throw new Error(v.statusText);return v.text()}).then(function(v){v=v+`
//# sourceURL=`+S;var u=_?self.eval(_.createScript("",v)):new Function(v);u.call(self),t()}).then(void 0,w);return}try{_&&(S=_.createScriptURL(S)),importScripts(S),t()}catch(v){w(v)}}},o}(),l=function(){function o(f){this._env=f,this._didInitialize=!1,this._didPatchNodeRequire=!1}return o.prototype._init=function(f){this._didInitialize||(this._didInitialize=!0,this._fs=f("fs"),this._vm=f("vm"),this._path=f("path"),this._crypto=f("crypto"))},o.prototype._initNodeRequire=function(f,S){var t=S.getConfig().getOptionsLiteral().nodeCachedData;if(!t||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;var w=this,h=f("module");function m(L){var y=L.constructor,_=function(v){try{return L.require(v)}finally{}};return _.resolve=function(v,u){return y._resolveFilename(v,L,!1,u)},_.resolve.paths=function(v){return y._resolveLookupPaths(v,L)},_.main=process.mainModule,_.extensions=y._extensions,_.cache=y._cache,_}h.prototype._compile=function(L,y){var _=h.wrap(L.replace(/^#!.*/,"")),g=S.getRecorder(),v=w._getCachedDataPath(t,y),u={filename:y},d;try{var s=w._fs.readFileSync(v);d=s.slice(0,16),u.cachedData=s.slice(16),g.record(60,v)}catch{g.record(61,v)}var a=new w._vm.Script(_,u),i=a.runInThisContext(u),c=w._path.dirname(y),b=m(this),N=[this.exports,b,this,y,c,process,Re,Buffer],M=i.apply(this.exports,N);return w._handleCachedData(a,_,v,!u.cachedData,S),w._verifyCachedData(a,_,v,d,S),M}},o.prototype.load=function(f,S,t,w){var h=this,m=f.getConfig().getOptionsLiteral(),L=p(f.getRecorder(),m.nodeRequire||T.global.nodeRequire),y=m.nodeInstrumenter||function(i){return i};this._init(L),this._initNodeRequire(L,f);var _=f.getRecorder();if(/^node\|/.test(S)){var g=S.split("|"),v=null;try{v=L(g[1])}catch(i){w(i);return}f.enqueueDefineAnonymousModule([],function(){return v}),t()}else{S=T.Utilities.fileUriToFilePath(this._env.isWindows,S);var u=this._path.normalize(S),d=this._getElectronRendererScriptPathOrUri(u),s=Boolean(m.nodeCachedData),a=s?this._getCachedDataPath(m.nodeCachedData,S):void 0;this._readSourceAndCachedData(u,a,_,function(i,c,b,N){if(i){w(i);return}var M;c.charCodeAt(0)===o._BOM?M=o._PREFIX+c.substring(1)+o._SUFFIX:M=o._PREFIX+c+o._SUFFIX,M=y(M,u);var R={filename:d,cachedData:b},P=h._createAndEvalScript(f,M,R,t,w);h._handleCachedData(P,M,a,s&&!b,f),h._verifyCachedData(P,M,a,N,f)})}},o.prototype._createAndEvalScript=function(f,S,t,w,h){var m=f.getRecorder();m.record(31,t.filename);var L=new this._vm.Script(S,t),y=L.runInThisContext(t),_=f.getGlobalAMDDefineFunc(),g=!1,v=function(){return g=!0,_.apply(null,arguments)};return v.amd=_.amd,y.call(T.global,f.getGlobalAMDRequireFunc(),v,t.filename,this._path.dirname(t.filename)),m.record(32,t.filename),g?w():h(new Error("Didn't receive define call in "+t.filename+"!")),L},o.prototype._getElectronRendererScriptPathOrUri=function(f){if(!this._env.isElectronRenderer)return f;var S=f.match(/^([a-z])\:(.*)/i);return S?"file:///"+(S[1].toUpperCase()+":"+S[2]).replace(/\\/g,"/"):"file://"+f},o.prototype._getCachedDataPath=function(f,S){var t=this._crypto.createHash("md5").update(S,"utf8").update(f.seed,"utf8").update(process.arch,"").digest("hex"),w=this._path.basename(S).replace(/\.js$/,"");return this._path.join(f.path,w+"-"+t+".code")},o.prototype._handleCachedData=function(f,S,t,w,h){var m=this;f.cachedDataRejected?this._fs.unlink(t,function(L){h.getRecorder().record(62,t),m._createAndWriteCachedData(f,S,t,h),L&&h.getConfig().onError(L)}):w&&this._createAndWriteCachedData(f,S,t,h)},o.prototype._createAndWriteCachedData=function(f,S,t,w){var h=this,m=Math.ceil(w.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),L=-1,y=0,_=void 0,g=function(){setTimeout(function(){_||(_=h._crypto.createHash("md5").update(S,"utf8").digest());var v=f.createCachedData();if(!(v.length===0||v.length===L||y>=5)){if(v.length<L){g();return}L=v.length,h._fs.writeFile(t,Buffer.concat([_,v]),function(u){u&&w.getConfig().onError(u),w.getRecorder().record(63,t),g()})}},m*Math.pow(4,y++))};g()},o.prototype._readSourceAndCachedData=function(f,S,t,w){if(!S)this._fs.readFile(f,{encoding:"utf8"},w);else{var h=void 0,m=void 0,L=void 0,y=2,_=function(g){g?w(g):--y===0&&w(void 0,h,m,L)};this._fs.readFile(f,{encoding:"utf8"},function(g,v){h=v,_(g)}),this._fs.readFile(S,function(g,v){!g&&v&&v.length>0?(L=v.slice(0,16),m=v.slice(16),t.record(60,S)):t.record(61,S),_()})}},o.prototype._verifyCachedData=function(f,S,t,w,h){var m=this;!w||f.cachedDataRejected||setTimeout(function(){var L=m._crypto.createHash("md5").update(S,"utf8").digest();w.equals(L)||(h.getConfig().onError(new Error("FAILED TO VERIFY CACHED DATA, deleting stale '"+t+"' now, but a RESTART IS REQUIRED")),m._fs.unlink(t,function(y){y&&h.getConfig().onError(y)}))},Math.ceil(5e3*(1+Math.random())))},o._BOM=65279,o._PREFIX="(function (require, define, __filename, __dirname) { ",o._SUFFIX=`
});`,o}();function p(o,f){if(f.__$__isRecorded)return f;var S=function(w){o.record(33,w);try{return f(w)}finally{o.record(34,w)}};return S.__$__isRecorded=!0,S}T.ensureRecordedNodeRequire=p;function C(o){return new r(o)}T.createScriptLoader=C})(se||(se={}));var se;(function(T){var r=function(){function C(o){var f=o.lastIndexOf("/");f!==-1?this.fromModulePath=o.substr(0,f+1):this.fromModulePath=""}return C._normalizeModuleId=function(o){var f=o,S;for(S=/\/\.\//;S.test(f);)f=f.replace(S,"/");for(f=f.replace(/^\.\//g,""),S=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;S.test(f);)f=f.replace(S,"/");return f=f.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),f},C.prototype.resolveModule=function(o){var f=o;return T.Utilities.isAbsolutePath(f)||(T.Utilities.startsWith(f,"./")||T.Utilities.startsWith(f,"../"))&&(f=C._normalizeModuleId(this.fromModulePath+f)),f},C.ROOT=new C(""),C}();T.ModuleIdResolver=r;var A=function(){function C(o,f,S,t,w,h){this.id=o,this.strId=f,this.dependencies=S,this._callback=t,this._errorback=w,this.moduleIdResolver=h,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}return C._safeInvokeFunction=function(o,f){try{return{returnedValue:o.apply(T.global,f),producedError:null}}catch(S){return{returnedValue:null,producedError:S}}},C._invokeFactory=function(o,f,S,t){return o.shouldInvokeFactory(f)?o.shouldCatchError()?this._safeInvokeFunction(S,t):{returnedValue:S.apply(T.global,t),producedError:null}:{returnedValue:null,producedError:null}},C.prototype.complete=function(o,f,S,t){this._isComplete=!0;var w=null;if(this._callback)if(typeof this._callback=="function"){o.record(21,this.strId);var h=C._invokeFactory(f,this.strId,this._callback,S);w=h.producedError,o.record(22,this.strId),!w&&typeof h.returnedValue<"u"&&(!this.exportsPassedIn||T.Utilities.isEmpty(this.exports))&&(this.exports=h.returnedValue)}else this.exports=this._callback;if(w){var m=T.ensureError(w);m.phase="factory",m.moduleId=this.strId,m.neededBy=t(this.id),this.error=m,f.onError(m)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null},C.prototype.onDependencyError=function(o){return this._isComplete=!0,this.error=o,this._errorback?(this._errorback(o),!0):!1},C.prototype.isComplete=function(){return this._isComplete},C}();T.Module=A;var e=function(){function C(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}return C.prototype.getMaxModuleId=function(){return this._nextId},C.prototype.getModuleId=function(o){var f=this._strModuleIdToIntModuleId.get(o);return typeof f>"u"&&(f=this._nextId++,this._strModuleIdToIntModuleId.set(o,f),this._intModuleIdToStrModuleId[f]=o),f},C.prototype.getStrModuleId=function(o){return this._intModuleIdToStrModuleId[o]},C}(),E=function(){function C(o){this.id=o}return C.EXPORTS=new C(0),C.MODULE=new C(1),C.REQUIRE=new C(2),C}();T.RegularDependency=E;var l=function(){function C(o,f,S){this.id=o,this.pluginId=f,this.pluginParam=S}return C}();T.PluginDependency=l;var p=function(){function C(o,f,S,t,w){w===void 0&&(w=0),this._env=o,this._scriptLoader=f,this._loaderAvailableTimestamp=w,this._defineFunc=S,this._requireFunc=t,this._moduleIdProvider=new e,this._config=new T.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[]}return C.prototype.reset=function(){return new C(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)},C.prototype.getGlobalAMDDefineFunc=function(){return this._defineFunc},C.prototype.getGlobalAMDRequireFunc=function(){return this._requireFunc},C._findRelevantLocationInStack=function(o,f){for(var S=function(u){return u.replace(/\\/g,"/")},t=S(o),w=f.split(/\n/),h=0;h<w.length;h++){var m=w[h].match(/(.*):(\d+):(\d+)\)?$/);if(m){var L=m[1],y=m[2],_=m[3],g=Math.max(L.lastIndexOf(" ")+1,L.lastIndexOf("(")+1);if(L=L.substr(g),L=S(L),L===t){var v={line:parseInt(y,10),col:parseInt(_,10)};return v.line===1&&(v.col-=53),v}}}throw new Error("Could not correlate define call site for needle "+o)},C.prototype.getBuildInfo=function(){if(!this._config.isBuild())return null;for(var o=[],f=0,S=0,t=this._modules2.length;S<t;S++){var w=this._modules2[S];if(!!w){var h=this._buildInfoPath[w.id]||null,m=this._buildInfoDefineStack[w.id]||null,L=this._buildInfoDependencies[w.id];o[f++]={id:w.strId,path:h,defineLocation:h&&m?C._findRelevantLocationInStack(h,m):null,dependencies:L,shim:null,exports:w.exports}}}return o},C.prototype.getRecorder=function(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new T.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=T.NullLoaderEventRecorder.INSTANCE),this._recorder},C.prototype.getLoaderEvents=function(){return this.getRecorder().getEvents()},C.prototype.enqueueDefineAnonymousModule=function(o,f){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");var S=null;this._config.isBuild()&&(S=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:S,dependencies:o,callback:f}},C.prototype.defineModule=function(o,f,S,t,w,h){var m=this;h===void 0&&(h=new r(o));var L=this._moduleIdProvider.getModuleId(o);if(this._modules2[L]){this._config.isDuplicateMessageIgnoredFor(o)||console.warn("Duplicate definition of module '"+o+"'");return}var y=new A(L,o,this._normalizeDependencies(f,h),S,t,h);this._modules2[L]=y,this._config.isBuild()&&(this._buildInfoDefineStack[L]=w,this._buildInfoDependencies[L]=(y.dependencies||[]).map(function(_){return m._moduleIdProvider.getStrModuleId(_.id)})),this._resolve(y)},C.prototype._normalizeDependency=function(o,f){if(o==="exports")return E.EXPORTS;if(o==="module")return E.MODULE;if(o==="require")return E.REQUIRE;var S=o.indexOf("!");if(S>=0){var t=f.resolveModule(o.substr(0,S)),w=f.resolveModule(o.substr(S+1)),h=this._moduleIdProvider.getModuleId(t+"!"+w),m=this._moduleIdProvider.getModuleId(t);return new l(h,m,w)}return new E(this._moduleIdProvider.getModuleId(f.resolveModule(o)))},C.prototype._normalizeDependencies=function(o,f){for(var S=[],t=0,w=0,h=o.length;w<h;w++)S[t++]=this._normalizeDependency(o[w],f);return S},C.prototype._relativeRequire=function(o,f,S,t){if(typeof f=="string")return this.synchronousRequire(f,o);this.defineModule(T.Utilities.generateAnonymousModule(),f,S,t,null,o)},C.prototype.synchronousRequire=function(o,f){f===void 0&&(f=new r(o));var S=this._normalizeDependency(o,f),t=this._modules2[S.id];if(!t)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+o+"'. This is the first mention of this module!");if(!t.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+o+"'. This module has not been resolved completely yet.");if(t.error)throw t.error;return t.exports},C.prototype.configure=function(o,f){var S=this._config.shouldRecordStats();f?this._config=new T.Configuration(this._env,o):this._config=this._config.cloneAndMerge(o),this._config.shouldRecordStats()&&!S&&(this._recorder=null)},C.prototype.getConfig=function(){return this._config},C.prototype._onLoad=function(o){if(this._currentAnonymousDefineCall!==null){var f=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(o),f.dependencies,f.callback,null,f.stack)}},C.prototype._createLoadError=function(o,f){var S=this,t=this._moduleIdProvider.getStrModuleId(o),w=(this._inverseDependencies2[o]||[]).map(function(m){return S._moduleIdProvider.getStrModuleId(m)}),h=T.ensureError(f);return h.phase="loading",h.moduleId=t,h.neededBy=w,h},C.prototype._onLoadError=function(o,f){var S=this._createLoadError(o,f);this._modules2[o]||(this._modules2[o]=new A(o,this._moduleIdProvider.getStrModuleId(o),[],function(){},null,null));for(var t=[],w=0,h=this._moduleIdProvider.getMaxModuleId();w<h;w++)t[w]=!1;var m=!1,L=[];for(L.push(o),t[o]=!0;L.length>0;){var y=L.shift(),_=this._modules2[y];_&&(m=_.onDependencyError(S)||m);var g=this._inverseDependencies2[y];if(g)for(var w=0,h=g.length;w<h;w++){var v=g[w];t[v]||(L.push(v),t[v]=!0)}}m||this._config.onError(S)},C.prototype._hasDependencyPath=function(o,f){var S=this._modules2[o];if(!S)return!1;for(var t=[],w=0,h=this._moduleIdProvider.getMaxModuleId();w<h;w++)t[w]=!1;var m=[];for(m.push(S),t[o]=!0;m.length>0;){var L=m.shift(),y=L.dependencies;if(y)for(var w=0,h=y.length;w<h;w++){var _=y[w];if(_.id===f)return!0;var g=this._modules2[_.id];g&&!t[_.id]&&(t[_.id]=!0,m.push(g))}}return!1},C.prototype._findCyclePath=function(o,f,S){if(o===f||S===50)return[o];var t=this._modules2[o];if(!t)return null;var w=t.dependencies;if(w)for(var h=0,m=w.length;h<m;h++){var L=this._findCyclePath(w[h].id,f,S+1);if(L!==null)return L.push(o),L}return null},C.prototype._createRequire=function(o){var f=this,S=function(t,w,h){return f._relativeRequire(o,t,w,h)};return S.toUrl=function(t){return f._config.requireToUrl(o.resolveModule(t))},S.getStats=function(){return f.getLoaderEvents()},S.hasDependencyCycle=function(){return f._hasDependencyCycle},S.config=function(t,w){w===void 0&&(w=!1),f.configure(t,w)},S.__$__nodeRequire=T.global.nodeRequire,S},C.prototype._loadModule=function(o){var f=this;if(!(this._modules2[o]||this._knownModules2[o])){this._knownModules2[o]=!0;var S=this._moduleIdProvider.getStrModuleId(o),t=this._config.moduleIdToPaths(S),w=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(S.indexOf("/")===-1||w.test(S))&&t.push("node|"+S);var h=-1,m=function(L){if(h++,h>=t.length)f._onLoadError(o,L);else{var y=t[h],_=f.getRecorder();if(f._config.isBuild()&&y==="empty:"){f._buildInfoPath[o]=y,f.defineModule(f._moduleIdProvider.getStrModuleId(o),[],null,null,null),f._onLoad(o);return}_.record(10,y),f._scriptLoader.load(f,y,function(){f._config.isBuild()&&(f._buildInfoPath[o]=y),_.record(11,y),f._onLoad(o)},function(g){_.record(12,y),m(g)})}};m(null)}},C.prototype._loadPluginDependency=function(o,f){var S=this;if(!(this._modules2[f.id]||this._knownModules2[f.id])){this._knownModules2[f.id]=!0;var t=function(w){S.defineModule(S._moduleIdProvider.getStrModuleId(f.id),[],w,null,null)};t.error=function(w){S._config.onError(S._createLoadError(f.id,w))},o.load(f.pluginParam,this._createRequire(r.ROOT),t,this._config.getOptionsLiteral())}},C.prototype._resolve=function(o){var f=this,S=o.dependencies;if(S)for(var t=0,w=S.length;t<w;t++){var h=S[t];if(h===E.EXPORTS){o.exportsPassedIn=!0,o.unresolvedDependenciesCount--;continue}if(h===E.MODULE){o.unresolvedDependenciesCount--;continue}if(h===E.REQUIRE){o.unresolvedDependenciesCount--;continue}var m=this._modules2[h.id];if(m&&m.isComplete()){if(m.error){o.onDependencyError(m.error);return}o.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(h.id,o.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(h.id)+"' and '"+this._moduleIdProvider.getStrModuleId(o.id)+"'. The cyclic path follows:");var L=this._findCyclePath(h.id,o.id,0)||[];L.reverse(),L.push(h.id),console.warn(L.map(function(g){return f._moduleIdProvider.getStrModuleId(g)}).join(` => 
`)),o.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[h.id]=this._inverseDependencies2[h.id]||[],this._inverseDependencies2[h.id].push(o.id),h instanceof l){var y=this._modules2[h.pluginId];if(y&&y.isComplete()){this._loadPluginDependency(y.exports,h);continue}var _=this._inversePluginDependencies2.get(h.pluginId);_||(_=[],this._inversePluginDependencies2.set(h.pluginId,_)),_.push(h),this._loadModule(h.pluginId);continue}this._loadModule(h.id)}o.unresolvedDependenciesCount===0&&this._onModuleComplete(o)},C.prototype._onModuleComplete=function(o){var f=this,S=this.getRecorder();if(!o.isComplete()){var t=o.dependencies,w=[];if(t)for(var h=0,m=t.length;h<m;h++){var L=t[h];if(L===E.EXPORTS){w[h]=o.exports;continue}if(L===E.MODULE){w[h]={id:o.strId,config:function(){return f._config.getConfigForModule(o.strId)}};continue}if(L===E.REQUIRE){w[h]=this._createRequire(o.moduleIdResolver);continue}var y=this._modules2[L.id];if(y){w[h]=y.exports;continue}w[h]=null}var _=function(s){return(f._inverseDependencies2[s]||[]).map(function(a){return f._moduleIdProvider.getStrModuleId(a)})};o.complete(S,this._config,w,_);var g=this._inverseDependencies2[o.id];if(this._inverseDependencies2[o.id]=null,g)for(var h=0,m=g.length;h<m;h++){var v=g[h],u=this._modules2[v];u.unresolvedDependenciesCount--,u.unresolvedDependenciesCount===0&&this._onModuleComplete(u)}var d=this._inversePluginDependencies2.get(o.id);if(d){this._inversePluginDependencies2.delete(o.id);for(var h=0,m=d.length;h<m;h++)this._loadPluginDependency(o.exports,d[h])}}},C}();T.ModuleManager=p})(se||(se={}));var X,se;(function(T){var r=new T.Environment,A=null,e=function(C,o,f){typeof C!="string"&&(f=o,o=C,C=null),(typeof o!="object"||!Array.isArray(o))&&(f=o,o=null),o||(o=["require","exports","module"]),C?A.defineModule(C,o,f,null,null):A.enqueueDefineAnonymousModule(o,f)};e.amd={jQuery:!0};var E=function(C,o){o===void 0&&(o=!1),A.configure(C,o)},l=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){E(arguments[0]);return}if(typeof arguments[0]=="string")return A.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){A.defineModule(T.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};l.config=E,l.getConfig=function(){return A.getConfig().getOptionsLiteral()},l.reset=function(){A=A.reset()},l.getBuildInfo=function(){return A.getBuildInfo()},l.getStats=function(){return A.getLoaderEvents()},l.define=e;function p(){if(typeof T.global.require<"u"||typeof require<"u"){var C=T.global.require||require;if(typeof C=="function"&&typeof C.resolve=="function"){var o=T.ensureRecordedNodeRequire(A.getRecorder(),C);T.global.nodeRequire=o,l.nodeRequire=o,l.__$__nodeRequire=o}}r.isNode&&!r.isElectronRenderer&&!r.isElectronNodeIntegrationWebWorker?module.exports=l:(r.isElectronRenderer||(T.global.define=e),T.global.require=l)}T.init=p,(typeof T.global.define!="function"||!T.global.define.amd)&&(A=new T.ModuleManager(r,T.createScriptLoader(r),e,l,T.Utilities.getHighPerformanceTimestamp()),typeof T.global.require<"u"&&typeof T.global.require!="function"&&l.config(T.global.require),X=function(){return e.apply(null,arguments)},X.amd=e.amd,typeof doNotInitLoader>"u"&&p())})(se||(se={}));var ue=this&&this.__awaiter||function(T,r,A,e){function E(l){return l instanceof A?l:new A(function(p){p(l)})}return new(A||(A=Promise))(function(l,p){function C(S){try{f(e.next(S))}catch(t){p(t)}}function o(S){try{f(e.throw(S))}catch(t){p(t)}}function f(S){S.done?l(S.value):E(S.value).then(C,o)}f((e=e.apply(T,r||[])).next())})};X(Q[21],J([0,1]),function(T,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.load=r.create=r.setPseudoTranslation=r.getConfiguredDefaultLocale=r.localize=void 0;let A=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const e="i-default";function E(m,L){let y;return L.length===0?y=m:y=m.replace(/\{(\d+)\}/g,(_,g)=>{const v=g[0],u=L[v];let d=_;return typeof u=="string"?d=u:(typeof u=="number"||typeof u=="boolean"||u===void 0||u===null)&&(d=String(u)),d}),A&&(y="\uFF3B"+y.replace(/[aouei]/g,"$&$&")+"\uFF3D"),y}function l(m,L){let y=m[L];return y||(y=m["*"],y)?y:null}function p(m){return m.charAt(m.length-1)==="/"?m:m+"/"}function C(m,L,y){return ue(this,void 0,void 0,function*(){const _=p(m)+p(L)+"vscode/"+p(y),g=yield fetch(_);if(g.ok)return yield g.json();throw new Error(`${g.status} - ${g.statusText}`)})}function o(m){return function(L,y){const _=Array.prototype.slice.call(arguments,2);return E(m[L],_)}}function f(m,L,...y){return E(L,y)}r.localize=f;function S(m){}r.getConfiguredDefaultLocale=S;function t(m){A=m}r.setPseudoTranslation=t;function w(m,L){var y;return{localize:o(L[m]),getConfiguredDefaultLocale:(y=L.getConfiguredDefaultLocale)!==null&&y!==void 0?y:_=>{}}}r.create=w;function h(m,L,y,_){var g;const v=(g=_["vs/nls"])!==null&&g!==void 0?g:{};if(!m||m.length===0)return y({localize:f,getConfiguredDefaultLocale:()=>{var i;return(i=v.availableLanguages)===null||i===void 0?void 0:i["*"]}});const u=v.availableLanguages?l(v.availableLanguages,m):null,d=u===null||u===e;let s=".nls";d||(s=s+"."+u);const a=i=>{Array.isArray(i)?i.localize=o(i):i.localize=o(i[m]),i.getConfiguredDefaultLocale=()=>{var c;return(c=v.availableLanguages)===null||c===void 0?void 0:c["*"]},y(i)};typeof v.loadBundle=="function"?v.loadBundle(m,u,(i,c)=>{i?L([m+".nls"],a):a(c)}):v.translationServiceUrl&&!d?ue(this,void 0,void 0,function*(){var i;try{const c=yield C(v.translationServiceUrl,u,m);return a(c)}catch(c){if(!u.includes("-"))return console.error(c),L([m+".nls"],a);try{const b=u.split("-")[0],N=yield C(v.translationServiceUrl,b,m);return(i=v.availableLanguages)!==null&&i!==void 0||(v.availableLanguages={}),v.availableLanguages["*"]=b,a(N)}catch(b){return console.error(b),L([m+".nls"],a)}}}):L([m+s],a,i=>{if(s===".nls"){console.error("Failed trying to load default language strings",i);return}console.error(`Failed to load message bundle for language ${u}. Falling back to the default language:`,i),L([m+".nls"],a)})}r.load=h}),function(){var T,r;const A=self.MonacoEnvironment,e=A&&A.baseUrl?A.baseUrl:"../../../",E=typeof((T=self.trustedTypes)===null||T===void 0?void 0:T.createPolicy)=="function"?(r=self.trustedTypes)===null||r===void 0?void 0:r.createPolicy("amdLoader",{createScriptURL:t=>t,createScript:(t,...w)=>{const h=w.slice(0,-1).join(","),m=w.pop().toString();return`(function anonymous(${h}) { ${m}
})`}}):void 0;function l(){try{return(E?self.eval(E.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}function p(){return new Promise((t,w)=>{if(typeof self.define=="function"&&self.define.amd)return t();const h=e+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(h)&&h.substring(0,self.origin.length)!==self.origin)&&l()){fetch(h).then(L=>{if(L.status!==200)throw new Error(L.statusText);return L.text()}).then(L=>{L=`${L}
//# sourceURL=${h}`,(E?self.eval(E.createScript("",L)):new Function(L)).call(self),t()}).then(void 0,w);return}E?importScripts(E.createScriptURL(h)):importScripts(h),t()})}function C(){require.config({baseUrl:e,catchError:!0,trustedTypesPolicy:E,amdModulesPattern:/^vs\//})}function o(t){p().then(()=>{C(),require([t],function(w){setTimeout(function(){const h=w.create((m,L)=>{self.postMessage(m,L)},null);for(self.onmessage=m=>h.onmessage(m.data,m.ports);S.length>0;)self.onmessage(S.shift())},0)})})}typeof self.define=="function"&&self.define.amd&&C();let f=!0;const S=[];self.onmessage=t=>{if(!f){S.push(t);return}f=!1,o(t.data)}}(),X(Q[22],J([0,1]),function(T,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.CallbackIterable=r.ArrayQueue=r.findMinBy=r.findLastMaxBy=r.findMaxBy=r.numberComparator=r.compareBy=r.CompareResult=r.splice=r.insertInto=r.asArray=r.pushMany=r.pushToEnd=r.pushToStart=r.arrayInsert=r.range=r.firstOrDefault=r.lastIndex=r.findLast=r.distinct=r.isNonEmptyArray=r.isFalsyOrEmpty=r.coalesceInPlace=r.coalesce=r.groupBy=r.quickSelect=r.findFirstInSorted=r.binarySearch2=r.binarySearch=r.removeFastWithoutKeepingOrder=r.equals=r.tail2=r.tail=void 0;function A(k,U=0){return k[k.length-(1+U)]}r.tail=A;function e(k){if(k.length===0)throw new Error("Invalid tail call");return[k.slice(0,k.length-1),k[k.length-1]]}r.tail2=e;function E(k,U,F=(V,n)=>V===n){if(k===U)return!0;if(!k||!U||k.length!==U.length)return!1;for(let V=0,n=k.length;V<n;V++)if(!F(k[V],U[V]))return!1;return!0}r.equals=E;function l(k,U){const F=k.length-1;U<F&&(k[U]=k[F]),k.pop()}r.removeFastWithoutKeepingOrder=l;function p(k,U,F){return C(k.length,V=>F(k[V],U))}r.binarySearch=p;function C(k,U){let F=0,V=k-1;for(;F<=V;){const n=(F+V)/2|0,ae=U(n);if(ae<0)F=n+1;else if(ae>0)V=n-1;else return n}return-(F+1)}r.binarySearch2=C;function o(k,U){let F=0,V=k.length;if(V===0)return 0;for(;F<V;){const n=Math.floor((F+V)/2);U(k[n])?V=n:F=n+1}return F}r.findFirstInSorted=o;function f(k,U,F){if(k=k|0,k>=U.length)throw new TypeError("invalid index");const V=U[Math.floor(U.length*Math.random())],n=[],ae=[],oe=[];for(const he of U){const we=F(he,V);we<0?n.push(he):we>0?ae.push(he):oe.push(he)}return k<n.length?f(k,n,F):k<n.length+oe.length?oe[0]:f(k-(n.length+oe.length),ae,F)}r.quickSelect=f;function S(k,U){const F=[];let V;for(const n of k.slice(0).sort(U))!V||U(V[0],n)!==0?(V=[n],F.push(V)):V.push(n);return F}r.groupBy=S;function t(k){return k.filter(U=>!!U)}r.coalesce=t;function w(k){let U=0;for(let F=0;F<k.length;F++)k[F]&&(k[U]=k[F],U+=1);k.length=U}r.coalesceInPlace=w;function h(k){return!Array.isArray(k)||k.length===0}r.isFalsyOrEmpty=h;function m(k){return Array.isArray(k)&&k.length>0}r.isNonEmptyArray=m;function L(k,U=F=>F){const F=new Set;return k.filter(V=>{const n=U(V);return F.has(n)?!1:(F.add(n),!0)})}r.distinct=L;function y(k,U){const F=_(k,U);if(F!==-1)return k[F]}r.findLast=y;function _(k,U){for(let F=k.length-1;F>=0;F--){const V=k[F];if(U(V))return F}return-1}r.lastIndex=_;function g(k,U){return k.length>0?k[0]:U}r.firstOrDefault=g;function v(k,U){let F=typeof U=="number"?k:0;typeof U=="number"?F=k:(F=0,U=k);const V=[];if(F<=U)for(let n=F;n<U;n++)V.push(n);else for(let n=F;n>U;n--)V.push(n);return V}r.range=v;function u(k,U,F){const V=k.slice(0,U),n=k.slice(U);return V.concat(F,n)}r.arrayInsert=u;function d(k,U){const F=k.indexOf(U);F>-1&&(k.splice(F,1),k.unshift(U))}r.pushToStart=d;function s(k,U){const F=k.indexOf(U);F>-1&&(k.splice(F,1),k.push(U))}r.pushToEnd=s;function a(k,U){for(const F of U)k.push(F)}r.pushMany=a;function i(k){return Array.isArray(k)?k:[k]}r.asArray=i;function c(k,U,F){const V=N(k,U),n=k.length,ae=F.length;k.length=n+ae;for(let oe=n-1;oe>=V;oe--)k[oe+ae]=k[oe];for(let oe=0;oe<ae;oe++)k[oe+V]=F[oe]}r.insertInto=c;function b(k,U,F,V){const n=N(k,U),ae=k.splice(n,F);return c(k,n,V),ae}r.splice=b;function N(k,U){return U<0?Math.max(U+k.length,0):Math.min(U,k.length)}var M;(function(k){function U(n){return n<0}k.isLessThan=U;function F(n){return n>0}k.isGreaterThan=F;function V(n){return n===0}k.isNeitherLessOrGreaterThan=V,k.greaterThan=1,k.lessThan=-1,k.neitherLessOrGreaterThan=0})(M=r.CompareResult||(r.CompareResult={}));function R(k,U){return(F,V)=>U(k(F),k(V))}r.compareBy=R;const P=(k,U)=>k-U;r.numberComparator=P;function I(k,U){if(k.length===0)return;let F=k[0];for(let V=1;V<k.length;V++){const n=k[V];U(n,F)>0&&(F=n)}return F}r.findMaxBy=I;function W(k,U){if(k.length===0)return;let F=k[0];for(let V=1;V<k.length;V++){const n=k[V];U(n,F)>=0&&(F=n)}return F}r.findLastMaxBy=W;function O(k,U){return I(k,(F,V)=>-U(F,V))}r.findMinBy=O;class q{constructor(U){this.f=U,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(U){let F=this.c;for(;F<this.f.length&&U(this.f[F]);)F++;const V=F===this.c?null:this.f.slice(this.c,F);return this.c=F,V}takeFromEndWhile(U){let F=this.d;for(;F>=0&&U(this.f[F]);)F--;const V=F===this.d?null:this.f.slice(F+1,this.d+1);return this.d=F,V}peek(){if(this.length!==0)return this.f[this.c]}dequeue(){const U=this.f[this.c];return this.c++,U}takeCount(U){const F=this.f.slice(this.c,this.c+U);return this.c+=U,F}}r.ArrayQueue=q;class Y{constructor(U){this.iterate=U}toArray(){const U=[];return this.iterate(F=>(U.push(F),!0)),U}filter(U){return new Y(F=>this.iterate(V=>U(V)?F(V):!0))}map(U){return new Y(F=>this.iterate(V=>F(U(V))))}findLast(U){let F;return this.iterate(V=>(U(V)&&(F=V),!0)),F}findLastMaxBy(U){let F,V=!0;return this.iterate(n=>((V||M.isGreaterThan(U(n,F)))&&(V=!1,F=n),!0)),F}}r.CallbackIterable=Y,Y.empty=new Y(k=>{})}),X(Q[23],J([0,1]),function(T,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.CachedFunction=r.LRUCachedFunction=void 0;class A{constructor(l){this.c=l,this.a=void 0,this.b=void 0}get(l){const p=JSON.stringify(l);return this.b!==p&&(this.b=p,this.a=this.c(l)),this.a}}r.LRUCachedFunction=A;class e{get cachedValues(){return this.a}constructor(l){this.b=l,this.a=new Map}get(l){if(this.a.has(l))return this.a.get(l);const p=this.b(l);return this.a.set(l,p),p}}r.CachedFunction=e}),X(Q[24],J([0,1]),function(T,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.CSSIcon=r.Codicon=r.getCodiconAriaLabel=void 0;function A(l){return l?l.replace(/\$\((.*?)\)/g,(p,C)=>` ${C} `).trim():""}r.getCodiconAriaLabel=A;class e{constructor(p,C,o){this.id=p,this.definition=C,this.description=o,e.a.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return e.a}}r.Codicon=e,e.a=[],e.add=new e("add",{fontCharacter:"\\ea60"}),e.plus=new e("plus",e.add.definition),e.gistNew=new e("gist-new",e.add.definition),e.repoCreate=new e("repo-create",e.add.definition),e.lightbulb=new e("lightbulb",{fontCharacter:"\\ea61"}),e.lightBulb=new e("light-bulb",{fontCharacter:"\\ea61"}),e.repo=new e("repo",{fontCharacter:"\\ea62"}),e.repoDelete=new e("repo-delete",{fontCharacter:"\\ea62"}),e.gistFork=new e("gist-fork",{fontCharacter:"\\ea63"}),e.repoForked=new e("repo-forked",{fontCharacter:"\\ea63"}),e.gitPullRequest=new e("git-pull-request",{fontCharacter:"\\ea64"}),e.gitPullRequestAbandoned=new e("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),e.recordKeys=new e("record-keys",{fontCharacter:"\\ea65"}),e.keyboard=new e("keyboard",{fontCharacter:"\\ea65"}),e.tag=new e("tag",{fontCharacter:"\\ea66"}),e.tagAdd=new e("tag-add",{fontCharacter:"\\ea66"}),e.tagRemove=new e("tag-remove",{fontCharacter:"\\ea66"}),e.person=new e("person",{fontCharacter:"\\ea67"}),e.personFollow=new e("person-follow",{fontCharacter:"\\ea67"}),e.personOutline=new e("person-outline",{fontCharacter:"\\ea67"}),e.personFilled=new e("person-filled",{fontCharacter:"\\ea67"}),e.gitBranch=new e("git-branch",{fontCharacter:"\\ea68"}),e.gitBranchCreate=new e("git-branch-create",{fontCharacter:"\\ea68"}),e.gitBranchDelete=new e("git-branch-delete",{fontCharacter:"\\ea68"}),e.sourceControl=new e("source-control",{fontCharacter:"\\ea68"}),e.mirror=new e("mirror",{fontCharacter:"\\ea69"}),e.mirrorPublic=new e("mirror-public",{fontCharacter:"\\ea69"}),e.star=new e("star",{fontCharacter:"\\ea6a"}),e.starAdd=new e("star-add",{fontCharacter:"\\ea6a"}),e.starDelete=new e("star-delete",{fontCharacter:"\\ea6a"}),e.starEmpty=new e("star-empty",{fontCharacter:"\\ea6a"}),e.comment=new e("comment",{fontCharacter:"\\ea6b"}),e.commentAdd=new e("comment-add",{fontCharacter:"\\ea6b"}),e.alert=new e("alert",{fontCharacter:"\\ea6c"}),e.warning=new e("warning",{fontCharacter:"\\ea6c"}),e.search=new e("search",{fontCharacter:"\\ea6d"}),e.searchSave=new e("search-save",{fontCharacter:"\\ea6d"}),e.logOut=new e("log-out",{fontCharacter:"\\ea6e"}),e.signOut=new e("sign-out",{fontCharacter:"\\ea6e"}),e.logIn=new e("log-in",{fontCharacter:"\\ea6f"}),e.signIn=new e("sign-in",{fontCharacter:"\\ea6f"}),e.eye=new e("eye",{fontCharacter:"\\ea70"}),e.eyeUnwatch=new e("eye-unwatch",{fontCharacter:"\\ea70"}),e.eyeWatch=new e("eye-watch",{fontCharacter:"\\ea70"}),e.circleFilled=new e("circle-filled",{fontCharacter:"\\ea71"}),e.primitiveDot=new e("primitive-dot",e.circleFilled.definition),e.closeDirty=new e("close-dirty",e.circleFilled.definition),e.debugBreakpoint=new e("debug-breakpoint",e.circleFilled.definition),e.debugBreakpointDisabled=new e("debug-breakpoint-disabled",e.circleFilled.definition),e.debugHint=new e("debug-hint",e.circleFilled.definition),e.primitiveSquare=new e("primitive-square",{fontCharacter:"\\ea72"}),e.edit=new e("edit",{fontCharacter:"\\ea73"}),e.pencil=new e("pencil",{fontCharacter:"\\ea73"}),e.info=new e("info",{fontCharacter:"\\ea74"}),e.issueOpened=new e("issue-opened",{fontCharacter:"\\ea74"}),e.gistPrivate=new e("gist-private",{fontCharacter:"\\ea75"}),e.gitForkPrivate=new e("git-fork-private",{fontCharacter:"\\ea75"}),e.lock=new e("lock",{fontCharacter:"\\ea75"}),e.mirrorPrivate=new e("mirror-private",{fontCharacter:"\\ea75"}),e.close=new e("close",{fontCharacter:"\\ea76"}),e.removeClose=new e("remove-close",{fontCharacter:"\\ea76"}),e.x=new e("x",{fontCharacter:"\\ea76"}),e.repoSync=new e("repo-sync",{fontCharacter:"\\ea77"}),e.sync=new e("sync",{fontCharacter:"\\ea77"}),e.clone=new e("clone",{fontCharacter:"\\ea78"}),e.desktopDownload=new e("desktop-download",{fontCharacter:"\\ea78"}),e.beaker=new e("beaker",{fontCharacter:"\\ea79"}),e.microscope=new e("microscope",{fontCharacter:"\\ea79"}),e.vm=new e("vm",{fontCharacter:"\\ea7a"}),e.deviceDesktop=new e("device-desktop",{fontCharacter:"\\ea7a"}),e.file=new e("file",{fontCharacter:"\\ea7b"}),e.fileText=new e("file-text",{fontCharacter:"\\ea7b"}),e.more=new e("more",{fontCharacter:"\\ea7c"}),e.ellipsis=new e("ellipsis",{fontCharacter:"\\ea7c"}),e.kebabHorizontal=new e("kebab-horizontal",{fontCharacter:"\\ea7c"}),e.mailReply=new e("mail-reply",{fontCharacter:"\\ea7d"}),e.reply=new e("reply",{fontCharacter:"\\ea7d"}),e.organization=new e("organization",{fontCharacter:"\\ea7e"}),e.organizationFilled=new e("organization-filled",{fontCharacter:"\\ea7e"}),e.organizationOutline=new e("organization-outline",{fontCharacter:"\\ea7e"}),e.newFile=new e("new-file",{fontCharacter:"\\ea7f"}),e.fileAdd=new e("file-add",{fontCharacter:"\\ea7f"}),e.newFolder=new e("new-folder",{fontCharacter:"\\ea80"}),e.fileDirectoryCreate=new e("file-directory-create",{fontCharacter:"\\ea80"}),e.trash=new e("trash",{fontCharacter:"\\ea81"}),e.trashcan=new e("trashcan",{fontCharacter:"\\ea81"}),e.history=new e("history",{fontCharacter:"\\ea82"}),e.clock=new e("clock",{fontCharacter:"\\ea82"}),e.folder=new e("folder",{fontCharacter:"\\ea83"}),e.fileDirectory=new e("file-directory",{fontCharacter:"\\ea83"}),e.symbolFolder=new e("symbol-folder",{fontCharacter:"\\ea83"}),e.logoGithub=new e("logo-github",{fontCharacter:"\\ea84"}),e.markGithub=new e("mark-github",{fontCharacter:"\\ea84"}),e.github=new e("github",{fontCharacter:"\\ea84"}),e.terminal=new e("terminal",{fontCharacter:"\\ea85"}),e.console=new e("console",{fontCharacter:"\\ea85"}),e.repl=new e("repl",{fontCharacter:"\\ea85"}),e.zap=new e("zap",{fontCharacter:"\\ea86"}),e.symbolEvent=new e("symbol-event",{fontCharacter:"\\ea86"}),e.error=new e("error",{fontCharacter:"\\ea87"}),e.stop=new e("stop",{fontCharacter:"\\ea87"}),e.variable=new e("variable",{fontCharacter:"\\ea88"}),e.symbolVariable=new e("symbol-variable",{fontCharacter:"\\ea88"}),e.array=new e("array",{fontCharacter:"\\ea8a"}),e.symbolArray=new e("symbol-array",{fontCharacter:"\\ea8a"}),e.symbolModule=new e("symbol-module",{fontCharacter:"\\ea8b"}),e.symbolPackage=new e("symbol-package",{fontCharacter:"\\ea8b"}),e.symbolNamespace=new e("symbol-namespace",{fontCharacter:"\\ea8b"}),e.symbolObject=new e("symbol-object",{fontCharacter:"\\ea8b"}),e.symbolMethod=new e("symbol-method",{fontCharacter:"\\ea8c"}),e.symbolFunction=new e("symbol-function",{fontCharacter:"\\ea8c"}),e.symbolConstructor=new e("symbol-constructor",{fontCharacter:"\\ea8c"}),e.symbolBoolean=new e("symbol-boolean",{fontCharacter:"\\ea8f"}),e.symbolNull=new e("symbol-null",{fontCharacter:"\\ea8f"}),e.symbolNumeric=new e("symbol-numeric",{fontCharacter:"\\ea90"}),e.symbolNumber=new e("symbol-number",{fontCharacter:"\\ea90"}),e.symbolStructure=new e("symbol-structure",{fontCharacter:"\\ea91"}),e.symbolStruct=new e("symbol-struct",{fontCharacter:"\\ea91"}),e.symbolParameter=new e("symbol-parameter",{fontCharacter:"\\ea92"}),e.symbolTypeParameter=new e("symbol-type-parameter",{fontCharacter:"\\ea92"}),e.symbolKey=new e("symbol-key",{fontCharacter:"\\ea93"}),e.symbolText=new e("symbol-text",{fontCharacter:"\\ea93"}),e.symbolReference=new e("symbol-reference",{fontCharacter:"\\ea94"}),e.goToFile=new e("go-to-file",{fontCharacter:"\\ea94"}),e.symbolEnum=new e("symbol-enum",{fontCharacter:"\\ea95"}),e.symbolValue=new e("symbol-value",{fontCharacter:"\\ea95"}),e.symbolRuler=new e("symbol-ruler",{fontCharacter:"\\ea96"}),e.symbolUnit=new e("symbol-unit",{fontCharacter:"\\ea96"}),e.activateBreakpoints=new e("activate-breakpoints",{fontCharacter:"\\ea97"}),e.archive=new e("archive",{fontCharacter:"\\ea98"}),e.arrowBoth=new e("arrow-both",{fontCharacter:"\\ea99"}),e.arrowDown=new e("arrow-down",{fontCharacter:"\\ea9a"}),e.arrowLeft=new e("arrow-left",{fontCharacter:"\\ea9b"}),e.arrowRight=new e("arrow-right",{fontCharacter:"\\ea9c"}),e.arrowSmallDown=new e("arrow-small-down",{fontCharacter:"\\ea9d"}),e.arrowSmallLeft=new e("arrow-small-left",{fontCharacter:"\\ea9e"}),e.arrowSmallRight=new e("arrow-small-right",{fontCharacter:"\\ea9f"}),e.arrowSmallUp=new e("arrow-small-up",{fontCharacter:"\\eaa0"}),e.arrowUp=new e("arrow-up",{fontCharacter:"\\eaa1"}),e.bell=new e("bell",{fontCharacter:"\\eaa2"}),e.bold=new e("bold",{fontCharacter:"\\eaa3"}),e.book=new e("book",{fontCharacter:"\\eaa4"}),e.bookmark=new e("bookmark",{fontCharacter:"\\eaa5"}),e.debugBreakpointConditionalUnverified=new e("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),e.debugBreakpointConditional=new e("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),e.debugBreakpointConditionalDisabled=new e("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),e.debugBreakpointDataUnverified=new e("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),e.debugBreakpointData=new e("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),e.debugBreakpointDataDisabled=new e("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),e.debugBreakpointLogUnverified=new e("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),e.debugBreakpointLog=new e("debug-breakpoint-log",{fontCharacter:"\\eaab"}),e.debugBreakpointLogDisabled=new e("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),e.briefcase=new e("briefcase",{fontCharacter:"\\eaac"}),e.broadcast=new e("broadcast",{fontCharacter:"\\eaad"}),e.browser=new e("browser",{fontCharacter:"\\eaae"}),e.bug=new e("bug",{fontCharacter:"\\eaaf"}),e.calendar=new e("calendar",{fontCharacter:"\\eab0"}),e.caseSensitive=new e("case-sensitive",{fontCharacter:"\\eab1"}),e.check=new e("check",{fontCharacter:"\\eab2"}),e.checklist=new e("checklist",{fontCharacter:"\\eab3"}),e.chevronDown=new e("chevron-down",{fontCharacter:"\\eab4"}),e.dropDownButton=new e("drop-down-button",e.chevronDown.definition),e.chevronLeft=new e("chevron-left",{fontCharacter:"\\eab5"}),e.chevronRight=new e("chevron-right",{fontCharacter:"\\eab6"}),e.chevronUp=new e("chevron-up",{fontCharacter:"\\eab7"}),e.chromeClose=new e("chrome-close",{fontCharacter:"\\eab8"}),e.chromeMaximize=new e("chrome-maximize",{fontCharacter:"\\eab9"}),e.chromeMinimize=new e("chrome-minimize",{fontCharacter:"\\eaba"}),e.chromeRestore=new e("chrome-restore",{fontCharacter:"\\eabb"}),e.circle=new e("circle",{fontCharacter:"\\eabc"}),e.circleOutline=new e("circle-outline",e.circle.definition),e.debugBreakpointUnverified=new e("debug-breakpoint-unverified",e.circle.definition),e.circleSlash=new e("circle-slash",{fontCharacter:"\\eabd"}),e.circuitBoard=new e("circuit-board",{fontCharacter:"\\eabe"}),e.clearAll=new e("clear-all",{fontCharacter:"\\eabf"}),e.clippy=new e("clippy",{fontCharacter:"\\eac0"}),e.closeAll=new e("close-all",{fontCharacter:"\\eac1"}),e.cloudDownload=new e("cloud-download",{fontCharacter:"\\eac2"}),e.cloudUpload=new e("cloud-upload",{fontCharacter:"\\eac3"}),e.code=new e("code",{fontCharacter:"\\eac4"}),e.collapseAll=new e("collapse-all",{fontCharacter:"\\eac5"}),e.colorMode=new e("color-mode",{fontCharacter:"\\eac6"}),e.commentDiscussion=new e("comment-discussion",{fontCharacter:"\\eac7"}),e.compareChanges=new e("compare-changes",{fontCharacter:"\\eafd"}),e.creditCard=new e("credit-card",{fontCharacter:"\\eac9"}),e.dash=new e("dash",{fontCharacter:"\\eacc"}),e.dashboard=new e("dashboard",{fontCharacter:"\\eacd"}),e.database=new e("database",{fontCharacter:"\\eace"}),e.debugContinue=new e("debug-continue",{fontCharacter:"\\eacf"}),e.debugDisconnect=new e("debug-disconnect",{fontCharacter:"\\ead0"}),e.debugPause=new e("debug-pause",{fontCharacter:"\\ead1"}),e.debugRestart=new e("debug-restart",{fontCharacter:"\\ead2"}),e.debugStart=new e("debug-start",{fontCharacter:"\\ead3"}),e.debugStepInto=new e("debug-step-into",{fontCharacter:"\\ead4"}),e.debugStepOut=new e("debug-step-out",{fontCharacter:"\\ead5"}),e.debugStepOver=new e("debug-step-over",{fontCharacter:"\\ead6"}),e.debugStop=new e("debug-stop",{fontCharacter:"\\ead7"}),e.debug=new e("debug",{fontCharacter:"\\ead8"}),e.deviceCameraVideo=new e("device-camera-video",{fontCharacter:"\\ead9"}),e.deviceCamera=new e("device-camera",{fontCharacter:"\\eada"}),e.deviceMobile=new e("device-mobile",{fontCharacter:"\\eadb"}),e.diffAdded=new e("diff-added",{fontCharacter:"\\eadc"}),e.diffIgnored=new e("diff-ignored",{fontCharacter:"\\eadd"}),e.diffModified=new e("diff-modified",{fontCharacter:"\\eade"}),e.diffRemoved=new e("diff-removed",{fontCharacter:"\\eadf"}),e.diffRenamed=new e("diff-renamed",{fontCharacter:"\\eae0"}),e.diff=new e("diff",{fontCharacter:"\\eae1"}),e.discard=new e("discard",{fontCharacter:"\\eae2"}),e.editorLayout=new e("editor-layout",{fontCharacter:"\\eae3"}),e.emptyWindow=new e("empty-window",{fontCharacter:"\\eae4"}),e.exclude=new e("exclude",{fontCharacter:"\\eae5"}),e.extensions=new e("extensions",{fontCharacter:"\\eae6"}),e.eyeClosed=new e("eye-closed",{fontCharacter:"\\eae7"}),e.fileBinary=new e("file-binary",{fontCharacter:"\\eae8"}),e.fileCode=new e("file-code",{fontCharacter:"\\eae9"}),e.fileMedia=new e("file-media",{fontCharacter:"\\eaea"}),e.filePdf=new e("file-pdf",{fontCharacter:"\\eaeb"}),e.fileSubmodule=new e("file-submodule",{fontCharacter:"\\eaec"}),e.fileSymlinkDirectory=new e("file-symlink-directory",{fontCharacter:"\\eaed"}),e.fileSymlinkFile=new e("file-symlink-file",{fontCharacter:"\\eaee"}),e.fileZip=new e("file-zip",{fontCharacter:"\\eaef"}),e.files=new e("files",{fontCharacter:"\\eaf0"}),e.filter=new e("filter",{fontCharacter:"\\eaf1"}),e.flame=new e("flame",{fontCharacter:"\\eaf2"}),e.foldDown=new e("fold-down",{fontCharacter:"\\eaf3"}),e.foldUp=new e("fold-up",{fontCharacter:"\\eaf4"}),e.fold=new e("fold",{fontCharacter:"\\eaf5"}),e.folderActive=new e("folder-active",{fontCharacter:"\\eaf6"}),e.folderOpened=new e("folder-opened",{fontCharacter:"\\eaf7"}),e.gear=new e("gear",{fontCharacter:"\\eaf8"}),e.gift=new e("gift",{fontCharacter:"\\eaf9"}),e.gistSecret=new e("gist-secret",{fontCharacter:"\\eafa"}),e.gist=new e("gist",{fontCharacter:"\\eafb"}),e.gitCommit=new e("git-commit",{fontCharacter:"\\eafc"}),e.gitCompare=new e("git-compare",{fontCharacter:"\\eafd"}),e.gitMerge=new e("git-merge",{fontCharacter:"\\eafe"}),e.githubAction=new e("github-action",{fontCharacter:"\\eaff"}),e.githubAlt=new e("github-alt",{fontCharacter:"\\eb00"}),e.globe=new e("globe",{fontCharacter:"\\eb01"}),e.grabber=new e("grabber",{fontCharacter:"\\eb02"}),e.graph=new e("graph",{fontCharacter:"\\eb03"}),e.gripper=new e("gripper",{fontCharacter:"\\eb04"}),e.heart=new e("heart",{fontCharacter:"\\eb05"}),e.home=new e("home",{fontCharacter:"\\eb06"}),e.horizontalRule=new e("horizontal-rule",{fontCharacter:"\\eb07"}),e.hubot=new e("hubot",{fontCharacter:"\\eb08"}),e.inbox=new e("inbox",{fontCharacter:"\\eb09"}),e.issueClosed=new e("issue-closed",{fontCharacter:"\\eba4"}),e.issueReopened=new e("issue-reopened",{fontCharacter:"\\eb0b"}),e.issues=new e("issues",{fontCharacter:"\\eb0c"}),e.italic=new e("italic",{fontCharacter:"\\eb0d"}),e.jersey=new e("jersey",{fontCharacter:"\\eb0e"}),e.json=new e("json",{fontCharacter:"\\eb0f"}),e.kebabVertical=new e("kebab-vertical",{fontCharacter:"\\eb10"}),e.key=new e("key",{fontCharacter:"\\eb11"}),e.law=new e("law",{fontCharacter:"\\eb12"}),e.lightbulbAutofix=new e("lightbulb-autofix",{fontCharacter:"\\eb13"}),e.linkExternal=new e("link-external",{fontCharacter:"\\eb14"}),e.link=new e("link",{fontCharacter:"\\eb15"}),e.listOrdered=new e("list-ordered",{fontCharacter:"\\eb16"}),e.listUnordered=new e("list-unordered",{fontCharacter:"\\eb17"}),e.liveShare=new e("live-share",{fontCharacter:"\\eb18"}),e.loading=new e("loading",{fontCharacter:"\\eb19"}),e.location=new e("location",{fontCharacter:"\\eb1a"}),e.mailRead=new e("mail-read",{fontCharacter:"\\eb1b"}),e.mail=new e("mail",{fontCharacter:"\\eb1c"}),e.markdown=new e("markdown",{fontCharacter:"\\eb1d"}),e.megaphone=new e("megaphone",{fontCharacter:"\\eb1e"}),e.mention=new e("mention",{fontCharacter:"\\eb1f"}),e.milestone=new e("milestone",{fontCharacter:"\\eb20"}),e.mortarBoard=new e("mortar-board",{fontCharacter:"\\eb21"}),e.move=new e("move",{fontCharacter:"\\eb22"}),e.multipleWindows=new e("multiple-windows",{fontCharacter:"\\eb23"}),e.mute=new e("mute",{fontCharacter:"\\eb24"}),e.noNewline=new e("no-newline",{fontCharacter:"\\eb25"}),e.note=new e("note",{fontCharacter:"\\eb26"}),e.octoface=new e("octoface",{fontCharacter:"\\eb27"}),e.openPreview=new e("open-preview",{fontCharacter:"\\eb28"}),e.package_=new e("package",{fontCharacter:"\\eb29"}),e.paintcan=new e("paintcan",{fontCharacter:"\\eb2a"}),e.pin=new e("pin",{fontCharacter:"\\eb2b"}),e.play=new e("play",{fontCharacter:"\\eb2c"}),e.run=new e("run",{fontCharacter:"\\eb2c"}),e.plug=new e("plug",{fontCharacter:"\\eb2d"}),e.preserveCase=new e("preserve-case",{fontCharacter:"\\eb2e"}),e.preview=new e("preview",{fontCharacter:"\\eb2f"}),e.project=new e("project",{fontCharacter:"\\eb30"}),e.pulse=new e("pulse",{fontCharacter:"\\eb31"}),e.question=new e("question",{fontCharacter:"\\eb32"}),e.quote=new e("quote",{fontCharacter:"\\eb33"}),e.radioTower=new e("radio-tower",{fontCharacter:"\\eb34"}),e.reactions=new e("reactions",{fontCharacter:"\\eb35"}),e.references=new e("references",{fontCharacter:"\\eb36"}),e.refresh=new e("refresh",{fontCharacter:"\\eb37"}),e.regex=new e("regex",{fontCharacter:"\\eb38"}),e.remoteExplorer=new e("remote-explorer",{fontCharacter:"\\eb39"}),e.remote=new e("remote",{fontCharacter:"\\eb3a"}),e.remove=new e("remove",{fontCharacter:"\\eb3b"}),e.replaceAll=new e("replace-all",{fontCharacter:"\\eb3c"}),e.replace=new e("replace",{fontCharacter:"\\eb3d"}),e.repoClone=new e("repo-clone",{fontCharacter:"\\eb3e"}),e.repoForcePush=new e("repo-force-push",{fontCharacter:"\\eb3f"}),e.repoPull=new e("repo-pull",{fontCharacter:"\\eb40"}),e.repoPush=new e("repo-push",{fontCharacter:"\\eb41"}),e.report=new e("report",{fontCharacter:"\\eb42"}),e.requestChanges=new e("request-changes",{fontCharacter:"\\eb43"}),e.rocket=new e("rocket",{fontCharacter:"\\eb44"}),e.rootFolderOpened=new e("root-folder-opened",{fontCharacter:"\\eb45"}),e.rootFolder=new e("root-folder",{fontCharacter:"\\eb46"}),e.rss=new e("rss",{fontCharacter:"\\eb47"}),e.ruby=new e("ruby",{fontCharacter:"\\eb48"}),e.saveAll=new e("save-all",{fontCharacter:"\\eb49"}),e.saveAs=new e("save-as",{fontCharacter:"\\eb4a"}),e.save=new e("save",{fontCharacter:"\\eb4b"}),e.screenFull=new e("screen-full",{fontCharacter:"\\eb4c"}),e.screenNormal=new e("screen-normal",{fontCharacter:"\\eb4d"}),e.searchStop=new e("search-stop",{fontCharacter:"\\eb4e"}),e.server=new e("server",{fontCharacter:"\\eb50"}),e.settingsGear=new e("settings-gear",{fontCharacter:"\\eb51"}),e.settings=new e("settings",{fontCharacter:"\\eb52"}),e.shield=new e("shield",{fontCharacter:"\\eb53"}),e.smiley=new e("smiley",{fontCharacter:"\\eb54"}),e.sortPrecedence=new e("sort-precedence",{fontCharacter:"\\eb55"}),e.splitHorizontal=new e("split-horizontal",{fontCharacter:"\\eb56"}),e.splitVertical=new e("split-vertical",{fontCharacter:"\\eb57"}),e.squirrel=new e("squirrel",{fontCharacter:"\\eb58"}),e.starFull=new e("star-full",{fontCharacter:"\\eb59"}),e.starHalf=new e("star-half",{fontCharacter:"\\eb5a"}),e.symbolClass=new e("symbol-class",{fontCharacter:"\\eb5b"}),e.symbolColor=new e("symbol-color",{fontCharacter:"\\eb5c"}),e.symbolCustomColor=new e("symbol-customcolor",{fontCharacter:"\\eb5c"}),e.symbolConstant=new e("symbol-constant",{fontCharacter:"\\eb5d"}),e.symbolEnumMember=new e("symbol-enum-member",{fontCharacter:"\\eb5e"}),e.symbolField=new e("symbol-field",{fontCharacter:"\\eb5f"}),e.symbolFile=new e("symbol-file",{fontCharacter:"\\eb60"}),e.symbolInterface=new e("symbol-interface",{fontCharacter:"\\eb61"}),e.symbolKeyword=new e("symbol-keyword",{fontCharacter:"\\eb62"}),e.symbolMisc=new e("symbol-misc",{fontCharacter:"\\eb63"}),e.symbolOperator=new e("symbol-operator",{fontCharacter:"\\eb64"}),e.symbolProperty=new e("symbol-property",{fontCharacter:"\\eb65"}),e.wrench=new e("wrench",{fontCharacter:"\\eb65"}),e.wrenchSubaction=new e("wrench-subaction",{fontCharacter:"\\eb65"}),e.symbolSnippet=new e("symbol-snippet",{fontCharacter:"\\eb66"}),e.tasklist=new e("tasklist",{fontCharacter:"\\eb67"}),e.telescope=new e("telescope",{fontCharacter:"\\eb68"}),e.textSize=new e("text-size",{fontCharacter:"\\eb69"}),e.threeBars=new e("three-bars",{fontCharacter:"\\eb6a"}),e.thumbsdown=new e("thumbsdown",{fontCharacter:"\\eb6b"}),e.thumbsup=new e("thumbsup",{fontCharacter:"\\eb6c"}),e.tools=new e("tools",{fontCharacter:"\\eb6d"}),e.triangleDown=new e("triangle-down",{fontCharacter:"\\eb6e"}),e.triangleLeft=new e("triangle-left",{fontCharacter:"\\eb6f"}),e.triangleRight=new e("triangle-right",{fontCharacter:"\\eb70"}),e.triangleUp=new e("triangle-up",{fontCharacter:"\\eb71"}),e.twitter=new e("twitter",{fontCharacter:"\\eb72"}),e.unfold=new e("unfold",{fontCharacter:"\\eb73"}),e.unlock=new e("unlock",{fontCharacter:"\\eb74"}),e.unmute=new e("unmute",{fontCharacter:"\\eb75"}),e.unverified=new e("unverified",{fontCharacter:"\\eb76"}),e.verified=new e("verified",{fontCharacter:"\\eb77"}),e.versions=new e("versions",{fontCharacter:"\\eb78"}),e.vmActive=new e("vm-active",{fontCharacter:"\\eb79"}),e.vmOutline=new e("vm-outline",{fontCharacter:"\\eb7a"}),e.vmRunning=new e("vm-running",{fontCharacter:"\\eb7b"}),e.watch=new e("watch",{fontCharacter:"\\eb7c"}),e.whitespace=new e("whitespace",{fontCharacter:"\\eb7d"}),e.wholeWord=new e("whole-word",{fontCharacter:"\\eb7e"}),e.window=new e("window",{fontCharacter:"\\eb7f"}),e.wordWrap=new e("word-wrap",{fontCharacter:"\\eb80"}),e.zoomIn=new e("zoom-in",{fontCharacter:"\\eb81"}),e.zoomOut=new e("zoom-out",{fontCharacter:"\\eb82"}),e.listFilter=new e("list-filter",{fontCharacter:"\\eb83"}),e.listFlat=new e("list-flat",{fontCharacter:"\\eb84"}),e.listSelection=new e("list-selection",{fontCharacter:"\\eb85"}),e.selection=new e("selection",{fontCharacter:"\\eb85"}),e.listTree=new e("list-tree",{fontCharacter:"\\eb86"}),e.debugBreakpointFunctionUnverified=new e("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),e.debugBreakpointFunction=new e("debug-breakpoint-function",{fontCharacter:"\\eb88"}),e.debugBreakpointFunctionDisabled=new e("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),e.debugStackframeActive=new e("debug-stackframe-active",{fontCharacter:"\\eb89"}),e.circleSmallFilled=new e("circle-small-filled",{fontCharacter:"\\eb8a"}),e.debugStackframeDot=new e("debug-stackframe-dot",e.circleSmallFilled.definition),e.debugStackframe=new e("debug-stackframe",{fontCharacter:"\\eb8b"}),e.debugStackframeFocused=new e("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),e.debugBreakpointUnsupported=new e("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),e.symbolString=new e("symbol-string",{fontCharacter:"\\eb8d"}),e.debugReverseContinue=new e("debug-reverse-continue",{fontCharacter:"\\eb8e"}),e.debugStepBack=new e("debug-step-back",{fontCharacter:"\\eb8f"}),e.debugRestartFrame=new e("debug-restart-frame",{fontCharacter:"\\eb90"}),e.callIncoming=new e("call-incoming",{fontCharacter:"\\eb92"}),e.callOutgoing=new e("call-outgoing",{fontCharacter:"\\eb93"}),e.menu=new e("menu",{fontCharacter:"\\eb94"}),e.expandAll=new e("expand-all",{fontCharacter:"\\eb95"}),e.feedback=new e("feedback",{fontCharacter:"\\eb96"}),e.groupByRefType=new e("group-by-ref-type",{fontCharacter:"\\eb97"}),e.ungroupByRefType=new e("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),e.account=new e("account",{fontCharacter:"\\eb99"}),e.bellDot=new e("bell-dot",{fontCharacter:"\\eb9a"}),e.debugConsole=new e("debug-console",{fontCharacter:"\\eb9b"}),e.library=new e("library",{fontCharacter:"\\eb9c"}),e.output=new e("output",{fontCharacter:"\\eb9d"}),e.runAll=new e("run-all",{fontCharacter:"\\eb9e"}),e.syncIgnored=new e("sync-ignored",{fontCharacter:"\\eb9f"}),e.pinned=new e("pinned",{fontCharacter:"\\eba0"}),e.githubInverted=new e("github-inverted",{fontCharacter:"\\eba1"}),e.debugAlt=new e("debug-alt",{fontCharacter:"\\eb91"}),e.serverProcess=new e("server-process",{fontCharacter:"\\eba2"}),e.serverEnvironment=new e("server-environment",{fontCharacter:"\\eba3"}),e.pass=new e("pass",{fontCharacter:"\\eba4"}),e.stopCircle=new e("stop-circle",{fontCharacter:"\\eba5"}),e.playCircle=new e("play-circle",{fontCharacter:"\\eba6"}),e.record=new e("record",{fontCharacter:"\\eba7"}),e.debugAltSmall=new e("debug-alt-small",{fontCharacter:"\\eba8"}),e.vmConnect=new e("vm-connect",{fontCharacter:"\\eba9"}),e.cloud=new e("cloud",{fontCharacter:"\\ebaa"}),e.merge=new e("merge",{fontCharacter:"\\ebab"}),e.exportIcon=new e("export",{fontCharacter:"\\ebac"}),e.graphLeft=new e("graph-left",{fontCharacter:"\\ebad"}),e.magnet=new e("magnet",{fontCharacter:"\\ebae"}),e.notebook=new e("notebook",{fontCharacter:"\\ebaf"}),e.redo=new e("redo",{fontCharacter:"\\ebb0"}),e.checkAll=new e("check-all",{fontCharacter:"\\ebb1"}),e.pinnedDirty=new e("pinned-dirty",{fontCharacter:"\\ebb2"}),e.passFilled=new e("pass-filled",{fontCharacter:"\\ebb3"}),e.circleLargeFilled=new e("circle-large-filled",{fontCharacter:"\\ebb4"}),e.circleLarge=new e("circle-large",{fontCharacter:"\\ebb5"}),e.circleLargeOutline=new e("circle-large-outline",e.circleLarge.definition),e.combine=new e("combine",{fontCharacter:"\\ebb6"}),e.gather=new e("gather",{fontCharacter:"\\ebb6"}),e.table=new e("table",{fontCharacter:"\\ebb7"}),e.variableGroup=new e("variable-group",{fontCharacter:"\\ebb8"}),e.typeHierarchy=new e("type-hierarchy",{fontCharacter:"\\ebb9"}),e.typeHierarchySub=new e("type-hierarchy-sub",{fontCharacter:"\\ebba"}),e.typeHierarchySuper=new e("type-hierarchy-super",{fontCharacter:"\\ebbb"}),e.gitPullRequestCreate=new e("git-pull-request-create",{fontCharacter:"\\ebbc"}),e.runAbove=new e("run-above",{fontCharacter:"\\ebbd"}),e.runBelow=new e("run-below",{fontCharacter:"\\ebbe"}),e.notebookTemplate=new e("notebook-template",{fontCharacter:"\\ebbf"}),e.debugRerun=new e("debug-rerun",{fontCharacter:"\\ebc0"}),e.workspaceTrusted=new e("workspace-trusted",{fontCharacter:"\\ebc1"}),e.workspaceUntrusted=new e("workspace-untrusted",{fontCharacter:"\\ebc2"}),e.workspaceUnspecified=new e("workspace-unspecified",{fontCharacter:"\\ebc3"}),e.terminalCmd=new e("terminal-cmd",{fontCharacter:"\\ebc4"}),e.terminalDebian=new e("terminal-debian",{fontCharacter:"\\ebc5"}),e.terminalLinux=new e("terminal-linux",{fontCharacter:"\\ebc6"}),e.terminalPowershell=new e("terminal-powershell",{fontCharacter:"\\ebc7"}),e.terminalTmux=new e("terminal-tmux",{fontCharacter:"\\ebc8"}),e.terminalUbuntu=new e("terminal-ubuntu",{fontCharacter:"\\ebc9"}),e.terminalBash=new e("terminal-bash",{fontCharacter:"\\ebca"}),e.arrowSwap=new e("arrow-swap",{fontCharacter:"\\ebcb"}),e.copy=new e("copy",{fontCharacter:"\\ebcc"}),e.personAdd=new e("person-add",{fontCharacter:"\\ebcd"}),e.filterFilled=new e("filter-filled",{fontCharacter:"\\ebce"}),e.wand=new e("wand",{fontCharacter:"\\ebcf"}),e.debugLineByLine=new e("debug-line-by-line",{fontCharacter:"\\ebd0"}),e.inspect=new e("inspect",{fontCharacter:"\\ebd1"}),e.layers=new e("layers",{fontCharacter:"\\ebd2"}),e.layersDot=new e("layers-dot",{fontCharacter:"\\ebd3"}),e.layersActive=new e("layers-active",{fontCharacter:"\\ebd4"}),e.compass=new e("compass",{fontCharacter:"\\ebd5"}),e.compassDot=new e("compass-dot",{fontCharacter:"\\ebd6"}),e.compassActive=new e("compass-active",{fontCharacter:"\\ebd7"}),e.azure=new e("azure",{fontCharacter:"\\ebd8"}),e.issueDraft=new e("issue-draft",{fontCharacter:"\\ebd9"}),e.gitPullRequestClosed=new e("git-pull-request-closed",{fontCharacter:"\\ebda"}),e.gitPullRequestDraft=new e("git-pull-request-draft",{fontCharacter:"\\ebdb"}),e.debugAll=new e("debug-all",{fontCharacter:"\\ebdc"}),e.debugCoverage=new e("debug-coverage",{fontCharacter:"\\ebdd"}),e.runErrors=new e("run-errors",{fontCharacter:"\\ebde"}),e.folderLibrary=new e("folder-library",{fontCharacter:"\\ebdf"}),e.debugContinueSmall=new e("debug-continue-small",{fontCharacter:"\\ebe0"}),e.beakerStop=new e("beaker-stop",{fontCharacter:"\\ebe1"}),e.graphLine=new e("graph-line",{fontCharacter:"\\ebe2"}),e.graphScatter=new e("graph-scatter",{fontCharacter:"\\ebe3"}),e.pieChart=new e("pie-chart",{fontCharacter:"\\ebe4"}),e.bracket=new e("bracket",e.json.definition),e.bracketDot=new e("bracket-dot",{fontCharacter:"\\ebe5"}),e.bracketError=new e("bracket-error",{fontCharacter:"\\ebe6"}),e.lockSmall=new e("lock-small",{fontCharacter:"\\ebe7"}),e.azureDevops=new e("azure-devops",{fontCharacter:"\\ebe8"}),e.verifiedFilled=new e("verified-filled",{fontCharacter:"\\ebe9"}),e.newLine=new e("newline",{fontCharacter:"\\ebea"}),e.layout=new e("layout",{fontCharacter:"\\ebeb"}),e.layoutActivitybarLeft=new e("layout-activitybar-left",{fontCharacter:"\\ebec"}),e.layoutActivitybarRight=new e("layout-activitybar-right",{fontCharacter:"\\ebed"}),e.layoutPanelLeft=new e("layout-panel-left",{fontCharacter:"\\ebee"}),e.layoutPanelCenter=new e("layout-panel-center",{fontCharacter:"\\ebef"}),e.layoutPanelJustify=new e("layout-panel-justify",{fontCharacter:"\\ebf0"}),e.layoutPanelRight=new e("layout-panel-right",{fontCharacter:"\\ebf1"}),e.layoutPanel=new e("layout-panel",{fontCharacter:"\\ebf2"}),e.layoutSidebarLeft=new e("layout-sidebar-left",{fontCharacter:"\\ebf3"}),e.layoutSidebarRight=new e("layout-sidebar-right",{fontCharacter:"\\ebf4"}),e.layoutStatusbar=new e("layout-statusbar",{fontCharacter:"\\ebf5"}),e.layoutMenubar=new e("layout-menubar",{fontCharacter:"\\ebf6"}),e.layoutCentered=new e("layout-centered",{fontCharacter:"\\ebf7"}),e.layoutSidebarRightOff=new e("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),e.layoutPanelOff=new e("layout-panel-off",{fontCharacter:"\\ec01"}),e.layoutSidebarLeftOff=new e("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),e.target=new e("target",{fontCharacter:"\\ebf8"}),e.indent=new e("indent",{fontCharacter:"\\ebf9"}),e.recordSmall=new e("record-small",{fontCharacter:"\\ebfa"}),e.errorSmall=new e("error-small",{fontCharacter:"\\ebfb"}),e.arrowCircleDown=new e("arrow-circle-down",{fontCharacter:"\\ebfc"}),e.arrowCircleLeft=new e("arrow-circle-left",{fontCharacter:"\\ebfd"}),e.arrowCircleRight=new e("arrow-circle-right",{fontCharacter:"\\ebfe"}),e.arrowCircleUp=new e("arrow-circle-up",{fontCharacter:"\\ebff"}),e.heartFilled=new e("heart-filled",{fontCharacter:"\\ec04"}),e.map=new e("map",{fontCharacter:"\\ec05"}),e.mapFilled=new e("map-filled",{fontCharacter:"\\ec06"}),e.circleSmall=new e("circle-small",{fontCharacter:"\\ec07"}),e.bellSlash=new e("bell-slash",{fontCharacter:"\\ec08"}),e.bellSlashDot=new e("bell-slash-dot",{fontCharacter:"\\ec09"}),e.commentUnresolved=new e("comment-unresolved",{fontCharacter:"\\ec0a"}),e.gitPullRequestGoToChanges=new e("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),e.gitPullRequestNewChanges=new e("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),e.searchFuzzy=new e("search-fuzzy",{fontCharacter:"\\ec0d"}),e.commentDraft=new e("comment-draft",{fontCharacter:"\\ec0e"}),e.dialogError=new e("dialog-error",e.error.definition),e.dialogWarning=new e("dialog-warning",e.warning.definition),e.dialogInfo=new e("dialog-info",e.info.definition),e.dialogClose=new e("dialog-close",e.close.definition),e.treeItemExpanded=new e("tree-item-expanded",e.chevronDown.definition),e.treeFilterOnTypeOn=new e("tree-filter-on-type-on",e.listFilter.definition),e.treeFilterOnTypeOff=new e("tree-filter-on-type-off",e.listSelection.definition),e.treeFilterClear=new e("tree-filter-clear",e.close.definition),e.treeItemLoading=new e("tree-item-loading",e.loading.definition),e.menuSelection=new e("menu-selection",e.check.definition),e.menuSubmenu=new e("menu-submenu",e.chevronRight.definition),e.menuBarMore=new e("menubar-more",e.more.definition),e.scrollbarButtonLeft=new e("scrollbar-button-left",e.triangleLeft.definition),e.scrollbarButtonRight=new e("scrollbar-button-right",e.triangleRight.definition),e.scrollbarButtonUp=new e("scrollbar-button-up",e.triangleUp.definition),e.scrollbarButtonDown=new e("scrollbar-button-down",e.triangleDown.definition),e.toolBarMore=new e("toolbar-more",e.more.definition),e.quickInputBack=new e("quick-input-back",e.arrowLeft.definition);var E;(function(l){l.iconNameSegment="[A-Za-z0-9]+",l.iconNameExpression="[A-Za-z0-9-]+",l.iconModifierExpression="~[A-Za-z]+",l.iconNameCharacter="[A-Za-z0-9~-]";const p=new RegExp(`^(${l.iconNameExpression})(${l.iconModifierExpression})?$`);function C(S){if(S instanceof e)return["codicon","codicon-"+S.id];const t=p.exec(S.id);if(!t)return C(e.error);const[,w,h]=t,m=["codicon","codicon-"+w];return h&&m.push("codicon-modifier-"+h.substring(1)),m}l.asClassNameArray=C;function o(S){return C(S).join(" ")}l.asClassName=o;function f(S){return"."+C(S).join(".")}l.asCSSSelector=f})(E=r.CSSIcon||(r.CSSIcon={}))}),X(Q[25],J([0,1]),function(T,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.DiffChange=void 0;class A{constructor(E,l,p,C){this.originalStart=E,this.originalLength=l,this.modifiedStart=p,this.modifiedLength=C}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}r.DiffChange=A}),X(Q[8],J([0,1]),function(T,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.BugIndicatingError=r.ErrorNoTelemetry=r.NotSupportedError=r.illegalState=r.illegalArgument=r.canceled=r.CancellationError=r.isCancellationError=r.transformErrorForSerialization=r.onUnexpectedExternalError=r.onUnexpectedError=r.errorHandler=r.ErrorHandler=void 0;class A{constructor(){this.b=[],this.a=function(y){setTimeout(()=>{throw y.stack?h.isErrorNoTelemetry(y)?new h(y.message+`

`+y.stack):new Error(y.message+`

`+y.stack):y},0)}}c(y){this.b.forEach(_=>{_(y)})}onUnexpectedError(y){this.a(y),this.c(y)}onUnexpectedExternalError(y){this.a(y)}}r.ErrorHandler=A,r.errorHandler=new A;function e(L){C(L)||r.errorHandler.onUnexpectedError(L)}r.onUnexpectedError=e;function E(L){C(L)||r.errorHandler.onUnexpectedExternalError(L)}r.onUnexpectedExternalError=E;function l(L){if(L instanceof Error){const{name:y,message:_}=L,g=L.stacktrace||L.stack;return{$isError:!0,name:y,message:_,stack:g,noTelemetry:h.isErrorNoTelemetry(L)}}return L}r.transformErrorForSerialization=l;const p="Canceled";function C(L){return L instanceof o?!0:L instanceof Error&&L.name===p&&L.message===p}r.isCancellationError=C;class o extends Error{constructor(){super(p),this.name=this.message}}r.CancellationError=o;function f(){const L=new Error(p);return L.name=L.message,L}r.canceled=f;function S(L){return L?new Error(`Illegal argument: ${L}`):new Error("Illegal argument")}r.illegalArgument=S;function t(L){return L?new Error(`Illegal state: ${L}`):new Error("Illegal state")}r.illegalState=t;class w extends Error{constructor(y){super("NotSupported"),y&&(this.message=y)}}r.NotSupportedError=w;class h extends Error{constructor(y){super(y),this.name="CodeExpectedError"}static fromError(y){if(y instanceof h)return y;const _=new h;return _.message=y.message,_.stack=y.stack,_}static isErrorNoTelemetry(y){return y.name==="CodeExpectedError"}}r.ErrorNoTelemetry=h;class m extends Error{constructor(y){super(y||"An unexpected bug occurred."),Object.setPrototypeOf(this,m.prototype);debugger}}r.BugIndicatingError=m}),X(Q[9],J([0,1,8]),function(T,r,A){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.checkAdjacentItems=r.assertFn=r.assertNever=r.ok=void 0;function e(C,o){if(!C)throw new Error(o?`Assertion failed (${o})`:"Assertion Failed")}r.ok=e;function E(C,o="Unreachable"){throw new Error(o)}r.assertNever=E;function l(C){if(!C()){debugger;C(),(0,A.onUnexpectedError)(new A.BugIndicatingError("Assertion Failed"))}}r.assertFn=l;function p(C,o){let f=0;for(;f<C.length-1;){const S=C[f],t=C[f+1];if(!o(S,t))return!1;f++}return!0}r.checkAdjacentItems=p}),X(Q[26],J([0,1]),function(T,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.once=void 0;function A(e){const E=this;let l=!1,p;return function(){return l||(l=!0,p=e.apply(E,arguments)),p}}r.once=A}),X(Q[13],J([0,1]),function(T,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.Iterable=void 0;var A;(function(e){function E(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}e.is=E;const l=Object.freeze([]);function p(){return l}e.empty=p;function*C(u){yield u}e.single=C;function o(u){return E(u)?u:C(u)}e.wrap=o;function f(u){return u||l}e.from=f;function S(u){return!u||u[Symbol.iterator]().next().done===!0}e.isEmpty=S;function t(u){return u[Symbol.iterator]().next().value}e.first=t;function w(u,d){for(const s of u)if(d(s))return!0;return!1}e.some=w;function h(u,d){for(const s of u)if(d(s))return s}e.find=h;function*m(u,d){for(const s of u)d(s)&&(yield s)}e.filter=m;function*L(u,d){let s=0;for(const a of u)yield d(a,s++)}e.map=L;function*y(...u){for(const d of u)for(const s of d)yield s}e.concat=y;function _(u,d,s){let a=s;for(const i of u)a=d(a,i);return a}e.reduce=_;function*g(u,d,s=u.length){for(d<0&&(d+=u.length),s<0?s+=u.length:s>u.length&&(s=u.length);d<s;d++)yield u[d]}e.slice=g;function v(u,d=Number.POSITIVE_INFINITY){const s=[];if(d===0)return[s,u];const a=u[Symbol.iterator]();for(let i=0;i<d;i++){const c=a.next();if(c.done)return[s,e.empty()];s.push(c.value)}return[s,{[Symbol.iterator](){return a}}]}e.consume=v})(A=r.Iterable||(r.Iterable={}))}),X(Q[27],J([0,1]),function(T,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.KeyChord=r.KeyCodeUtils=r.IMMUTABLE_KEY_CODE_TO_CODE=r.IMMUTABLE_CODE_TO_KEY_CODE=r.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=r.EVENT_KEY_CODE_MAP=void 0;class A{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(w,h){this._keyCodeToStr[w]=h,this._strToKeyCode[h.toLowerCase()]=w}keyCodeToStr(w){return this._keyCodeToStr[w]}strToKeyCode(w){return this._strToKeyCode[w.toLowerCase()]||0}}const e=new A,E=new A,l=new A;r.EVENT_KEY_CODE_MAP=new Array(230),r.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const p=[],C=Object.create(null),o=Object.create(null);r.IMMUTABLE_CODE_TO_KEY_CODE=[],r.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let t=0;t<=193;t++)r.IMMUTABLE_CODE_TO_KEY_CODE[t]=-1;for(let t=0;t<=127;t++)r.IMMUTABLE_KEY_CODE_TO_CODE[t]=-1;(function(){const t="",w=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",t,t],[0,1,1,"Hyper",0,t,0,t,t,t],[0,1,2,"Super",0,t,0,t,t,t],[0,1,3,"Fn",0,t,0,t,t,t],[0,1,4,"FnLock",0,t,0,t,t,t],[0,1,5,"Suspend",0,t,0,t,t,t],[0,1,6,"Resume",0,t,0,t,t,t],[0,1,7,"Turbo",0,t,0,t,t,t],[0,1,8,"Sleep",0,t,0,"VK_SLEEP",t,t],[0,1,9,"WakeUp",0,t,0,t,t,t],[31,0,10,"KeyA",31,"A",65,"VK_A",t,t],[32,0,11,"KeyB",32,"B",66,"VK_B",t,t],[33,0,12,"KeyC",33,"C",67,"VK_C",t,t],[34,0,13,"KeyD",34,"D",68,"VK_D",t,t],[35,0,14,"KeyE",35,"E",69,"VK_E",t,t],[36,0,15,"KeyF",36,"F",70,"VK_F",t,t],[37,0,16,"KeyG",37,"G",71,"VK_G",t,t],[38,0,17,"KeyH",38,"H",72,"VK_H",t,t],[39,0,18,"KeyI",39,"I",73,"VK_I",t,t],[40,0,19,"KeyJ",40,"J",74,"VK_J",t,t],[41,0,20,"KeyK",41,"K",75,"VK_K",t,t],[42,0,21,"KeyL",42,"L",76,"VK_L",t,t],[43,0,22,"KeyM",43,"M",77,"VK_M",t,t],[44,0,23,"KeyN",44,"N",78,"VK_N",t,t],[45,0,24,"KeyO",45,"O",79,"VK_O",t,t],[46,0,25,"KeyP",46,"P",80,"VK_P",t,t],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",t,t],[48,0,27,"KeyR",48,"R",82,"VK_R",t,t],[49,0,28,"KeyS",49,"S",83,"VK_S",t,t],[50,0,29,"KeyT",50,"T",84,"VK_T",t,t],[51,0,30,"KeyU",51,"U",85,"VK_U",t,t],[52,0,31,"KeyV",52,"V",86,"VK_V",t,t],[53,0,32,"KeyW",53,"W",87,"VK_W",t,t],[54,0,33,"KeyX",54,"X",88,"VK_X",t,t],[55,0,34,"KeyY",55,"Y",89,"VK_Y",t,t],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",t,t],[22,0,36,"Digit1",22,"1",49,"VK_1",t,t],[23,0,37,"Digit2",23,"2",50,"VK_2",t,t],[24,0,38,"Digit3",24,"3",51,"VK_3",t,t],[25,0,39,"Digit4",25,"4",52,"VK_4",t,t],[26,0,40,"Digit5",26,"5",53,"VK_5",t,t],[27,0,41,"Digit6",27,"6",54,"VK_6",t,t],[28,0,42,"Digit7",28,"7",55,"VK_7",t,t],[29,0,43,"Digit8",29,"8",56,"VK_8",t,t],[30,0,44,"Digit9",30,"9",57,"VK_9",t,t],[21,0,45,"Digit0",21,"0",48,"VK_0",t,t],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",t,t],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",t,t],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",t,t],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",t,t],[10,1,50,"Space",10,"Space",32,"VK_SPACE",t,t],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,t,0,t,t,t],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",t,t],[59,1,64,"F1",59,"F1",112,"VK_F1",t,t],[60,1,65,"F2",60,"F2",113,"VK_F2",t,t],[61,1,66,"F3",61,"F3",114,"VK_F3",t,t],[62,1,67,"F4",62,"F4",115,"VK_F4",t,t],[63,1,68,"F5",63,"F5",116,"VK_F5",t,t],[64,1,69,"F6",64,"F6",117,"VK_F6",t,t],[65,1,70,"F7",65,"F7",118,"VK_F7",t,t],[66,1,71,"F8",66,"F8",119,"VK_F8",t,t],[67,1,72,"F9",67,"F9",120,"VK_F9",t,t],[68,1,73,"F10",68,"F10",121,"VK_F10",t,t],[69,1,74,"F11",69,"F11",122,"VK_F11",t,t],[70,1,75,"F12",70,"F12",123,"VK_F12",t,t],[0,1,76,"PrintScreen",0,t,0,t,t,t],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",t,t],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",t,t],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",t,t],[14,1,80,"Home",14,"Home",36,"VK_HOME",t,t],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",t,t],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",t,t],[13,1,83,"End",13,"End",35,"VK_END",t,t],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",t,t],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",t],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",t],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",t],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",t],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",t,t],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",t,t],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",t,t],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",t,t],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",t,t],[3,1,94,"NumpadEnter",3,t,0,t,t,t],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",t,t],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",t,t],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",t,t],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",t,t],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",t,t],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",t,t],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",t,t],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",t,t],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",t,t],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",t,t],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",t,t],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",t,t],[58,1,107,"ContextMenu",58,"ContextMenu",93,t,t,t],[0,1,108,"Power",0,t,0,t,t,t],[0,1,109,"NumpadEqual",0,t,0,t,t,t],[71,1,110,"F13",71,"F13",124,"VK_F13",t,t],[72,1,111,"F14",72,"F14",125,"VK_F14",t,t],[73,1,112,"F15",73,"F15",126,"VK_F15",t,t],[74,1,113,"F16",74,"F16",127,"VK_F16",t,t],[75,1,114,"F17",75,"F17",128,"VK_F17",t,t],[76,1,115,"F18",76,"F18",129,"VK_F18",t,t],[77,1,116,"F19",77,"F19",130,"VK_F19",t,t],[0,1,117,"F20",0,t,0,"VK_F20",t,t],[0,1,118,"F21",0,t,0,"VK_F21",t,t],[0,1,119,"F22",0,t,0,"VK_F22",t,t],[0,1,120,"F23",0,t,0,"VK_F23",t,t],[0,1,121,"F24",0,t,0,"VK_F24",t,t],[0,1,122,"Open",0,t,0,t,t,t],[0,1,123,"Help",0,t,0,t,t,t],[0,1,124,"Select",0,t,0,t,t,t],[0,1,125,"Again",0,t,0,t,t,t],[0,1,126,"Undo",0,t,0,t,t,t],[0,1,127,"Cut",0,t,0,t,t,t],[0,1,128,"Copy",0,t,0,t,t,t],[0,1,129,"Paste",0,t,0,t,t,t],[0,1,130,"Find",0,t,0,t,t,t],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",t,t],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",t,t],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",t,t],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",t,t],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",t,t],[0,1,136,"KanaMode",0,t,0,t,t,t],[0,0,137,"IntlYen",0,t,0,t,t,t],[0,1,138,"Convert",0,t,0,t,t,t],[0,1,139,"NonConvert",0,t,0,t,t,t],[0,1,140,"Lang1",0,t,0,t,t,t],[0,1,141,"Lang2",0,t,0,t,t,t],[0,1,142,"Lang3",0,t,0,t,t,t],[0,1,143,"Lang4",0,t,0,t,t,t],[0,1,144,"Lang5",0,t,0,t,t,t],[0,1,145,"Abort",0,t,0,t,t,t],[0,1,146,"Props",0,t,0,t,t,t],[0,1,147,"NumpadParenLeft",0,t,0,t,t,t],[0,1,148,"NumpadParenRight",0,t,0,t,t,t],[0,1,149,"NumpadBackspace",0,t,0,t,t,t],[0,1,150,"NumpadMemoryStore",0,t,0,t,t,t],[0,1,151,"NumpadMemoryRecall",0,t,0,t,t,t],[0,1,152,"NumpadMemoryClear",0,t,0,t,t,t],[0,1,153,"NumpadMemoryAdd",0,t,0,t,t,t],[0,1,154,"NumpadMemorySubtract",0,t,0,t,t,t],[0,1,155,"NumpadClear",126,"Clear",12,"VK_CLEAR",t,t],[0,1,156,"NumpadClearEntry",0,t,0,t,t,t],[5,1,0,t,5,"Ctrl",17,"VK_CONTROL",t,t],[4,1,0,t,4,"Shift",16,"VK_SHIFT",t,t],[6,1,0,t,6,"Alt",18,"VK_MENU",t,t],[57,1,0,t,57,"Meta",0,"VK_COMMAND",t,t],[5,1,157,"ControlLeft",5,t,0,"VK_LCONTROL",t,t],[4,1,158,"ShiftLeft",4,t,0,"VK_LSHIFT",t,t],[6,1,159,"AltLeft",6,t,0,"VK_LMENU",t,t],[57,1,160,"MetaLeft",57,t,0,"VK_LWIN",t,t],[5,1,161,"ControlRight",5,t,0,"VK_RCONTROL",t,t],[4,1,162,"ShiftRight",4,t,0,"VK_RSHIFT",t,t],[6,1,163,"AltRight",6,t,0,"VK_RMENU",t,t],[57,1,164,"MetaRight",57,t,0,"VK_RWIN",t,t],[0,1,165,"BrightnessUp",0,t,0,t,t,t],[0,1,166,"BrightnessDown",0,t,0,t,t,t],[0,1,167,"MediaPlay",0,t,0,t,t,t],[0,1,168,"MediaRecord",0,t,0,t,t,t],[0,1,169,"MediaFastForward",0,t,0,t,t,t],[0,1,170,"MediaRewind",0,t,0,t,t,t],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",t,t],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",t,t],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",t,t],[0,1,174,"Eject",0,t,0,t,t,t],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",t,t],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",t,t],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",t,t],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",t,t],[0,1,179,"LaunchApp1",0,t,0,"VK_MEDIA_LAUNCH_APP1",t,t],[0,1,180,"SelectTask",0,t,0,t,t,t],[0,1,181,"LaunchScreenSaver",0,t,0,t,t,t],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",t,t],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",t,t],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",t,t],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",t,t],[0,1,186,"BrowserStop",0,t,0,"VK_BROWSER_STOP",t,t],[0,1,187,"BrowserRefresh",0,t,0,"VK_BROWSER_REFRESH",t,t],[0,1,188,"BrowserFavorites",0,t,0,"VK_BROWSER_FAVORITES",t,t],[0,1,189,"ZoomToggle",0,t,0,t,t,t],[0,1,190,"MailReply",0,t,0,t,t,t],[0,1,191,"MailForward",0,t,0,t,t,t],[0,1,192,"MailSend",0,t,0,t,t,t],[109,1,0,t,109,"KeyInComposition",229,t,t,t],[111,1,0,t,111,"ABNT_C2",194,"VK_ABNT_C2",t,t],[91,1,0,t,91,"OEM_8",223,"VK_OEM_8",t,t],[0,1,0,t,0,t,0,"VK_KANA",t,t],[0,1,0,t,0,t,0,"VK_HANGUL",t,t],[0,1,0,t,0,t,0,"VK_JUNJA",t,t],[0,1,0,t,0,t,0,"VK_FINAL",t,t],[0,1,0,t,0,t,0,"VK_HANJA",t,t],[0,1,0,t,0,t,0,"VK_KANJI",t,t],[0,1,0,t,0,t,0,"VK_CONVERT",t,t],[0,1,0,t,0,t,0,"VK_NONCONVERT",t,t],[0,1,0,t,0,t,0,"VK_ACCEPT",t,t],[0,1,0,t,0,t,0,"VK_MODECHANGE",t,t],[0,1,0,t,0,t,0,"VK_SELECT",t,t],[0,1,0,t,0,t,0,"VK_PRINT",t,t],[0,1,0,t,0,t,0,"VK_EXECUTE",t,t],[0,1,0,t,0,t,0,"VK_SNAPSHOT",t,t],[0,1,0,t,0,t,0,"VK_HELP",t,t],[0,1,0,t,0,t,0,"VK_APPS",t,t],[0,1,0,t,0,t,0,"VK_PROCESSKEY",t,t],[0,1,0,t,0,t,0,"VK_PACKET",t,t],[0,1,0,t,0,t,0,"VK_DBE_SBCSCHAR",t,t],[0,1,0,t,0,t,0,"VK_DBE_DBCSCHAR",t,t],[0,1,0,t,0,t,0,"VK_ATTN",t,t],[0,1,0,t,0,t,0,"VK_CRSEL",t,t],[0,1,0,t,0,t,0,"VK_EXSEL",t,t],[0,1,0,t,0,t,0,"VK_EREOF",t,t],[0,1,0,t,0,t,0,"VK_PLAY",t,t],[0,1,0,t,0,t,0,"VK_ZOOM",t,t],[0,1,0,t,0,t,0,"VK_NONAME",t,t],[0,1,0,t,0,t,0,"VK_PA1",t,t],[0,1,0,t,0,t,0,"VK_OEM_CLEAR",t,t]],h=[],m=[];for(const L of w){const[y,_,g,v,u,d,s,a,i,c]=L;if(m[g]||(m[g]=!0,p[g]=v,C[v]=g,o[v.toLowerCase()]=g,_&&(r.IMMUTABLE_CODE_TO_KEY_CODE[g]=u,u!==0&&u!==3&&u!==5&&u!==4&&u!==6&&u!==57&&(r.IMMUTABLE_KEY_CODE_TO_CODE[u]=g))),!h[u]){if(h[u]=!0,!d)throw new Error(`String representation missing for key code ${u} around scan code ${v}`);e.define(u,d),E.define(u,i||d),l.define(u,c||i||d)}s&&(r.EVENT_KEY_CODE_MAP[s]=u),a&&(r.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[a]=u)}r.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var f;(function(t){function w(g){return e.keyCodeToStr(g)}t.toString=w;function h(g){return e.strToKeyCode(g)}t.fromString=h;function m(g){return E.keyCodeToStr(g)}t.toUserSettingsUS=m;function L(g){return l.keyCodeToStr(g)}t.toUserSettingsGeneral=L;function y(g){return E.strToKeyCode(g)||l.strToKeyCode(g)}t.fromUserSettings=y;function _(g){if(g>=93&&g<=108)return null;switch(g){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return e.keyCodeToStr(g)}t.toElectronAccelerator=_})(f=r.KeyCodeUtils||(r.KeyCodeUtils={}));function S(t,w){const h=(w&65535)<<16>>>0;return(t|h)>>>0}r.KeyChord=S}),X(Q[28],J([0,1]),function(T,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.Lazy=void 0;class A{constructor(E){this.d=E,this.a=!1}getValue(){if(!this.a)try{this.b=this.d()}catch(E){this.c=E}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}r.Lazy=A}),X(Q[10],J([0,1,26,13]),function(T,r,A,e){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.DisposableMap=r.ImmortalReference=r.SafeDisposable=r.RefCountedDisposable=r.MutableDisposable=r.Disposable=r.DisposableStore=r.toDisposable=r.combinedDisposable=r.dispose=r.isDisposable=r.markAsSingleton=r.setDisposableTracker=void 0;const E=!1;let l=null;function p(a){l=a}if(r.setDisposableTracker=p,E){const a="__is_disposable_tracked__";p(new class{trackDisposable(i){const c=new Error("Potentially leaked disposable").stack;setTimeout(()=>{i[a]||console.log(c)},3e3)}setParent(i,c){if(i&&i!==_.None)try{i[a]=!0}catch{}}markAsDisposed(i){if(i&&i!==_.None)try{i[a]=!0}catch{}}markAsSingleton(i){}})}function C(a){return l?.trackDisposable(a),a}function o(a){l?.markAsDisposed(a)}function f(a,i){l?.setParent(a,i)}function S(a,i){if(!!l)for(const c of a)l.setParent(c,i)}function t(a){return l?.markAsSingleton(a),a}r.markAsSingleton=t;function w(a){return typeof a.dispose=="function"&&a.dispose.length===0}r.isDisposable=w;function h(a){if(e.Iterable.is(a)){const i=[];for(const c of a)if(c)try{c.dispose()}catch(b){i.push(b)}if(i.length===1)throw i[0];if(i.length>1)throw new AggregateError(i,"Encountered errors while disposing of store");return Array.isArray(a)?[]:a}else if(a)return a.dispose(),a}r.dispose=h;function m(...a){const i=L(()=>h(a));return S(a,i),i}r.combinedDisposable=m;function L(a){const i=C({dispose:(0,A.once)(()=>{o(i),a()})});return i}r.toDisposable=L;class y{constructor(){this.a=new Set,this.b=!1,C(this)}dispose(){this.b||(o(this),this.b=!0,this.clear())}get isDisposed(){return this.b}clear(){if(this.a.size!==0)try{h(this.a)}finally{this.a.clear()}}add(i){if(!i)return i;if(i===this)throw new Error("Cannot register a disposable on itself!");return f(i,this),this.b?y.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.a.add(i),i}}r.DisposableStore=y,y.DISABLE_DISPOSED_WARNING=!1;class _{constructor(){this.f=new y,C(this),f(this.f,this)}dispose(){o(this),this.f.dispose()}q(i){if(i===this)throw new Error("Cannot register a disposable on itself!");return this.f.add(i)}}r.Disposable=_,_.None=Object.freeze({dispose(){}});class g{constructor(){this.b=!1,C(this)}get value(){return this.b?void 0:this.a}set value(i){var c;this.b||i===this.a||((c=this.a)===null||c===void 0||c.dispose(),i&&f(i,this),this.a=i)}clear(){this.value=void 0}dispose(){var i;this.b=!0,o(this),(i=this.a)===null||i===void 0||i.dispose(),this.a=void 0}clearAndLeak(){const i=this.a;return this.a=void 0,i&&f(i,null),i}}r.MutableDisposable=g;class v{constructor(i){this.b=i,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}r.RefCountedDisposable=v;class u{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,C(this)}set(i){let c=i;return this.unset=()=>c=void 0,this.isset=()=>c!==void 0,this.dispose=()=>{c&&(c(),c=void 0,o(this))},this}}r.SafeDisposable=u;class d{constructor(i){this.object=i}dispose(){}}r.ImmortalReference=d;class s{constructor(){this.a=new Map,this.b=!1,C(this)}dispose(){o(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{h(this.a.values())}finally{this.a.clear()}}get(i){return this.a.get(i)}set(i,c,b=!1){var N;this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),b||(N=this.a.get(i))===null||N===void 0||N.dispose(),this.a.set(i,c)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}r.DisposableMap=s}),X(Q[14],J([0,1]),function(T,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.LinkedList=void 0;class A{constructor(l){this.element=l,this.next=A.Undefined,this.prev=A.Undefined}}A.Undefined=new A(void 0);class e{constructor(){this.a=A.Undefined,this.b=A.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===A.Undefined}clear(){let l=this.a;for(;l!==A.Undefined;){const p=l.next;l.prev=A.Undefined,l.next=A.Undefined,l=p}this.a=A.Undefined,this.b=A.Undefined,this.c=0}unshift(l){return this.d(l,!1)}push(l){return this.d(l,!0)}d(l,p){const C=new A(l);if(this.a===A.Undefined)this.a=C,this.b=C;else if(p){const f=this.b;this.b=C,C.prev=f,f.next=C}else{const f=this.a;this.a=C,C.next=f,f.prev=C}this.c+=1;let o=!1;return()=>{o||(o=!0,this.e(C))}}shift(){if(this.a!==A.Undefined){const l=this.a.element;return this.e(this.a),l}}pop(){if(this.b!==A.Undefined){const l=this.b.element;return this.e(this.b),l}}e(l){if(l.prev!==A.Undefined&&l.next!==A.Undefined){const p=l.prev;p.next=l.next,l.next.prev=p}else l.prev===A.Undefined&&l.next===A.Undefined?(this.a=A.Undefined,this.b=A.Undefined):l.next===A.Undefined?(this.b=this.b.prev,this.b.next=A.Undefined):l.prev===A.Undefined&&(this.a=this.a.next,this.a.prev=A.Undefined);this.c-=1}*[Symbol.iterator](){let l=this.a;for(;l!==A.Undefined;)yield l.element,l=l.next}}r.LinkedList=e}),X(Q[4],J([0,1,23,28]),function(T,r,A,e){"use strict";var E;Object.defineProperty(r,"__esModule",{value:!0}),r.InvisibleCharacters=r.AmbiguousCharacters=r.noBreakWhitespace=r.getLeftDeleteOffset=r.singleLetterHash=r.containsUppercaseCharacter=r.startsWithUTF8BOM=r.UTF8_BOM_CHARACTER=r.isEmojiImprecise=r.isFullWidthCharacter=r.containsUnusualLineTerminators=r.UNUSUAL_LINE_TERMINATORS=r.isBasicASCII=r.containsRTL=r.getCharContainingOffset=r.prevCharLength=r.nextCharLength=r.GraphemeIterator=r.CodePointIterator=r.getNextCodePoint=r.computeCodePoint=r.isLowSurrogate=r.isHighSurrogate=r.commonSuffixLength=r.commonPrefixLength=r.startsWithIgnoreCase=r.equalsIgnoreCase=r.isUpperAsciiLetter=r.isLowerAsciiLetter=r.isAsciiDigit=r.compareSubstringIgnoreCase=r.compareIgnoreCase=r.compareSubstring=r.compare=r.lastNonWhitespaceIndex=r.getLeadingWhitespace=r.firstNonWhitespaceIndex=r.splitLines=r.regExpFlags=r.regExpLeadsToEndlessLoop=r.createRegExp=r.stripWildcards=r.convertSimple2RegExpPattern=r.rtrim=r.ltrim=r.trim=r.escapeRegExpCharacters=r.escape=r.format=r.isFalsyOrWhitespace=void 0;function l(D){return!D||typeof D!="string"?!0:D.trim().length===0}r.isFalsyOrWhitespace=l;const p=/{(\d+)}/g;function C(D,...B){return B.length===0?D:D.replace(p,function(z,j){const K=parseInt(j,10);return isNaN(K)||K<0||K>=B.length?z:B[K]})}r.format=C;function o(D){return D.replace(/[<>&]/g,function(B){switch(B){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return B}})}r.escape=o;function f(D){return D.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}r.escapeRegExpCharacters=f;function S(D,B=" "){const z=t(D,B);return w(z,B)}r.trim=S;function t(D,B){if(!D||!B)return D;const z=B.length;if(z===0||D.length===0)return D;let j=0;for(;D.indexOf(B,j)===j;)j=j+z;return D.substring(j)}r.ltrim=t;function w(D,B){if(!D||!B)return D;const z=B.length,j=D.length;if(z===0||j===0)return D;let K=j,re=-1;for(;re=D.lastIndexOf(B,K-1),!(re===-1||re+z!==K);){if(re===0)return"";K=re}return D.substring(0,K)}r.rtrim=w;function h(D){return D.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}r.convertSimple2RegExpPattern=h;function m(D){return D.replace(/\*/g,"")}r.stripWildcards=m;function L(D,B,z={}){if(!D)throw new Error("Cannot create regex from empty string");B||(D=f(D)),z.wholeWord&&(/\B/.test(D.charAt(0))||(D="\\b"+D),/\B/.test(D.charAt(D.length-1))||(D=D+"\\b"));let j="";return z.global&&(j+="g"),z.matchCase||(j+="i"),z.multiline&&(j+="m"),z.unicode&&(j+="u"),new RegExp(D,j)}r.createRegExp=L;function y(D){return D.source==="^"||D.source==="^$"||D.source==="$"||D.source==="^\\s*$"?!1:!!(D.exec("")&&D.lastIndex===0)}r.regExpLeadsToEndlessLoop=y;function _(D){return(D.global?"g":"")+(D.ignoreCase?"i":"")+(D.multiline?"m":"")+(D.unicode?"u":"")}r.regExpFlags=_;function g(D){return D.split(/\r\n|\r|\n/)}r.splitLines=g;function v(D){for(let B=0,z=D.length;B<z;B++){const j=D.charCodeAt(B);if(j!==32&&j!==9)return B}return-1}r.firstNonWhitespaceIndex=v;function u(D,B=0,z=D.length){for(let j=B;j<z;j++){const K=D.charCodeAt(j);if(K!==32&&K!==9)return D.substring(B,j)}return D.substring(B,z)}r.getLeadingWhitespace=u;function d(D,B=D.length-1){for(let z=B;z>=0;z--){const j=D.charCodeAt(z);if(j!==32&&j!==9)return z}return-1}r.lastNonWhitespaceIndex=d;function s(D,B){return D<B?-1:D>B?1:0}r.compare=s;function a(D,B,z=0,j=D.length,K=0,re=B.length){for(;z<j&&K<re;z++,K++){const de=D.charCodeAt(z),ie=B.charCodeAt(K);if(de<ie)return-1;if(de>ie)return 1}const le=j-z,be=re-K;return le<be?-1:le>be?1:0}r.compareSubstring=a;function i(D,B){return c(D,B,0,D.length,0,B.length)}r.compareIgnoreCase=i;function c(D,B,z=0,j=D.length,K=0,re=B.length){for(;z<j&&K<re;z++,K++){let de=D.charCodeAt(z),ie=B.charCodeAt(K);if(de===ie)continue;if(de>=128||ie>=128)return a(D.toLowerCase(),B.toLowerCase(),z,j,K,re);N(de)&&(de-=32),N(ie)&&(ie-=32);const fe=de-ie;if(fe!==0)return fe}const le=j-z,be=re-K;return le<be?-1:le>be?1:0}r.compareSubstringIgnoreCase=c;function b(D){return D>=48&&D<=57}r.isAsciiDigit=b;function N(D){return D>=97&&D<=122}r.isLowerAsciiLetter=N;function M(D){return D>=65&&D<=90}r.isUpperAsciiLetter=M;function R(D,B){return D.length===B.length&&c(D,B)===0}r.equalsIgnoreCase=R;function P(D,B){const z=B.length;return B.length>D.length?!1:c(D,B,0,z)===0}r.startsWithIgnoreCase=P;function I(D,B){const z=Math.min(D.length,B.length);let j;for(j=0;j<z;j++)if(D.charCodeAt(j)!==B.charCodeAt(j))return j;return z}r.commonPrefixLength=I;function W(D,B){const z=Math.min(D.length,B.length);let j;const K=D.length-1,re=B.length-1;for(j=0;j<z;j++)if(D.charCodeAt(K-j)!==B.charCodeAt(re-j))return j;return z}r.commonSuffixLength=W;function O(D){return 55296<=D&&D<=56319}r.isHighSurrogate=O;function q(D){return 56320<=D&&D<=57343}r.isLowSurrogate=q;function Y(D,B){return(D-55296<<10)+(B-56320)+65536}r.computeCodePoint=Y;function k(D,B,z){const j=D.charCodeAt(z);if(O(j)&&z+1<B){const K=D.charCodeAt(z+1);if(q(K))return Y(j,K)}return j}r.getNextCodePoint=k;function U(D,B){const z=D.charCodeAt(B-1);if(q(z)&&B>1){const j=D.charCodeAt(B-2);if(O(j))return Y(j,z)}return z}class F{get offset(){return this.e}constructor(B,z=0){this.c=B,this.d=B.length,this.e=z}setOffset(B){this.e=B}prevCodePoint(){const B=U(this.c,this.e);return this.e-=B>=65536?2:1,B}nextCodePoint(){const B=k(this.c,this.d,this.e);return this.e+=B>=65536?2:1,B}eol(){return this.e>=this.d}}r.CodePointIterator=F;class V{get offset(){return this.c.offset}constructor(B,z=0){this.c=new F(B,z)}nextGraphemeLength(){const B=ne.getInstance(),z=this.c,j=z.offset;let K=B.getGraphemeBreakType(z.nextCodePoint());for(;!z.eol();){const re=z.offset,le=B.getGraphemeBreakType(z.nextCodePoint());if(te(K,le)){z.setOffset(re);break}K=le}return z.offset-j}prevGraphemeLength(){const B=ne.getInstance(),z=this.c,j=z.offset;let K=B.getGraphemeBreakType(z.prevCodePoint());for(;z.offset>0;){const re=z.offset,le=B.getGraphemeBreakType(z.prevCodePoint());if(te(le,K)){z.setOffset(re);break}K=le}return j-z.offset}eol(){return this.c.eol()}}r.GraphemeIterator=V;function n(D,B){return new V(D,B).nextGraphemeLength()}r.nextCharLength=n;function ae(D,B){return new V(D,B).prevGraphemeLength()}r.prevCharLength=ae;function oe(D,B){B>0&&q(D.charCodeAt(B))&&B--;const z=B+n(D,B);return[z-ae(D,z),z]}r.getCharContainingOffset=oe;let he;function we(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Se(D){return he||(he=we()),he.test(D)}r.containsRTL=Se;const Ne=/^[\t\n\r\x20-\x7E]*$/;function _e(D){return Ne.test(D)}r.isBasicASCII=_e,r.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Z(D){return r.UNUSUAL_LINE_TERMINATORS.test(D)}r.containsUnusualLineTerminators=Z;function H(D){return D>=11904&&D<=55215||D>=63744&&D<=64255||D>=65281&&D<=65374}r.isFullWidthCharacter=H;function G(D){return D>=127462&&D<=127487||D===8986||D===8987||D===9200||D===9203||D>=9728&&D<=10175||D===11088||D===11093||D>=127744&&D<=128591||D>=128640&&D<=128764||D>=128992&&D<=129008||D>=129280&&D<=129535||D>=129648&&D<=129782}r.isEmojiImprecise=G,r.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function $(D){return!!(D&&D.length>0&&D.charCodeAt(0)===65279)}r.startsWithUTF8BOM=$;function x(D,B=!1){return D?(B&&(D=D.replace(/\\./g,"")),D.toLowerCase()!==D):!1}r.containsUppercaseCharacter=x;function ee(D){return D=D%(2*26),D<26?String.fromCharCode(97+D):String.fromCharCode(65+D-26)}r.singleLetterHash=ee;function te(D,B){return D===0?B!==5&&B!==7:D===2&&B===3?!1:D===4||D===2||D===3||B===4||B===2||B===3?!0:!(D===8&&(B===8||B===9||B===11||B===12)||(D===11||D===9)&&(B===9||B===10)||(D===12||D===10)&&B===10||B===5||B===13||B===7||D===1||D===13&&B===14||D===6&&B===6)}class ne{static getInstance(){return ne.c||(ne.c=new ne),ne.c}constructor(){this.d=Ce()}getGraphemeBreakType(B){if(B<32)return B===10?3:B===13?2:4;if(B<127)return 0;const z=this.d,j=z.length/3;let K=1;for(;K<=j;)if(B<z[3*K])K=2*K;else if(B>z[3*K+1])K=2*K+1;else return z[3*K+2];return 0}}ne.c=null;function Ce(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Le(D,B){if(D===0)return 0;const z=pe(D,B);if(z!==void 0)return z;const j=new F(B,D);return j.prevCodePoint(),j.offset}r.getLeftDeleteOffset=Le;function pe(D,B){const z=new F(B,D);let j=z.prevCodePoint();for(;ve(j)||j===65039||j===8419;){if(z.offset===0)return;j=z.prevCodePoint()}if(!G(j))return;let K=z.offset;return K>0&&z.prevCodePoint()===8205&&(K=z.offset),K}function ve(D){return 127995<=D&&D<=127999}r.noBreakWhitespace="\xA0";class ce{static getInstance(B){return ce.d.get(Array.from(B))}static getLocales(){return ce.e.getValue()}constructor(B){this.f=B}isAmbiguous(B){return this.f.has(B)}getPrimaryConfusable(B){return this.f.get(B)}getConfusableCodePoints(){return new Set(this.f.keys())}}r.AmbiguousCharacters=ce,E=ce,ce.c=new e.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),ce.d=new A.LRUCachedFunction(D=>{function B(ie){const fe=new Map;for(let ge=0;ge<ie.length;ge+=2)fe.set(ie[ge],ie[ge+1]);return fe}function z(ie,fe){const ge=new Map(ie);for(const[ye,Ae]of fe)ge.set(ye,Ae);return ge}function j(ie,fe){if(!ie)return fe;const ge=new Map;for(const[ye,Ae]of ie)fe.has(ye)&&ge.set(ye,Ae);return ge}const K=E.c.getValue();let re=D.filter(ie=>!ie.startsWith("_")&&ie in K);re.length===0&&(re=["_default"]);let le;for(const ie of re){const fe=B(K[ie]);le=j(le,fe)}const be=B(K._common),de=z(be,le);return new ce(de)}),ce.e=new e.Lazy(()=>Object.keys(ce.c.getValue()).filter(D=>!D.startsWith("_")));class me{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(me.c())),this.d}static isInvisibleCharacter(B){return me.e().has(B)}static get codePoints(){return me.e()}}r.InvisibleCharacters=me,me.d=void 0}),X(Q[29],J([0,1,4]),function(T,r,A){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.StringSHA1=r.toHexString=r.stringHash=r.numberHash=r.doHash=r.hash=void 0;function e(L){return E(L,0)}r.hash=e;function E(L,y){switch(typeof L){case"object":return L===null?l(349,y):Array.isArray(L)?o(L,y):f(L,y);case"string":return C(L,y);case"boolean":return p(L,y);case"number":return l(L,y);case"undefined":return l(937,y);default:return l(617,y)}}r.doHash=E;function l(L,y){return(y<<5)-y+L|0}r.numberHash=l;function p(L,y){return l(L?433:863,y)}function C(L,y){y=l(149417,y);for(let _=0,g=L.length;_<g;_++)y=l(L.charCodeAt(_),y);return y}r.stringHash=C;function o(L,y){return y=l(104579,y),L.reduce((_,g)=>E(g,_),y)}function f(L,y){return y=l(181387,y),Object.keys(L).sort().reduce((_,g)=>(_=C(g,_),E(L[g],_)),y)}function S(L,y,_=32){const g=_-y,v=~((1<<g)-1);return(L<<y|(v&L)>>>g)>>>0}function t(L,y=0,_=L.byteLength,g=0){for(let v=0;v<_;v++)L[y+v]=g}function w(L,y,_="0"){for(;L.length<y;)L=_+L;return L}function h(L,y=32){return L instanceof ArrayBuffer?Array.from(new Uint8Array(L)).map(_=>_.toString(16).padStart(2,"0")).join(""):w((L>>>0).toString(16),y/4)}r.toHexString=h;class m{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(y){const _=y.length;if(_===0)return;const g=this.p;let v=this.r,u=this.u,d,s;for(u!==0?(d=u,s=-1,u=0):(d=y.charCodeAt(0),s=0);;){let a=d;if(A.isHighSurrogate(d))if(s+1<_){const i=y.charCodeAt(s+1);A.isLowSurrogate(i)?(s++,a=A.computeCodePoint(d,i)):a=65533}else{u=d;break}else A.isLowSurrogate(d)&&(a=65533);if(v=this.w(g,v,a),s++,s<_)d=y.charCodeAt(s);else break}this.r=v,this.u=u}w(y,_,g){return g<128?y[_++]=g:g<2048?(y[_++]=192|(g&1984)>>>6,y[_++]=128|(g&63)>>>0):g<65536?(y[_++]=224|(g&61440)>>>12,y[_++]=128|(g&4032)>>>6,y[_++]=128|(g&63)>>>0):(y[_++]=240|(g&1835008)>>>18,y[_++]=128|(g&258048)>>>12,y[_++]=128|(g&4032)>>>6,y[_++]=128|(g&63)>>>0),_>=64&&(this.y(),_-=64,this.t+=64,y[0]=y[64+0],y[1]=y[64+1],y[2]=y[64+2]),_}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),h(this.h)+h(this.l)+h(this.m)+h(this.n)+h(this.o)}x(){this.p[this.r++]=128,t(this.p,this.r),this.r>56&&(this.y(),t(this.p));const y=8*this.t;this.q.setUint32(56,Math.floor(y/4294967296),!1),this.q.setUint32(60,y%4294967296,!1),this.y()}y(){const y=m.g,_=this.q;for(let b=0;b<64;b+=4)y.setUint32(b,_.getUint32(b,!1),!1);for(let b=64;b<320;b+=4)y.setUint32(b,S(y.getUint32(b-12,!1)^y.getUint32(b-32,!1)^y.getUint32(b-56,!1)^y.getUint32(b-64,!1),1),!1);let g=this.h,v=this.l,u=this.m,d=this.n,s=this.o,a,i,c;for(let b=0;b<80;b++)b<20?(a=v&u|~v&d,i=1518500249):b<40?(a=v^u^d,i=1859775393):b<60?(a=v&u|v&d|u&d,i=2400959708):(a=v^u^d,i=3395469782),c=S(g,5)+a+s+i+y.getUint32(b*4,!1)&4294967295,s=d,d=u,u=S(v,30),v=g,g=c;this.h=this.h+g&4294967295,this.l=this.l+v&4294967295,this.m=this.m+u&4294967295,this.n=this.n+d&4294967295,this.o=this.o+s&4294967295}}r.StringSHA1=m,m.g=new DataView(new ArrayBuffer(320))}),X(Q[15],J([0,1,25,29]),function(T,r,A,e){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.LcsDiff=r.stringDiff=r.StringDiffSequence=void 0;class E{constructor(t){this.a=t}getElements(){const t=this.a,w=new Int32Array(t.length);for(let h=0,m=t.length;h<m;h++)w[h]=t.charCodeAt(h);return w}}r.StringDiffSequence=E;function l(S,t,w){return new f(new E(S),new E(t)).ComputeDiff(w).changes}r.stringDiff=l;class p{static Assert(t,w){if(!t)throw new Error(w)}}class C{static Copy(t,w,h,m,L){for(let y=0;y<L;y++)h[m+y]=t[w+y]}static Copy2(t,w,h,m,L){for(let y=0;y<L;y++)h[m+y]=t[w+y]}}class o{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new A.DiffChange(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(t,w){this.b=Math.min(this.b,t),this.c=Math.min(this.c,w),this.d++}AddModifiedElement(t,w){this.b=Math.min(this.b,t),this.c=Math.min(this.c,w),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class f{constructor(t,w,h=null){this.a=h,this.b=t,this.c=w;const[m,L,y]=f.o(t),[_,g,v]=f.o(w);this.d=y&&v,this.e=m,this.f=L,this.g=_,this.h=g,this.k=[],this.m=[]}static n(t){return t.length>0&&typeof t[0]=="string"}static o(t){const w=t.getElements();if(f.n(w)){const h=new Int32Array(w.length);for(let m=0,L=w.length;m<L;m++)h[m]=(0,e.stringHash)(w[m],0);return[w,h,!0]}return w instanceof Int32Array?[[],w,!1]:[[],new Int32Array(w),!1]}p(t,w){return this.f[t]!==this.h[w]?!1:this.d?this.e[t]===this.g[w]:!0}q(t,w){if(!this.p(t,w))return!1;const h=f.r(this.b,t),m=f.r(this.c,w);return h===m}static r(t,w){return typeof t.getStrictElement=="function"?t.getStrictElement(w):null}s(t,w){return this.f[t]!==this.f[w]?!1:this.d?this.e[t]===this.e[w]:!0}u(t,w){return this.h[t]!==this.h[w]?!1:this.d?this.g[t]===this.g[w]:!0}ComputeDiff(t){return this.v(0,this.f.length-1,0,this.h.length-1,t)}v(t,w,h,m,L){const y=[!1];let _=this.w(t,w,h,m,y);return L&&(_=this.z(_)),{quitEarly:y[0],changes:_}}w(t,w,h,m,L){for(L[0]=!1;t<=w&&h<=m&&this.p(t,h);)t++,h++;for(;w>=t&&m>=h&&this.p(w,m);)w--,m--;if(t>w||h>m){let d;return h<=m?(p.Assert(t===w+1,"originalStart should only be one more than originalEnd"),d=[new A.DiffChange(t,0,h,m-h+1)]):t<=w?(p.Assert(h===m+1,"modifiedStart should only be one more than modifiedEnd"),d=[new A.DiffChange(t,w-t+1,h,0)]):(p.Assert(t===w+1,"originalStart should only be one more than originalEnd"),p.Assert(h===m+1,"modifiedStart should only be one more than modifiedEnd"),d=[]),d}const y=[0],_=[0],g=this.y(t,w,h,m,y,_,L),v=y[0],u=_[0];if(g!==null)return g;if(!L[0]){const d=this.w(t,v,h,u,L);let s=[];return L[0]?s=[new A.DiffChange(v+1,w-(v+1)+1,u+1,m-(u+1)+1)]:s=this.w(v+1,w,u+1,m,L),this.H(d,s)}return[new A.DiffChange(t,w-t+1,h,m-h+1)]}x(t,w,h,m,L,y,_,g,v,u,d,s,a,i,c,b,N,M){let R=null,P=null,I=new o,W=w,O=h,q=a[0]-b[0]-m,Y=-1073741824,k=this.k.length-1;do{const U=q+t;U===W||U<O&&v[U-1]<v[U+1]?(d=v[U+1],i=d-q-m,d<Y&&I.MarkNextChange(),Y=d,I.AddModifiedElement(d+1,i),q=U+1-t):(d=v[U-1]+1,i=d-q-m,d<Y&&I.MarkNextChange(),Y=d-1,I.AddOriginalElement(d,i+1),q=U-1-t),k>=0&&(v=this.k[k],t=v[0],W=1,O=v.length-1)}while(--k>=-1);if(R=I.getReverseChanges(),M[0]){let U=a[0]+1,F=b[0]+1;if(R!==null&&R.length>0){const V=R[R.length-1];U=Math.max(U,V.getOriginalEnd()),F=Math.max(F,V.getModifiedEnd())}P=[new A.DiffChange(U,s-U+1,F,c-F+1)]}else{I=new o,W=y,O=_,q=a[0]-b[0]-g,Y=1073741824,k=N?this.m.length-1:this.m.length-2;do{const U=q+L;U===W||U<O&&u[U-1]>=u[U+1]?(d=u[U+1]-1,i=d-q-g,d>Y&&I.MarkNextChange(),Y=d+1,I.AddOriginalElement(d+1,i+1),q=U+1-L):(d=u[U-1],i=d-q-g,d>Y&&I.MarkNextChange(),Y=d,I.AddModifiedElement(d+1,i+1),q=U-1-L),k>=0&&(u=this.m[k],L=u[0],W=1,O=u.length-1)}while(--k>=-1);P=I.getChanges()}return this.H(R,P)}y(t,w,h,m,L,y,_){let g=0,v=0,u=0,d=0,s=0,a=0;t--,h--,L[0]=0,y[0]=0,this.k=[],this.m=[];const i=w-t+(m-h),c=i+1,b=new Int32Array(c),N=new Int32Array(c),M=m-h,R=w-t,P=t-h,I=w-m,O=(R-M)%2===0;b[M]=t,N[R]=w,_[0]=!1;for(let q=1;q<=i/2+1;q++){let Y=0,k=0;u=this.J(M-q,q,M,c),d=this.J(M+q,q,M,c);for(let F=u;F<=d;F+=2){F===u||F<d&&b[F-1]<b[F+1]?g=b[F+1]:g=b[F-1]+1,v=g-(F-M)-P;const V=g;for(;g<w&&v<m&&this.p(g+1,v+1);)g++,v++;if(b[F]=g,g+v>Y+k&&(Y=g,k=v),!O&&Math.abs(F-R)<=q-1&&g>=N[F])return L[0]=g,y[0]=v,V<=N[F]&&1447>0&&q<=1447+1?this.x(M,u,d,P,R,s,a,I,b,N,g,w,L,v,m,y,O,_):null}const U=(Y-t+(k-h)-q)/2;if(this.a!==null&&!this.a(Y,U))return _[0]=!0,L[0]=Y,y[0]=k,U>0&&1447>0&&q<=1447+1?this.x(M,u,d,P,R,s,a,I,b,N,g,w,L,v,m,y,O,_):(t++,h++,[new A.DiffChange(t,w-t+1,h,m-h+1)]);s=this.J(R-q,q,R,c),a=this.J(R+q,q,R,c);for(let F=s;F<=a;F+=2){F===s||F<a&&N[F-1]>=N[F+1]?g=N[F+1]-1:g=N[F-1],v=g-(F-R)-I;const V=g;for(;g>t&&v>h&&this.p(g,v);)g--,v--;if(N[F]=g,O&&Math.abs(F-M)<=q&&g<=b[F])return L[0]=g,y[0]=v,V>=b[F]&&1447>0&&q<=1447+1?this.x(M,u,d,P,R,s,a,I,b,N,g,w,L,v,m,y,O,_):null}if(q<=1447){let F=new Int32Array(d-u+2);F[0]=M-u+1,C.Copy2(b,u,F,1,d-u+1),this.k.push(F),F=new Int32Array(a-s+2),F[0]=R-s+1,C.Copy2(N,s,F,1,a-s+1),this.m.push(F)}}return this.x(M,u,d,P,R,s,a,I,b,N,g,w,L,v,m,y,O,_)}z(t){for(let w=0;w<t.length;w++){const h=t[w],m=w<t.length-1?t[w+1].originalStart:this.f.length,L=w<t.length-1?t[w+1].modifiedStart:this.h.length,y=h.originalLength>0,_=h.modifiedLength>0;for(;h.originalStart+h.originalLength<m&&h.modifiedStart+h.modifiedLength<L&&(!y||this.s(h.originalStart,h.originalStart+h.originalLength))&&(!_||this.u(h.modifiedStart,h.modifiedStart+h.modifiedLength));){const v=this.q(h.originalStart,h.modifiedStart);if(this.q(h.originalStart+h.originalLength,h.modifiedStart+h.modifiedLength)&&!v)break;h.originalStart++,h.modifiedStart++}const g=[null];if(w<t.length-1&&this.I(t[w],t[w+1],g)){t[w]=g[0],t.splice(w+1,1),w--;continue}}for(let w=t.length-1;w>=0;w--){const h=t[w];let m=0,L=0;if(w>0){const d=t[w-1];m=d.originalStart+d.originalLength,L=d.modifiedStart+d.modifiedLength}const y=h.originalLength>0,_=h.modifiedLength>0;let g=0,v=this.G(h.originalStart,h.originalLength,h.modifiedStart,h.modifiedLength);for(let d=1;;d++){const s=h.originalStart-d,a=h.modifiedStart-d;if(s<m||a<L||y&&!this.s(s,s+h.originalLength)||_&&!this.u(a,a+h.modifiedLength))break;const c=(s===m&&a===L?5:0)+this.G(s,h.originalLength,a,h.modifiedLength);c>v&&(v=c,g=d)}h.originalStart-=g,h.modifiedStart-=g;const u=[null];if(w>0&&this.I(t[w-1],t[w],u)){t[w-1]=u[0],t.splice(w,1),w++;continue}}if(this.d)for(let w=1,h=t.length;w<h;w++){const m=t[w-1],L=t[w],y=L.originalStart-m.originalStart-m.originalLength,_=m.originalStart,g=L.originalStart+L.originalLength,v=g-_,u=m.modifiedStart,d=L.modifiedStart+L.modifiedLength,s=d-u;if(y<5&&v<20&&s<20){const a=this.A(_,v,u,s,y);if(a){const[i,c]=a;(i!==m.originalStart+m.originalLength||c!==m.modifiedStart+m.modifiedLength)&&(m.originalLength=i-m.originalStart,m.modifiedLength=c-m.modifiedStart,L.originalStart=i+y,L.modifiedStart=c+y,L.originalLength=g-L.originalStart,L.modifiedLength=d-L.modifiedStart)}}}return t}A(t,w,h,m,L){if(w<L||m<L)return null;const y=t+w-L+1,_=h+m-L+1;let g=0,v=0,u=0;for(let d=t;d<y;d++)for(let s=h;s<_;s++){const a=this.B(d,s,L);a>0&&a>g&&(g=a,v=d,u=s)}return g>0?[v,u]:null}B(t,w,h){let m=0;for(let L=0;L<h;L++){if(!this.p(t+L,w+L))return 0;m+=this.e[t+L].length}return m}C(t){return t<=0||t>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[t])}D(t,w){if(this.C(t)||this.C(t-1))return!0;if(w>0){const h=t+w;if(this.C(h-1)||this.C(h))return!0}return!1}E(t){return t<=0||t>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[t])}F(t,w){if(this.E(t)||this.E(t-1))return!0;if(w>0){const h=t+w;if(this.E(h-1)||this.E(h))return!0}return!1}G(t,w,h,m){const L=this.D(t,w)?1:0,y=this.F(h,m)?1:0;return L+y}H(t,w){const h=[];if(t.length===0||w.length===0)return w.length>0?w:t;if(this.I(t[t.length-1],w[0],h)){const m=new Array(t.length+w.length-1);return C.Copy(t,0,m,0,t.length-1),m[t.length-1]=h[0],C.Copy(w,1,m,t.length,w.length-1),m}else{const m=new Array(t.length+w.length);return C.Copy(t,0,m,0,t.length),C.Copy(w,0,m,t.length,w.length),m}}I(t,w,h){if(p.Assert(t.originalStart<=w.originalStart,"Left change is not less than or equal to right change"),p.Assert(t.modifiedStart<=w.modifiedStart,"Left change is not less than or equal to right change"),t.originalStart+t.originalLength>=w.originalStart||t.modifiedStart+t.modifiedLength>=w.modifiedStart){const m=t.originalStart;let L=t.originalLength;const y=t.modifiedStart;let _=t.modifiedLength;return t.originalStart+t.originalLength>=w.originalStart&&(L=w.originalStart+w.originalLength-t.originalStart),t.modifiedStart+t.modifiedLength>=w.modifiedStart&&(_=w.modifiedStart+w.modifiedLength-t.modifiedStart),h[0]=new A.DiffChange(m,L,y,_),!0}else return h[0]=null,!1}J(t,w,h,m){if(t>=0&&t<m)return t;const L=h,y=m-h-1,_=w%2===0;if(t<0){const g=L%2===0;return _===g?0:1}else{const g=y%2===0;return _===g?m-1:m-2}}}r.LcsDiff=f}),X(Q[30],J([0,1]),function(T,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.withNullAsUndefined=r.validateConstraint=r.validateConstraints=r.isFunction=r.assertIsDefined=r.assertType=r.isUndefinedOrNull=r.isDefined=r.isUndefined=r.isBoolean=r.isIterable=r.isNumber=r.isTypedArray=r.isObject=r.isString=void 0;function A(_){return typeof _=="string"}r.isString=A;function e(_){return typeof _=="object"&&_!==null&&!Array.isArray(_)&&!(_ instanceof RegExp)&&!(_ instanceof Date)}r.isObject=e;function E(_){const g=Object.getPrototypeOf(Uint8Array);return typeof _=="object"&&_ instanceof g}r.isTypedArray=E;function l(_){return typeof _=="number"&&!isNaN(_)}r.isNumber=l;function p(_){return!!_&&typeof _[Symbol.iterator]=="function"}r.isIterable=p;function C(_){return _===!0||_===!1}r.isBoolean=C;function o(_){return typeof _>"u"}r.isUndefined=o;function f(_){return!S(_)}r.isDefined=f;function S(_){return o(_)||_===null}r.isUndefinedOrNull=S;function t(_,g){if(!_)throw new Error(g?`Unexpected type, expected '${g}'`:"Unexpected type")}r.assertType=t;function w(_){if(S(_))throw new Error("Assertion Failed: argument is undefined or null");return _}r.assertIsDefined=w;function h(_){return typeof _=="function"}r.isFunction=h;function m(_,g){const v=Math.min(_.length,g.length);for(let u=0;u<v;u++)L(_[u],g[u])}r.validateConstraints=m;function L(_,g){if(A(g)){if(typeof _!==g)throw new Error(`argument does not match constraint: typeof ${g}`)}else if(h(g)){try{if(_ instanceof g)return}catch{}if(!S(_)&&_.constructor===g||g.length===1&&g.call(void 0,_)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}r.validateConstraint=L;function y(_){return _===null?void 0:_}r.withNullAsUndefined=y}),X(Q[11],J([0,1,30]),function(T,r,A){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.createProxyObject=r.getAllMethodNames=r.getAllPropertyNames=r.equals=r.mixin=r.cloneAndChange=r.deepFreeze=r.deepClone=void 0;function e(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const m=Array.isArray(h)?[]:{};return Object.entries(h).forEach(([L,y])=>{m[L]=y&&typeof y=="object"?e(y):y}),m}r.deepClone=e;function E(h){if(!h||typeof h!="object")return h;const m=[h];for(;m.length>0;){const L=m.shift();Object.freeze(L);for(const y in L)if(l.call(L,y)){const _=L[y];typeof _=="object"&&!Object.isFrozen(_)&&!(0,A.isTypedArray)(_)&&m.push(_)}}return h}r.deepFreeze=E;const l=Object.prototype.hasOwnProperty;function p(h,m){return C(h,m,new Set)}r.cloneAndChange=p;function C(h,m,L){if((0,A.isUndefinedOrNull)(h))return h;const y=m(h);if(typeof y<"u")return y;if(Array.isArray(h)){const _=[];for(const g of h)_.push(C(g,m,L));return _}if((0,A.isObject)(h)){if(L.has(h))throw new Error("Cannot clone recursive data-structure");L.add(h);const _={};for(const g in h)l.call(h,g)&&(_[g]=C(h[g],m,L));return L.delete(h),_}return h}function o(h,m,L=!0){return(0,A.isObject)(h)?((0,A.isObject)(m)&&Object.keys(m).forEach(y=>{y in h?L&&((0,A.isObject)(h[y])&&(0,A.isObject)(m[y])?o(h[y],m[y],L):h[y]=m[y]):h[y]=m[y]}),h):m}r.mixin=o;function f(h,m){if(h===m)return!0;if(h==null||m===null||m===void 0||typeof h!=typeof m||typeof h!="object"||Array.isArray(h)!==Array.isArray(m))return!1;let L,y;if(Array.isArray(h)){if(h.length!==m.length)return!1;for(L=0;L<h.length;L++)if(!f(h[L],m[L]))return!1}else{const _=[];for(y in h)_.push(y);_.sort();const g=[];for(y in m)g.push(y);if(g.sort(),!f(_,g))return!1;for(L=0;L<_.length;L++)if(!f(h[_[L]],m[_[L]]))return!1}return!0}r.equals=f;function S(h){let m=[],L=Object.getPrototypeOf(h);for(;Object.prototype!==L;)m=m.concat(Object.getOwnPropertyNames(L)),L=Object.getPrototypeOf(L);return m}r.getAllPropertyNames=S;function t(h){const m=[];for(const L of S(h))typeof h[L]=="function"&&m.push(L);return m}r.getAllMethodNames=t;function w(h,m){const L=_=>function(){const g=Array.prototype.slice.call(arguments,0);return m(_,g)},y={};for(const _ of h)y[_]=L(_);return y}r.createProxyObject=w}),X(Q[16],J([0,1]),function(T,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.toUint32=r.toUint8=void 0;function A(E){return E<0?0:E>255?255:E|0}r.toUint8=A;function e(E){return E<0?0:E>4294967295?4294967295:E|0}r.toUint32=e}),X(Q[17],J([0,1,16]),function(T,r,A){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.CharacterSet=r.CharacterClassifier=void 0;class e{constructor(p){const C=(0,A.toUint8)(p);this.c=C,this.a=e.d(C),this.b=new Map}static d(p){const C=new Uint8Array(256);return C.fill(p),C}set(p,C){const o=(0,A.toUint8)(C);p>=0&&p<256?this.a[p]=o:this.b.set(p,o)}get(p){return p>=0&&p<256?this.a[p]:this.b.get(p)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}r.CharacterClassifier=e;class E{constructor(){this.a=new e(0)}add(p){this.a.set(p,1)}has(p){return this.a.get(p)===1}clear(){return this.a.clear()}}r.CharacterSet=E}),X(Q[3],J([0,1]),function(T,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.Position=void 0;class A{constructor(E,l){this.lineNumber=E,this.column=l}with(E=this.lineNumber,l=this.column){return E===this.lineNumber&&l===this.column?this:new A(E,l)}delta(E=0,l=0){return this.with(this.lineNumber+E,this.column+l)}equals(E){return A.equals(this,E)}static equals(E,l){return!E&&!l?!0:!!E&&!!l&&E.lineNumber===l.lineNumber&&E.column===l.column}isBefore(E){return A.isBefore(this,E)}static isBefore(E,l){return E.lineNumber<l.lineNumber?!0:l.lineNumber<E.lineNumber?!1:E.column<l.column}isBeforeOrEqual(E){return A.isBeforeOrEqual(this,E)}static isBeforeOrEqual(E,l){return E.lineNumber<l.lineNumber?!0:l.lineNumber<E.lineNumber?!1:E.column<=l.column}static compare(E,l){const p=E.lineNumber|0,C=l.lineNumber|0;if(p===C){const o=E.column|0,f=l.column|0;return o-f}return p-C}clone(){return new A(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(E){return new A(E.lineNumber,E.column)}static isIPosition(E){return E&&typeof E.lineNumber=="number"&&typeof E.column=="number"}}r.Position=A}),X(Q[2],J([0,1,3]),function(T,r,A){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.Range=void 0;class e{constructor(l,p,C,o){l>C||l===C&&p>o?(this.startLineNumber=C,this.startColumn=o,this.endLineNumber=l,this.endColumn=p):(this.startLineNumber=l,this.startColumn=p,this.endLineNumber=C,this.endColumn=o)}isEmpty(){return e.isEmpty(this)}static isEmpty(l){return l.startLineNumber===l.endLineNumber&&l.startColumn===l.endColumn}containsPosition(l){return e.containsPosition(this,l)}static containsPosition(l,p){return!(p.lineNumber<l.startLineNumber||p.lineNumber>l.endLineNumber||p.lineNumber===l.startLineNumber&&p.column<l.startColumn||p.lineNumber===l.endLineNumber&&p.column>l.endColumn)}static strictContainsPosition(l,p){return!(p.lineNumber<l.startLineNumber||p.lineNumber>l.endLineNumber||p.lineNumber===l.startLineNumber&&p.column<=l.startColumn||p.lineNumber===l.endLineNumber&&p.column>=l.endColumn)}containsRange(l){return e.containsRange(this,l)}static containsRange(l,p){return!(p.startLineNumber<l.startLineNumber||p.endLineNumber<l.startLineNumber||p.startLineNumber>l.endLineNumber||p.endLineNumber>l.endLineNumber||p.startLineNumber===l.startLineNumber&&p.startColumn<l.startColumn||p.endLineNumber===l.endLineNumber&&p.endColumn>l.endColumn)}strictContainsRange(l){return e.strictContainsRange(this,l)}static strictContainsRange(l,p){return!(p.startLineNumber<l.startLineNumber||p.endLineNumber<l.startLineNumber||p.startLineNumber>l.endLineNumber||p.endLineNumber>l.endLineNumber||p.startLineNumber===l.startLineNumber&&p.startColumn<=l.startColumn||p.endLineNumber===l.endLineNumber&&p.endColumn>=l.endColumn)}plusRange(l){return e.plusRange(this,l)}static plusRange(l,p){let C,o,f,S;return p.startLineNumber<l.startLineNumber?(C=p.startLineNumber,o=p.startColumn):p.startLineNumber===l.startLineNumber?(C=p.startLineNumber,o=Math.min(p.startColumn,l.startColumn)):(C=l.startLineNumber,o=l.startColumn),p.endLineNumber>l.endLineNumber?(f=p.endLineNumber,S=p.endColumn):p.endLineNumber===l.endLineNumber?(f=p.endLineNumber,S=Math.max(p.endColumn,l.endColumn)):(f=l.endLineNumber,S=l.endColumn),new e(C,o,f,S)}intersectRanges(l){return e.intersectRanges(this,l)}static intersectRanges(l,p){let C=l.startLineNumber,o=l.startColumn,f=l.endLineNumber,S=l.endColumn;const t=p.startLineNumber,w=p.startColumn,h=p.endLineNumber,m=p.endColumn;return C<t?(C=t,o=w):C===t&&(o=Math.max(o,w)),f>h?(f=h,S=m):f===h&&(S=Math.min(S,m)),C>f||C===f&&o>S?null:new e(C,o,f,S)}equalsRange(l){return e.equalsRange(this,l)}static equalsRange(l,p){return!l&&!p?!0:!!l&&!!p&&l.startLineNumber===p.startLineNumber&&l.startColumn===p.startColumn&&l.endLineNumber===p.endLineNumber&&l.endColumn===p.endColumn}getEndPosition(){return e.getEndPosition(this)}static getEndPosition(l){return new A.Position(l.endLineNumber,l.endColumn)}getStartPosition(){return e.getStartPosition(this)}static getStartPosition(l){return new A.Position(l.startLineNumber,l.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(l,p){return new e(this.startLineNumber,this.startColumn,l,p)}setStartPosition(l,p){return new e(l,p,this.endLineNumber,this.endColumn)}collapseToStart(){return e.collapseToStart(this)}static collapseToStart(l){return new e(l.startLineNumber,l.startColumn,l.startLineNumber,l.startColumn)}collapseToEnd(){return e.collapseToEnd(this)}static collapseToEnd(l){return new e(l.endLineNumber,l.endColumn,l.endLineNumber,l.endColumn)}delta(l){return new e(this.startLineNumber+l,this.startColumn,this.endLineNumber+l,this.endColumn)}static fromPositions(l,p=l){return new e(l.lineNumber,l.column,p.lineNumber,p.column)}static lift(l){return l?new e(l.startLineNumber,l.startColumn,l.endLineNumber,l.endColumn):null}static isIRange(l){return l&&typeof l.startLineNumber=="number"&&typeof l.startColumn=="number"&&typeof l.endLineNumber=="number"&&typeof l.endColumn=="number"}static areIntersectingOrTouching(l,p){return!(l.endLineNumber<p.startLineNumber||l.endLineNumber===p.startLineNumber&&l.endColumn<p.startColumn||p.endLineNumber<l.startLineNumber||p.endLineNumber===l.startLineNumber&&p.endColumn<l.startColumn)}static areIntersecting(l,p){return!(l.endLineNumber<p.startLineNumber||l.endLineNumber===p.startLineNumber&&l.endColumn<=p.startColumn||p.endLineNumber<l.startLineNumber||p.endLineNumber===l.startLineNumber&&p.endColumn<=l.startColumn)}static compareRangesUsingStarts(l,p){if(l&&p){const f=l.startLineNumber|0,S=p.startLineNumber|0;if(f===S){const t=l.startColumn|0,w=p.startColumn|0;if(t===w){const h=l.endLineNumber|0,m=p.endLineNumber|0;if(h===m){const L=l.endColumn|0,y=p.endColumn|0;return L-y}return h-m}return t-w}return f-S}return(l?1:0)-(p?1:0)}static compareRangesUsingEnds(l,p){return l.endLineNumber===p.endLineNumber?l.endColumn===p.endColumn?l.startLineNumber===p.startLineNumber?l.startColumn-p.startColumn:l.startLineNumber-p.startLineNumber:l.endColumn-p.endColumn:l.endLineNumber-p.endLineNumber}static spansMultipleLines(l){return l.endLineNumber>l.startLineNumber}toJSON(){return this}}r.Range=e}),X(Q[31],J([0,1,3,2]),function(T,r,A,e){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.Selection=void 0;class E extends e.Range{constructor(p,C,o,f){super(p,C,o,f),this.selectionStartLineNumber=p,this.selectionStartColumn=C,this.positionLineNumber=o,this.positionColumn=f}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(p){return E.selectionsEqual(this,p)}static selectionsEqual(p,C){return p.selectionStartLineNumber===C.selectionStartLineNumber&&p.selectionStartColumn===C.selectionStartColumn&&p.positionLineNumber===C.positionLineNumber&&p.positionColumn===C.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(p,C){return this.getDirection()===0?new E(this.startLineNumber,this.startColumn,p,C):new E(p,C,this.startLineNumber,this.startColumn)}getPosition(){return new A.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new A.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(p,C){return this.getDirection()===0?new E(p,C,this.endLineNumber,this.endColumn):new E(this.endLineNumber,this.endColumn,p,C)}static fromPositions(p,C=p){return new E(p.lineNumber,p.column,C.lineNumber,C.column)}static fromRange(p,C){return C===0?new E(p.startLineNumber,p.startColumn,p.endLineNumber,p.endColumn):new E(p.endLineNumber,p.endColumn,p.startLineNumber,p.startColumn)}static liftSelection(p){return new E(p.selectionStartLineNumber,p.selectionStartColumn,p.positionLineNumber,p.positionColumn)}static selectionsArrEqual(p,C){if(p&&!C||!p&&C)return!1;if(!p&&!C)return!0;if(p.length!==C.length)return!1;for(let o=0,f=p.length;o<f;o++)if(!this.selectionsEqual(p[o],C[o]))return!1;return!0}static isISelection(p){return p&&typeof p.selectionStartLineNumber=="number"&&typeof p.selectionStartColumn=="number"&&typeof p.positionLineNumber=="number"&&typeof p.positionColumn=="number"}static createWithDirection(p,C,o,f,S){return S===0?new E(p,C,o,f):new E(o,f,p,C)}}r.Selection=E}),X(Q[32],J([0,1,17]),function(T,r,A){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.getMapForWordSeparators=r.WordCharacterClassifier=void 0;class e extends A.CharacterClassifier{constructor(p){super(0);for(let C=0,o=p.length;C<o;C++)this.set(p.charCodeAt(C),2);this.set(32,1),this.set(9,1)}}r.WordCharacterClassifier=e;function E(l){const p={};return C=>(p.hasOwnProperty(C)||(p[C]=l(C)),p[C])}r.getMapForWordSeparators=E(l=>new e(l))}),X(Q[18],J([0,1,13,14]),function(T,r,A,e){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.getWordAtText=r.ensureValidWordDefinition=r.DEFAULT_WORD_REGEXP=r.USUAL_WORD_SEPARATORS=void 0,r.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function E(f=""){let S="(-?\\d*\\.\\d\\w*)|([^";for(const t of r.USUAL_WORD_SEPARATORS)f.indexOf(t)>=0||(S+="\\"+t);return S+="\\s]+)",new RegExp(S,"g")}r.DEFAULT_WORD_REGEXP=E();function l(f){let S=r.DEFAULT_WORD_REGEXP;if(f&&f instanceof RegExp)if(f.global)S=f;else{let t="g";f.ignoreCase&&(t+="i"),f.multiline&&(t+="m"),f.unicode&&(t+="u"),S=new RegExp(f.source,t)}return S.lastIndex=0,S}r.ensureValidWordDefinition=l;const p=new e.LinkedList;p.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function C(f,S,t,w,h){if(h||(h=A.Iterable.first(p)),t.length>h.maxLen){let g=f-h.maxLen/2;return g<0?g=0:w+=g,t=t.substring(g,f+h.maxLen/2),C(f,S,t,w,h)}const m=Date.now(),L=f-1-w;let y=-1,_=null;for(let g=1;!(Date.now()-m>=h.timeBudget);g++){const v=L-h.windowSize*g;S.lastIndex=Math.max(0,v);const u=o(S,t,L,y);if(!u&&_||(_=u,v<=0))break;y=v}if(_){const g={word:_[0],startColumn:w+1+_.index,endColumn:w+1+_.index+_[0].length};return S.lastIndex=0,g}return null}r.getWordAtText=C;function o(f,S,t,w){let h;for(;h=f.exec(S);){const m=h.index||0;if(m<=t&&f.lastIndex>=t)return h;if(w>0&&m>w)return null}return null}}),X(Q[6],J([0,1]),function(T,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.OffsetRange=r.SequenceDiff=void 0;class A{constructor(l,p){this.seq1Range=l,this.seq2Range=p}reverse(){return new A(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}}r.SequenceDiff=A;class e{constructor(l,p){this.start=l,this.endExclusive=p}get isEmpty(){return this.start===this.endExclusive}delta(l){return new e(this.start+l,this.endExclusive+l)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}join(l){return new e(Math.min(this.start,l.start),Math.max(this.endExclusive,l.endExclusive))}}r.OffsetRange=e}),X(Q[33],J([0,1,6]),function(T,r,A){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.shiftSequenceDiffs=r.joinSequenceDiffs=r.smoothenSequenceDiffs=r.optimizeSequenceDiffs=void 0;function e(o,f,S){let t=S;return t=l(o,f,t),t=p(o,f,t),t}r.optimizeSequenceDiffs=e;function E(o,f,S){const t=[];for(const w of S){const h=t[t.length-1];if(!h){t.push(w);continue}w.seq1Range.start-h.seq1Range.endExclusive<=2||w.seq2Range.start-h.seq2Range.endExclusive<=2?t[t.length-1]=new A.SequenceDiff(h.seq1Range.join(w.seq1Range),h.seq2Range.join(w.seq2Range)):t.push(w)}return t}r.smoothenSequenceDiffs=E;function l(o,f,S){const t=[];S.length>0&&t.push(S[0]);for(let w=1;w<S.length;w++){const h=t[t.length-1],m=S[w];if(m.seq1Range.isEmpty){let L=!0;const y=m.seq1Range.start-h.seq1Range.endExclusive;for(let _=1;_<=y;_++)if(f.getElement(m.seq2Range.start-_)!==f.getElement(m.seq2Range.endExclusive-_)){L=!1;break}if(L){t[t.length-1]=new A.SequenceDiff(h.seq1Range,new A.OffsetRange(h.seq2Range.start,m.seq2Range.endExclusive-y));continue}}t.push(m)}return t}r.joinSequenceDiffs=l;function p(o,f,S){if(!o.getBoundaryScore||!f.getBoundaryScore)return S;for(let t=0;t<S.length;t++){const w=S[t];if(w.seq1Range.isEmpty){const h=t>0?S[t-1].seq2Range.endExclusive:-1,m=t+1<S.length?S[t+1].seq2Range.start:f.length;S[t]=C(w,o,f,m,h)}else if(w.seq2Range.isEmpty){const h=t>0?S[t-1].seq1Range.endExclusive:-1,m=t+1<S.length?S[t+1].seq1Range.start:o.length;S[t]=C(w.reverse(),f,o,m,h).reverse()}}return S}r.shiftSequenceDiffs=p;function C(o,f,S,t,w){let m=1;for(;o.seq2Range.start-m>w&&S.getElement(o.seq2Range.start-m)===S.getElement(o.seq2Range.endExclusive-m)&&m<20;)m++;m--;let L=0;for(;o.seq2Range.start+L<t&&S.getElement(o.seq2Range.start+L)===S.getElement(o.seq2Range.endExclusive+L)&&L<20;)L++;if(m===0&&L===0)return o;let y=0,_=-1;for(let g=-m;g<=L;g++){const v=o.seq2Range.start+g,u=o.seq2Range.endExclusive+g,d=o.seq1Range.start+g,s=f.getBoundaryScore(d)+S.getBoundaryScore(v)+S.getBoundaryScore(u);s>_&&(_=s,y=g)}return y!==0?new A.SequenceDiff(o.seq1Range.delta(y),o.seq2Range.delta(y)):o}}),X(Q[34],J([0,1,6]),function(T,r,A){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.MyersDiffAlgorithm=void 0;class e{compute(o,f){if(o.length===0)return[new A.SequenceDiff(new A.OffsetRange(0,0),new A.OffsetRange(0,f.length))];if(f.length===0)return[new A.SequenceDiff(new A.OffsetRange(0,o.length),new A.OffsetRange(0,0))];function S(v,u){for(;v<o.length&&u<f.length&&o.getElement(v)===f.getElement(u);)v++,u++;return v}let t=0;const w=new l;w.set(0,S(0,0));const h=new p;h.set(0,w.get(0)===0?null:new E(null,0,0,w.get(0)));let m=0;e:for(;;)for(t++,m=-t;m<=t;m+=2){const v=m===t?-1:w.get(m+1),u=m===-t?-1:w.get(m-1)+1,d=Math.min(Math.max(v,u),o.length),s=d-m,a=S(d,s);w.set(m,a);const i=d===v?h.get(m+1):h.get(m-1);if(h.set(m,a!==d?new E(i,d,s,a-d):i),w.get(m)===o.length&&w.get(m)-m===f.length)break e}let L=h.get(m);const y=[];let _=o.length,g=f.length;for(;;){const v=L?L.x+L.length:0,u=L?L.y+L.length:0;if((v!==_||u!==g)&&y.push(new A.SequenceDiff(new A.OffsetRange(v,_),new A.OffsetRange(u,g))),!L)break;_=L.x,g=L.y,L=L.prev}return y.reverse(),y}}r.MyersDiffAlgorithm=e;class E{constructor(o,f,S,t){this.prev=o,this.x=f,this.y=S,this.length=t}}class l{constructor(){this.a=new Int32Array(10),this.b=new Int32Array(10)}get(o){return o<0?(o=-o-1,this.b[o]):this.a[o]}set(o,f){if(o<0){if(o=-o-1,o>=this.b.length){const S=this.b;this.b=new Int32Array(S.length*2),this.b.set(S)}this.b[o]=f}else{if(o>=this.a.length){const S=this.a;this.a=new Int32Array(S.length*2),this.a.set(S)}this.a[o]=f}}}class p{constructor(){this.a=[],this.b=[]}get(o){return o<0?(o=-o-1,this.b[o]):this.a[o]}set(o,f){o<0?(o=-o-1,this.b[o]=f):this.a[o]=f}}}),X(Q[35],J([0,1]),function(T,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.Array2D=void 0;class A{constructor(E,l){this.width=E,this.height=l,this.a=[],this.a=new Array(E*l)}get(E,l){return this.a[E+l*this.width]}set(E,l,p){this.a[E+l*this.width]=p}}r.Array2D=A}),X(Q[36],J([0,1,6,35]),function(T,r,A,e){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.DynamicProgrammingDiffing=void 0;class E{compute(p,C,o){const f=new e.Array2D(p.length,C.length),S=new e.Array2D(p.length,C.length),t=new e.Array2D(p.length,C.length);for(let g=0;g<p.length;g++)for(let v=0;v<C.length;v++){const u=g===0?0:f.get(g-1,v),d=v===0?0:f.get(g,v-1);let s;p.getElement(g)===C.getElement(v)?(g===0||v===0?s=0:s=f.get(g-1,v-1),g>0&&v>0&&S.get(g-1,v-1)===3&&(s+=t.get(g-1,v-1)),s+=o?o(g,v):1):s=-1;const a=Math.max(u,d,s);if(a===s){const i=g>0&&v>0?t.get(g-1,v-1):0;t.set(g,v,i+1),S.set(g,v,3)}else a===u?(t.set(g,v,0),S.set(g,v,1)):a===d&&(t.set(g,v,0),S.set(g,v,2));f.set(g,v,a)}const w=[];let h=p.length,m=C.length;function L(g,v){(g+1!==h||v+1!==m)&&w.push(new A.SequenceDiff(new A.OffsetRange(g+1,h),new A.OffsetRange(v+1,m))),h=g,m=v}let y=p.length-1,_=C.length-1;for(;y>=0&&_>=0;)S.get(y,_)===3?(L(y,_),y--,_--):S.get(y,_)===1?y--:_--;return L(-1,-1),w.reverse(),w}}r.DynamicProgrammingDiffing=E}),X(Q[19],J([0,1]),function(T,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.LineRange=r.RangeMapping=r.LineRangeMapping=void 0;class A{constructor(p,C,o){this.originalRange=p,this.modifiedRange=C,this.innerChanges=o}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}}r.LineRangeMapping=A;class e{constructor(p,C){this.originalRange=p,this.modifiedRange=C}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}}r.RangeMapping=e;class E{constructor(p,C){this.startLineNumber=p,this.endLineNumberExclusive=C}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(p){return new E(this.startLineNumber+p,this.endLineNumberExclusive+p)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(p){return new E(Math.min(this.startLineNumber,p.startLineNumber),Math.max(this.endLineNumberExclusive,p.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}}r.LineRange=E}),X(Q[37],J([0,1,15,19,4,2,9]),function(T,r,A,e,E,l,p){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.DiffComputer=r.SmartLinesDiffComputer=void 0;const C=3;class o{computeDiff(u,d,s){var a;const c=new L(u,d,{maxComputationTime:s.maxComputationTimeMs,shouldIgnoreTrimWhitespace:s.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),b=[];let N=null;for(const M of c.changes){let R;M.originalEndLineNumber===0?R=new e.LineRange(M.originalStartLineNumber+1,M.originalStartLineNumber+1):R=new e.LineRange(M.originalStartLineNumber,M.originalEndLineNumber+1);let P;M.modifiedEndLineNumber===0?P=new e.LineRange(M.modifiedStartLineNumber+1,M.modifiedStartLineNumber+1):P=new e.LineRange(M.modifiedStartLineNumber,M.modifiedEndLineNumber+1);let I=new e.LineRangeMapping(R,P,(a=M.charChanges)===null||a===void 0?void 0:a.map(W=>new e.RangeMapping(new l.Range(W.originalStartLineNumber,W.originalStartColumn,W.originalEndLineNumber,W.originalEndColumn),new l.Range(W.modifiedStartLineNumber,W.modifiedStartColumn,W.modifiedEndLineNumber,W.modifiedEndColumn))));N&&(N.modifiedRange.endLineNumberExclusive===I.modifiedRange.startLineNumber||N.originalRange.endLineNumberExclusive===I.originalRange.startLineNumber)&&(I=new e.LineRangeMapping(N.originalRange.join(I.originalRange),N.modifiedRange.join(I.modifiedRange),N.innerChanges&&I.innerChanges?N.innerChanges.concat(I.innerChanges):void 0),b.pop()),b.push(I),N=I}return(0,p.assertFn)(()=>(0,p.checkAdjacentItems)(b,(M,R)=>R.originalRange.startLineNumber-M.originalRange.endLineNumberExclusive===R.modifiedRange.startLineNumber-M.modifiedRange.endLineNumberExclusive&&M.originalRange.endLineNumberExclusive<R.originalRange.startLineNumber&&M.modifiedRange.endLineNumberExclusive<R.modifiedRange.startLineNumber)),{quitEarly:c.quitEarly,changes:b}}}r.SmartLinesDiffComputer=o;function f(v,u,d,s){return new A.LcsDiff(v,u,d).ComputeDiff(s)}class S{constructor(u){const d=[],s=[];for(let a=0,i=u.length;a<i;a++)d[a]=y(u[a],1),s[a]=_(u[a],1);this.lines=u,this.a=d,this.b=s}getElements(){const u=[];for(let d=0,s=this.lines.length;d<s;d++)u[d]=this.lines[d].substring(this.a[d]-1,this.b[d]-1);return u}getStrictElement(u){return this.lines[u]}getStartLineNumber(u){return u+1}getEndLineNumber(u){return u+1}createCharSequence(u,d,s){const a=[],i=[],c=[];let b=0;for(let N=d;N<=s;N++){const M=this.lines[N],R=u?this.a[N]:1,P=u?this.b[N]:M.length+1;for(let I=R;I<P;I++)a[b]=M.charCodeAt(I-1),i[b]=N+1,c[b]=I,b++;!u&&N<s&&(a[b]=10,i[b]=N+1,c[b]=M.length+1,b++)}return new t(a,i,c)}}class t{constructor(u,d,s){this.a=u,this.b=d,this.d=s}toString(){return"["+this.a.map((u,d)=>(u===10?"\\n":String.fromCharCode(u))+`-(${this.b[d]},${this.d[d]})`).join(", ")+"]"}e(u,d){if(u<0||u>=d.length)throw new Error("Illegal index")}getElements(){return this.a}getStartLineNumber(u){return u>0&&u===this.b.length?this.getEndLineNumber(u-1):(this.e(u,this.b),this.b[u])}getEndLineNumber(u){return u===-1?this.getStartLineNumber(u+1):(this.e(u,this.b),this.a[u]===10?this.b[u]+1:this.b[u])}getStartColumn(u){return u>0&&u===this.d.length?this.getEndColumn(u-1):(this.e(u,this.d),this.d[u])}getEndColumn(u){return u===-1?this.getStartColumn(u+1):(this.e(u,this.d),this.a[u]===10?1:this.d[u]+1)}}class w{constructor(u,d,s,a,i,c,b,N){this.originalStartLineNumber=u,this.originalStartColumn=d,this.originalEndLineNumber=s,this.originalEndColumn=a,this.modifiedStartLineNumber=i,this.modifiedStartColumn=c,this.modifiedEndLineNumber=b,this.modifiedEndColumn=N}static createFromDiffChange(u,d,s){const a=d.getStartLineNumber(u.originalStart),i=d.getStartColumn(u.originalStart),c=d.getEndLineNumber(u.originalStart+u.originalLength-1),b=d.getEndColumn(u.originalStart+u.originalLength-1),N=s.getStartLineNumber(u.modifiedStart),M=s.getStartColumn(u.modifiedStart),R=s.getEndLineNumber(u.modifiedStart+u.modifiedLength-1),P=s.getEndColumn(u.modifiedStart+u.modifiedLength-1);return new w(a,i,c,b,N,M,R,P)}}function h(v){if(v.length<=1)return v;const u=[v[0]];let d=u[0];for(let s=1,a=v.length;s<a;s++){const i=v[s],c=i.originalStart-(d.originalStart+d.originalLength),b=i.modifiedStart-(d.modifiedStart+d.modifiedLength);Math.min(c,b)<C?(d.originalLength=i.originalStart+i.originalLength-d.originalStart,d.modifiedLength=i.modifiedStart+i.modifiedLength-d.modifiedStart):(u.push(i),d=i)}return u}class m{constructor(u,d,s,a,i){this.originalStartLineNumber=u,this.originalEndLineNumber=d,this.modifiedStartLineNumber=s,this.modifiedEndLineNumber=a,this.charChanges=i}static createFromDiffResult(u,d,s,a,i,c,b){let N,M,R,P,I;if(d.originalLength===0?(N=s.getStartLineNumber(d.originalStart)-1,M=0):(N=s.getStartLineNumber(d.originalStart),M=s.getEndLineNumber(d.originalStart+d.originalLength-1)),d.modifiedLength===0?(R=a.getStartLineNumber(d.modifiedStart)-1,P=0):(R=a.getStartLineNumber(d.modifiedStart),P=a.getEndLineNumber(d.modifiedStart+d.modifiedLength-1)),c&&d.originalLength>0&&d.originalLength<20&&d.modifiedLength>0&&d.modifiedLength<20&&i()){const W=s.createCharSequence(u,d.originalStart,d.originalStart+d.originalLength-1),O=a.createCharSequence(u,d.modifiedStart,d.modifiedStart+d.modifiedLength-1);if(W.getElements().length>0&&O.getElements().length>0){let q=f(W,O,i,!0).changes;b&&(q=h(q)),I=[];for(let Y=0,k=q.length;Y<k;Y++)I.push(w.createFromDiffChange(q[Y],W,O))}}return new m(N,M,R,P,I)}}class L{constructor(u,d,s){this.a=s.shouldComputeCharChanges,this.b=s.shouldPostProcessCharChanges,this.d=s.shouldIgnoreTrimWhitespace,this.e=s.shouldMakePrettyDiff,this.f=u,this.g=d,this.h=new S(u),this.j=new S(d),this.k=g(s.maxComputationTime),this.l=g(s.maxComputationTime===0?0:Math.min(s.maxComputationTime,5e3))}computeDiff(){if(this.h.lines.length===1&&this.h.lines[0].length===0)return this.j.lines.length===1&&this.j.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.j.lines.length,charChanges:void 0}]};if(this.j.lines.length===1&&this.j.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.h.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const u=f(this.h,this.j,this.k,this.e),d=u.changes,s=u.quitEarly;if(this.d){const b=[];for(let N=0,M=d.length;N<M;N++)b.push(m.createFromDiffResult(this.d,d[N],this.h,this.j,this.l,this.a,this.b));return{quitEarly:s,changes:b}}const a=[];let i=0,c=0;for(let b=-1,N=d.length;b<N;b++){const M=b+1<N?d[b+1]:null,R=M?M.originalStart:this.f.length,P=M?M.modifiedStart:this.g.length;for(;i<R&&c<P;){const I=this.f[i],W=this.g[c];if(I!==W){{let O=y(I,1),q=y(W,1);for(;O>1&&q>1;){const Y=I.charCodeAt(O-2),k=W.charCodeAt(q-2);if(Y!==k)break;O--,q--}(O>1||q>1)&&this.m(a,i+1,1,O,c+1,1,q)}{let O=_(I,1),q=_(W,1);const Y=I.length+1,k=W.length+1;for(;O<Y&&q<k;){const U=I.charCodeAt(O-1),F=I.charCodeAt(q-1);if(U!==F)break;O++,q++}(O<Y||q<k)&&this.m(a,i+1,O,Y,c+1,q,k)}}i++,c++}M&&(a.push(m.createFromDiffResult(this.d,M,this.h,this.j,this.l,this.a,this.b)),i+=M.originalLength,c+=M.modifiedLength)}return{quitEarly:s,changes:a}}m(u,d,s,a,i,c,b){if(this.n(u,d,s,a,i,c,b))return;let N;this.a&&(N=[new w(d,s,d,a,i,c,i,b)]),u.push(new m(d,d,i,i,N))}n(u,d,s,a,i,c,b){const N=u.length;if(N===0)return!1;const M=u[N-1];return M.originalEndLineNumber===0||M.modifiedEndLineNumber===0?!1:M.originalEndLineNumber+1===d&&M.modifiedEndLineNumber+1===i?(M.originalEndLineNumber=d,M.modifiedEndLineNumber=i,this.a&&M.charChanges&&M.charChanges.push(new w(d,s,d,a,i,c,i,b)),!0):!1}}r.DiffComputer=L;function y(v,u){const d=E.firstNonWhitespaceIndex(v);return d===-1?u:d+1}function _(v,u){const d=E.lastNonWhitespaceIndex(v);return d===-1?u:d+2}function g(v){if(v===0)return()=>!0;const u=Date.now();return()=>Date.now()-u<v}}),X(Q[38],J([0,1,9,3,2,6,36,33,34,19]),function(T,r,A,e,E,l,p,C,o,f){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.LineSequence=r.lineRangeMappingFromRangeMappings=r.StandardLinesDiffComputer=void 0;class S{constructor(){this.b=new p.DynamicProgrammingDiffing,this.c=new o.MyersDiffAlgorithm}computeDiff(d,s,a){const i=new Map;function c(k){let U=i.get(k);return U===void 0&&(U=i.size,i.set(k,U)),U}const b=d.map(k=>c(k.trim())),N=s.map(k=>c(k.trim())),M=new h(b,d),R=new h(N,s);let P=(()=>M.length+R.length<1500?this.b.compute(M,R,(k,U)=>d[k]===s[U]?s[U].length===0?.1:1+Math.log(1+s[U].length):.99):this.c.compute(M,R))();P=(0,C.optimizeSequenceDiffs)(M,R,P);const I=[],W=k=>{for(let U=0;U<k;U++){const F=O+U,V=q+U;if(d[F]!==s[V]){const n=this.e(d,s,new l.SequenceDiff(new l.OffsetRange(F,F+1),new l.OffsetRange(V,V+1)));for(const ae of n)I.push(ae)}}};let O=0,q=0;for(const k of P){(0,A.assertFn)(()=>k.seq1Range.start-O===k.seq2Range.start-q);const U=k.seq1Range.start-O;W(U),O=k.seq1Range.endExclusive,q=k.seq2Range.endExclusive;const F=this.e(d,s,k);for(const V of F)I.push(V)}W(d.length-O);const Y=t(I);return{quitEarly:!1,changes:Y}}e(d,s,a){const i=new L(d,a.seq1Range),c=new L(s,a.seq2Range),b=i.length+c.length<500?this.b.compute(i,c):this.c.compute(i,c);let N=(0,C.optimizeSequenceDiffs)(i,c,b);return N=(0,C.smoothenSequenceDiffs)(i,c,N),N.map(R=>new f.RangeMapping(i.translateRange(R.seq1Range).delta(a.seq1Range.start),c.translateRange(R.seq2Range).delta(a.seq2Range.start)))}}r.StandardLinesDiffComputer=S;function t(u){const d=[];for(const s of w(u,(a,i)=>i.originalRange.startLineNumber-(a.originalRange.endLineNumber-(a.originalRange.endColumn>1?0:1))<=1||i.modifiedRange.startLineNumber-(a.modifiedRange.endLineNumber-(a.modifiedRange.endColumn>1?0:1))<=1)){const a=s[0],i=s[s.length-1];d.push(new f.LineRangeMapping(new f.LineRange(a.originalRange.startLineNumber,i.originalRange.endLineNumber+(i.originalRange.endColumn>1||i.modifiedRange.endColumn>1?1:0)),new f.LineRange(a.modifiedRange.startLineNumber,i.modifiedRange.endLineNumber+(i.originalRange.endColumn>1||i.modifiedRange.endColumn>1?1:0)),s))}return(0,A.assertFn)(()=>(0,A.checkAdjacentItems)(d,(s,a)=>a.originalRange.startLineNumber-s.originalRange.endLineNumberExclusive===a.modifiedRange.startLineNumber-s.modifiedRange.endLineNumberExclusive&&s.originalRange.endLineNumberExclusive<a.originalRange.startLineNumber&&s.modifiedRange.endLineNumberExclusive<a.modifiedRange.startLineNumber)),d}r.lineRangeMappingFromRangeMappings=t;function*w(u,d){let s,a;for(const i of u)a!==void 0&&d(a,i)?s.push(i):(s&&(yield s),s=[i]),a=i;s&&(yield s)}class h{constructor(d,s){this.b=d,this.c=s}getElement(d){return this.b[d]}get length(){return this.b.length}getBoundaryScore(d){const s=d===0?0:m(this.c[d-1]),a=d===this.c.length?0:m(this.c[d]);return 1e3-(s+a)}}r.LineSequence=h;function m(u){let d=0;for(;d<u.length&&(u.charCodeAt(d)===32||u.charCodeAt(d)===9);)d++;return d}class L{constructor(d,s){this.lines=d,this.lineRange=s;let a=0;this.c=new Int32Array(s.length);for(let c=s.start;c<s.endExclusive;c++)a+=d[c].length,this.c[c-s.start]=a+1,a++;this.b=new Int32Array(a);let i=0;for(let c=s.start;c<s.endExclusive;c++){const b=d[c];for(let N=0;N<b.length;N++)this.b[i+N]=b.charCodeAt(N);i+=b.length,c<d.length-1&&(this.b[i]=`
`.charCodeAt(0),i+=1)}}getElement(d){return this.b[d]}get length(){return this.b.length}getBoundaryScore(d){const s=g(d>0?this.b[d-1]:-1),a=g(d<this.b.length?this.b[d]:-1);if(s===6&&a===7)return 0;let i=0;return s!==a&&(i+=10,a===1&&(i+=1)),i+=_(s),i+=_(a),i}translateOffset(d){let s=0,a=this.c.length;for(;s<a;){const c=Math.floor((s+a)/2);this.c[c]>d?a=c:s=c+1}const i=s===0?0:this.c[s-1];return new e.Position(s+1,d-i+1)}translateRange(d){return E.Range.fromPositions(this.translateOffset(d.start),this.translateOffset(d.endExclusive))}}const y={[0]:0,[1]:0,[2]:0,[3]:10,[4]:2,[5]:3,[6]:10,[7]:10};function _(u){return y[u]}function g(u){return u===10?7:u===13?6:v(u)?5:u>=97&&u<=122?0:u>=65&&u<=90?1:u>=48&&u<=57?2:u===-1?3:4}function v(u){return u===32||u===9}}),X(Q[39],J([0,1,37,38]),function(T,r,A,e){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.linesDiffComputers=void 0,r.linesDiffComputers={smart:new A.SmartLinesDiffComputer,experimental:new e.StandardLinesDiffComputer}}),X(Q[40],J([0,1,17]),function(T,r,A){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.computeLinks=r.LinkComputer=r.StateMachine=void 0;class e{constructor(w,h,m){const L=new Uint8Array(w*h);for(let y=0,_=w*h;y<_;y++)L[y]=m;this.a=L,this.rows=w,this.cols=h}get(w,h){return this.a[w*this.cols+h]}set(w,h,m){this.a[w*this.cols+h]=m}}class E{constructor(w){let h=0,m=0;for(let y=0,_=w.length;y<_;y++){const[g,v,u]=w[y];v>h&&(h=v),g>m&&(m=g),u>m&&(m=u)}h++,m++;const L=new e(m,h,0);for(let y=0,_=w.length;y<_;y++){const[g,v,u]=w[y];L.set(g,v,u)}this.a=L,this.b=h}nextState(w,h){return h<0||h>=this.b?0:this.a.get(w,h)}}r.StateMachine=E;let l=null;function p(){return l===null&&(l=new E([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),l}let C=null;function o(){if(C===null){C=new A.CharacterClassifier(0);const t=`, 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let h=0;h<t.length;h++)C.set(t.charCodeAt(h),1);const w=".;:";for(let h=0;h<w.length;h++)C.set(w.charCodeAt(h),2)}return C}class f{static a(w,h,m,L,y){let _=y-1;do{const g=h.charCodeAt(_);if(w.get(g)!==2)break;_--}while(_>L);if(L>0){const g=h.charCodeAt(L-1),v=h.charCodeAt(_);(g===40&&v===41||g===91&&v===93||g===123&&v===125)&&_--}return{range:{startLineNumber:m,startColumn:L+1,endLineNumber:m,endColumn:_+2},url:h.substring(L,_+1)}}static computeLinks(w,h=p()){const m=o(),L=[];for(let y=1,_=w.getLineCount();y<=_;y++){const g=w.getLineContent(y),v=g.length;let u=0,d=0,s=0,a=1,i=!1,c=!1,b=!1,N=!1;for(;u<v;){let M=!1;const R=g.charCodeAt(u);if(a===13){let P;switch(R){case 40:i=!0,P=0;break;case 41:P=i?0:1;break;case 91:b=!0,c=!0,P=0;break;case 93:b=!1,P=c?0:1;break;case 123:N=!0,P=0;break;case 125:P=N?0:1;break;case 39:case 34:case 96:s===R?P=1:s===39||s===34||s===96?P=0:P=1;break;case 42:P=s===42?1:0;break;case 124:P=s===124?1:0;break;case 32:P=b?0:1;break;default:P=m.get(R)}P===1&&(L.push(f.a(m,g,y,d,u)),M=!0)}else if(a===12){let P;R===91?(c=!0,P=0):P=m.get(R),P===1?M=!0:a=13}else a=h.nextState(a,R),a===0&&(M=!0);M&&(a=1,i=!1,c=!1,N=!1,d=u+1,s=R),u++}a===13&&L.push(f.a(m,g,y,d,v))}return L}}r.LinkComputer=f;function S(t){return!t||typeof t.getLineCount!="function"||typeof t.getLineContent!="function"?[]:f.computeLinks(t)}r.computeLinks=S}),X(Q[41],J([0,1]),function(T,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.BasicInplaceReplace=void 0;class A{constructor(){this.c=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(E,l,p,C,o){if(E&&l){const f=this.a(l,o);if(f)return{range:E,value:f}}if(p&&C){const f=this.a(C,o);if(f)return{range:p,value:f}}return null}a(E,l){const p=this.b(E,l);return p!==null?p:this.d(E,l)}b(E,l){const p=Math.pow(10,E.length-(E.lastIndexOf(".")+1));let C=Number(E);const o=parseFloat(E);return!isNaN(C)&&!isNaN(o)&&C===o?C===0&&!l?null:(C=Math.floor(C*p),C+=l?p:-p,String(C/p)):null}d(E,l){return this.e(this.c,E,l)}e(E,l,p){let C=null;for(let o=0,f=E.length;C===null&&o<f;o++)C=this.f(E[o],l,p);return C}f(E,l,p){let C=E.indexOf(l);return C>=0?(C+=p?1:-1,C<0?C=E.length-1:C%=E.length,E[C]):null}}r.BasicInplaceReplace=A,A.INSTANCE=new A}),X(Q[42],J([0,1,11]),function(T,r,A){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.shouldSynchronizeModel=r.ApplyEditsResult=r.SearchData=r.ValidAnnotatedEditOperation=r.isITextSnapshot=r.FindMatch=r.TextModelResolvedOptions=r.InjectedTextCursorStops=r.MinimapPosition=r.OverviewRulerLane=void 0;var e;(function(h){h[h.Left=1]="Left",h[h.Center=2]="Center",h[h.Right=4]="Right",h[h.Full=7]="Full"})(e=r.OverviewRulerLane||(r.OverviewRulerLane={}));var E;(function(h){h[h.Inline=1]="Inline",h[h.Gutter=2]="Gutter"})(E=r.MinimapPosition||(r.MinimapPosition={}));var l;(function(h){h[h.Both=0]="Both",h[h.Right=1]="Right",h[h.Left=2]="Left",h[h.None=3]="None"})(l=r.InjectedTextCursorStops||(r.InjectedTextCursorStops={}));class p{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(m){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,m.tabSize|0),m.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,m.indentSize|0),this.a=!1),this.insertSpaces=Boolean(m.insertSpaces),this.defaultEOL=m.defaultEOL|0,this.trimAutoWhitespace=Boolean(m.trimAutoWhitespace),this.bracketPairColorizationOptions=m.bracketPairColorizationOptions}equals(m){return this.tabSize===m.tabSize&&this.a===m.a&&this.indentSize===m.indentSize&&this.insertSpaces===m.insertSpaces&&this.defaultEOL===m.defaultEOL&&this.trimAutoWhitespace===m.trimAutoWhitespace&&(0,A.equals)(this.bracketPairColorizationOptions,m.bracketPairColorizationOptions)}createChangeEvent(m){return{tabSize:this.tabSize!==m.tabSize,indentSize:this.indentSize!==m.indentSize,insertSpaces:this.insertSpaces!==m.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==m.trimAutoWhitespace}}}r.TextModelResolvedOptions=p;class C{constructor(m,L){this._findMatchBrand=void 0,this.range=m,this.matches=L}}r.FindMatch=C;function o(h){return h&&typeof h.read=="function"}r.isITextSnapshot=o;class f{constructor(m,L,y,_,g,v){this.identifier=m,this.range=L,this.text=y,this.forceMoveMarkers=_,this.isAutoWhitespaceEdit=g,this._isTracked=v}}r.ValidAnnotatedEditOperation=f;class S{constructor(m,L,y){this.regex=m,this.wordSeparators=L,this.simpleSearch=y}}r.SearchData=S;class t{constructor(m,L,y){this.reverseEdits=m,this.changes=L,this.trimAutoWhitespaceLineNumbers=y}}r.ApplyEditsResult=t;function w(h){return!h.isTooLargeForSyncing()&&!h.isForSimpleWidget}r.shouldSynchronizeModel=w}),X(Q[43],J([0,1,22,16]),function(T,r,A,e){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.PrefixSumIndexOfResult=r.ConstantTimePrefixSumComputer=r.PrefixSumComputer=void 0;class E{constructor(o){this.a=o,this.b=new Uint32Array(o.length),this.c=new Int32Array(1),this.c[0]=-1}insertValues(o,f){o=(0,e.toUint32)(o);const S=this.a,t=this.b,w=f.length;return w===0?!1:(this.a=new Uint32Array(S.length+w),this.a.set(S.subarray(0,o),0),this.a.set(S.subarray(o),o+w),this.a.set(f,o),o-1<this.c[0]&&(this.c[0]=o-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(t.subarray(0,this.c[0]+1)),!0)}setValue(o,f){return o=(0,e.toUint32)(o),f=(0,e.toUint32)(f),this.a[o]===f?!1:(this.a[o]=f,o-1<this.c[0]&&(this.c[0]=o-1),!0)}removeValues(o,f){o=(0,e.toUint32)(o),f=(0,e.toUint32)(f);const S=this.a,t=this.b;if(o>=S.length)return!1;const w=S.length-o;return f>=w&&(f=w),f===0?!1:(this.a=new Uint32Array(S.length-f),this.a.set(S.subarray(0,o),0),this.a.set(S.subarray(o+f),o),this.b=new Uint32Array(this.a.length),o-1<this.c[0]&&(this.c[0]=o-1),this.c[0]>=0&&this.b.set(t.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(o){return o<0?0:(o=(0,e.toUint32)(o),this.d(o))}d(o){if(o<=this.c[0])return this.b[o];let f=this.c[0]+1;f===0&&(this.b[0]=this.a[0],f++),o>=this.a.length&&(o=this.a.length-1);for(let S=f;S<=o;S++)this.b[S]=this.b[S-1]+this.a[S];return this.c[0]=Math.max(this.c[0],o),this.b[o]}getIndexOf(o){o=Math.floor(o),this.getTotalSum();let f=0,S=this.a.length-1,t=0,w=0,h=0;for(;f<=S;)if(t=f+(S-f)/2|0,w=this.b[t],h=w-this.a[t],o<h)S=t-1;else if(o>=w)f=t+1;else break;return new p(t,o-h)}}r.PrefixSumComputer=E;class l{constructor(o){this.a=o,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(o){return this.g(),o===0?0:this.d[o-1]}getIndexOf(o){this.g();const f=this.e[o],S=f>0?this.d[f-1]:0;return new p(f,o-S)}removeValues(o,f){this.a.splice(o,f),this.f(o)}insertValues(o,f){this.a=(0,A.arrayInsert)(this.a,o,f),this.f(o)}f(o){this.b=!1,this.c=Math.min(this.c,o-1)}g(){if(!this.b){for(let o=this.c+1,f=this.a.length;o<f;o++){const S=this.a[o],t=o>0?this.d[o-1]:0;this.d[o]=t+S;for(let w=0;w<S;w++)this.e[t+w]=o}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(o,f){this.a[o]!==f&&(this.a[o]=f,this.f(o))}}r.ConstantTimePrefixSumComputer=l;class p{constructor(o,f){this.index=o,this.remainder=f,this._prefixSumIndexOfResultBrand=void 0,this.index=o,this.remainder=f}}r.PrefixSumIndexOfResult=p}),X(Q[44],J([0,1,4,3,43]),function(T,r,A,e,E){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.MirrorTextModel=void 0;class l{constructor(C,o,f,S){this.c=C,this.d=o,this.f=f,this.g=S,this.h=null,this.j=null}dispose(){this.d.length=0}get version(){return this.g}getText(){return this.j===null&&(this.j=this.d.join(this.f)),this.j}onEvents(C){C.eol&&C.eol!==this.f&&(this.f=C.eol,this.h=null);const o=C.changes;for(const f of o)this.n(f.range),this.o(new e.Position(f.range.startLineNumber,f.range.startColumn),f.text);this.g=C.versionId,this.j=null}k(){if(!this.h){const C=this.f.length,o=this.d.length,f=new Uint32Array(o);for(let S=0;S<o;S++)f[S]=this.d[S].length+C;this.h=new E.PrefixSumComputer(f)}}l(C,o){this.d[C]=o,this.h&&this.h.setValue(C,this.d[C].length+this.f.length)}n(C){if(C.startLineNumber===C.endLineNumber){if(C.startColumn===C.endColumn)return;this.l(C.startLineNumber-1,this.d[C.startLineNumber-1].substring(0,C.startColumn-1)+this.d[C.startLineNumber-1].substring(C.endColumn-1));return}this.l(C.startLineNumber-1,this.d[C.startLineNumber-1].substring(0,C.startColumn-1)+this.d[C.endLineNumber-1].substring(C.endColumn-1)),this.d.splice(C.startLineNumber,C.endLineNumber-C.startLineNumber),this.h&&this.h.removeValues(C.startLineNumber,C.endLineNumber-C.startLineNumber)}o(C,o){if(o.length===0)return;const f=(0,A.splitLines)(o);if(f.length===1){this.l(C.lineNumber-1,this.d[C.lineNumber-1].substring(0,C.column-1)+f[0]+this.d[C.lineNumber-1].substring(C.column-1));return}f[f.length-1]+=this.d[C.lineNumber-1].substring(C.column-1),this.l(C.lineNumber-1,this.d[C.lineNumber-1].substring(0,C.column-1)+f[0]);const S=new Uint32Array(f.length-1);for(let t=1;t<f.length;t++)this.d.splice(C.lineNumber+t-1,0,f[t]),S[t-1]=f[t].length+this.f.length;this.h&&this.h.insertValues(C.lineNumber,S)}}r.MirrorTextModel=l}),X(Q[45],J([0,1,4,32,3,2,42]),function(T,r,A,e,E,l,p){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.Searcher=r.isValidMatch=r.TextModelSearch=r.createFindMatch=r.isMultilineRegexSource=r.SearchParams=void 0;const C=999;class o{constructor(g,v,u,d){this.searchString=g,this.isRegex=v,this.matchCase=u,this.wordSeparators=d}parseSearchRequest(){if(this.searchString==="")return null;let g;this.isRegex?g=f(this.searchString):g=this.searchString.indexOf(`
`)>=0;let v=null;try{v=A.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:g,global:!0,unicode:!0})}catch{return null}if(!v)return null;let u=!this.isRegex&&!g;return u&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(u=this.matchCase),new p.SearchData(v,this.wordSeparators?(0,e.getMapForWordSeparators)(this.wordSeparators):null,u?this.searchString:null)}}r.SearchParams=o;function f(_){if(!_||_.length===0)return!1;for(let g=0,v=_.length;g<v;g++){const u=_.charCodeAt(g);if(u===10)return!0;if(u===92){if(g++,g>=v)break;const d=_.charCodeAt(g);if(d===110||d===114||d===87)return!0}}return!1}r.isMultilineRegexSource=f;function S(_,g,v){if(!v)return new p.FindMatch(_,null);const u=[];for(let d=0,s=g.length;d<s;d++)u[d]=g[d];return new p.FindMatch(_,u)}r.createFindMatch=S;class t{constructor(g){const v=[];let u=0;for(let d=0,s=g.length;d<s;d++)g.charCodeAt(d)===10&&(v[u++]=d);this.a=v}findLineFeedCountBeforeOffset(g){const v=this.a;let u=0,d=v.length-1;if(d===-1||g<=v[0])return 0;for(;u<d;){const s=u+((d-u)/2>>0);v[s]>=g?d=s-1:v[s+1]>=g?(u=s,d=s):u=s+1}return u+1}}class w{static findMatches(g,v,u,d,s){const a=v.parseSearchRequest();return a?a.regex.multiline?this.b(g,u,new y(a.wordSeparators,a.regex),d,s):this.c(g,u,a,d,s):[]}static a(g,v,u,d,s,a){let i,c=0;d?(c=d.findLineFeedCountBeforeOffset(s),i=v+s+c):i=v+s;let b;if(d){const P=d.findLineFeedCountBeforeOffset(s+a.length)-c;b=i+a.length+P}else b=i+a.length;const N=g.getPositionAt(i),M=g.getPositionAt(b);return new l.Range(N.lineNumber,N.column,M.lineNumber,M.column)}static b(g,v,u,d,s){const a=g.getOffsetAt(v.getStartPosition()),i=g.getValueInRange(v,1),c=g.getEOL()===`\r
`?new t(i):null,b=[];let N=0,M;for(u.reset(0);M=u.next(i);)if(b[N++]=S(this.a(g,a,i,c,M.index,M[0]),M,d),N>=s)return b;return b}static c(g,v,u,d,s){const a=[];let i=0;if(v.startLineNumber===v.endLineNumber){const b=g.getLineContent(v.startLineNumber).substring(v.startColumn-1,v.endColumn-1);return i=this.d(u,b,v.startLineNumber,v.startColumn-1,i,a,d,s),a}const c=g.getLineContent(v.startLineNumber).substring(v.startColumn-1);i=this.d(u,c,v.startLineNumber,v.startColumn-1,i,a,d,s);for(let b=v.startLineNumber+1;b<v.endLineNumber&&i<s;b++)i=this.d(u,g.getLineContent(b),b,0,i,a,d,s);if(i<s){const b=g.getLineContent(v.endLineNumber).substring(0,v.endColumn-1);i=this.d(u,b,v.endLineNumber,0,i,a,d,s)}return a}static d(g,v,u,d,s,a,i,c){const b=g.wordSeparators;if(!i&&g.simpleSearch){const R=g.simpleSearch,P=R.length,I=v.length;let W=-P;for(;(W=v.indexOf(R,W+P))!==-1;)if((!b||L(b,v,I,W,P))&&(a[s++]=new p.FindMatch(new l.Range(u,W+1+d,u,W+1+P+d),null),s>=c))return s;return s}const N=new y(g.wordSeparators,g.regex);let M;N.reset(0);do if(M=N.next(v),M&&(a[s++]=S(new l.Range(u,M.index+1+d,u,M.index+1+M[0].length+d),M,i),s>=c))return s;while(M);return s}static findNextMatch(g,v,u,d){const s=v.parseSearchRequest();if(!s)return null;const a=new y(s.wordSeparators,s.regex);return s.regex.multiline?this.e(g,u,a,d):this.f(g,u,a,d)}static e(g,v,u,d){const s=new E.Position(v.lineNumber,1),a=g.getOffsetAt(s),i=g.getLineCount(),c=g.getValueInRange(new l.Range(s.lineNumber,s.column,i,g.getLineMaxColumn(i)),1),b=g.getEOL()===`\r
`?new t(c):null;u.reset(v.column-1);const N=u.next(c);return N?S(this.a(g,a,c,b,N.index,N[0]),N,d):v.lineNumber!==1||v.column!==1?this.e(g,new E.Position(1,1),u,d):null}static f(g,v,u,d){const s=g.getLineCount(),a=v.lineNumber,i=g.getLineContent(a),c=this.g(u,i,a,v.column,d);if(c)return c;for(let b=1;b<=s;b++){const N=(a+b-1)%s,M=g.getLineContent(N+1),R=this.g(u,M,N+1,1,d);if(R)return R}return null}static g(g,v,u,d,s){g.reset(d-1);const a=g.next(v);return a?S(new l.Range(u,a.index+1,u,a.index+1+a[0].length),a,s):null}static findPreviousMatch(g,v,u,d){const s=v.parseSearchRequest();if(!s)return null;const a=new y(s.wordSeparators,s.regex);return s.regex.multiline?this.h(g,u,a,d):this.j(g,u,a,d)}static h(g,v,u,d){const s=this.b(g,new l.Range(1,1,v.lineNumber,v.column),u,d,10*C);if(s.length>0)return s[s.length-1];const a=g.getLineCount();return v.lineNumber!==a||v.column!==g.getLineMaxColumn(a)?this.h(g,new E.Position(a,g.getLineMaxColumn(a)),u,d):null}static j(g,v,u,d){const s=g.getLineCount(),a=v.lineNumber,i=g.getLineContent(a).substring(0,v.column-1),c=this.k(u,i,a,d);if(c)return c;for(let b=1;b<=s;b++){const N=(s+a-b-1)%s,M=g.getLineContent(N+1),R=this.k(u,M,N+1,d);if(R)return R}return null}static k(g,v,u,d){let s=null,a;for(g.reset(0);a=g.next(v);)s=S(new l.Range(u,a.index+1,u,a.index+1+a[0].length),a,d);return s}}r.TextModelSearch=w;function h(_,g,v,u,d){if(u===0)return!0;const s=g.charCodeAt(u-1);if(_.get(s)!==0||s===13||s===10)return!0;if(d>0){const a=g.charCodeAt(u);if(_.get(a)!==0)return!0}return!1}function m(_,g,v,u,d){if(u+d===v)return!0;const s=g.charCodeAt(u+d);if(_.get(s)!==0||s===13||s===10)return!0;if(d>0){const a=g.charCodeAt(u+d-1);if(_.get(a)!==0)return!0}return!1}function L(_,g,v,u,d){return h(_,g,v,u,d)&&m(_,g,v,u,d)}r.isValidMatch=L;class y{constructor(g,v){this._wordSeparators=g,this.a=v,this.b=-1,this.c=0}reset(g){this.a.lastIndex=g,this.b=-1,this.c=0}next(g){const v=g.length;let u;do{if(this.b+this.c===v||(u=this.a.exec(g),!u))return null;const d=u.index,s=u[0].length;if(d===this.b&&s===this.c){if(s===0){A.getNextCodePoint(g,v,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=d,this.c=s,!this._wordSeparators||L(this._wordSeparators,g,v,d,s))return u}while(u);return null}}r.Searcher=y}),X(Q[46],J([0,1,2,45,4,9,18]),function(T,r,A,e,E,l,p){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.UnicodeTextModelHighlighter=void 0;class C{static computeUnicodeHighlights(w,h,m){const L=m?m.startLineNumber:1,y=m?m.endLineNumber:w.getLineCount(),_=new f(h),g=_.getCandidateCodePoints();let v;g==="allNonBasicAscii"?v=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):v=new RegExp(`${o(Array.from(g))}`,"g");const u=new e.Searcher(null,v),d=[];let s=!1,a,i=0,c=0,b=0;e:for(let N=L,M=y;N<=M;N++){const R=w.getLineContent(N),P=R.length;u.reset(0);do if(a=u.next(R),a){let I=a.index,W=a.index+a[0].length;if(I>0){const k=R.charCodeAt(I-1);E.isHighSurrogate(k)&&I--}if(W+1<P){const k=R.charCodeAt(W-1);E.isHighSurrogate(k)&&W++}const O=R.substring(I,W);let q=(0,p.getWordAtText)(I+1,p.DEFAULT_WORD_REGEXP,R,0);q&&q.endColumn<=I+1&&(q=null);const Y=_.shouldHighlightNonBasicASCII(O,q?q.word:null);if(Y!==0){Y===3?i++:Y===2?c++:Y===1?b++:(0,l.assertNever)(Y);const k=1e3;if(d.length>=k){s=!0;break e}d.push(new A.Range(N,I+1,N,W+1))}}while(a)}return{ranges:d,hasMore:s,ambiguousCharacterCount:i,invisibleCharacterCount:c,nonBasicAsciiCharacterCount:b}}static computeUnicodeHighlightReason(w,h){const m=new f(h);switch(m.shouldHighlightNonBasicASCII(w,null)){case 0:return null;case 2:return{kind:1};case 3:{const y=w.codePointAt(0),_=m.ambiguousCharacters.getPrimaryConfusable(y),g=E.AmbiguousCharacters.getLocales().filter(v=>!E.AmbiguousCharacters.getInstance(new Set([...h.allowedLocales,v])).isAmbiguous(y));return{kind:0,confusableWith:String.fromCodePoint(_),notAmbiguousInLocales:g}}case 1:return{kind:2}}}}r.UnicodeTextModelHighlighter=C;function o(t,w){return`[${E.escapeRegExpCharacters(t.map(m=>String.fromCodePoint(m)).join(""))}]`}class f{constructor(w){this.b=w,this.a=new Set(w.allowedCodePoints),this.ambiguousCharacters=E.AmbiguousCharacters.getInstance(new Set(w.allowedLocales))}getCandidateCodePoints(){if(this.b.nonBasicASCII)return"allNonBasicAscii";const w=new Set;if(this.b.invisibleCharacters)for(const h of E.InvisibleCharacters.codePoints)S(String.fromCodePoint(h))||w.add(h);if(this.b.ambiguousCharacters)for(const h of this.ambiguousCharacters.getConfusableCodePoints())w.add(h);for(const h of this.a)w.delete(h);return w}shouldHighlightNonBasicASCII(w,h){const m=w.codePointAt(0);if(this.a.has(m))return 0;if(this.b.nonBasicASCII)return 1;let L=!1,y=!1;if(h)for(const _ of h){const g=_.codePointAt(0),v=E.isBasicASCII(_);L=L||v,!v&&!this.ambiguousCharacters.isAmbiguous(g)&&!E.InvisibleCharacters.isInvisibleCharacter(g)&&(y=!0)}return!L&&y?0:this.b.invisibleCharacters&&!S(w)&&E.InvisibleCharacters.isInvisibleCharacter(m)?2:this.b.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(m)?3:0}}function S(t){return t===" "||t===`
`||t==="	"}}),X(Q[47],J([0,1]),function(T,r){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.WrappingIndent=r.TrackedRangeStickiness=r.TextEditorCursorStyle=r.TextEditorCursorBlinkingStyle=r.SymbolTag=r.SymbolKind=r.SignatureHelpTriggerKind=r.SelectionDirection=r.ScrollbarVisibility=r.ScrollType=r.RenderMinimap=r.RenderLineNumbersType=r.PositionAffinity=r.OverviewRulerLane=r.OverlayWidgetPositionPreference=r.MouseTargetType=r.MinimapPosition=r.MarkerTag=r.MarkerSeverity=r.KeyCode=r.InlineCompletionTriggerKind=r.InlayHintKind=r.InjectedTextCursorStops=r.IndentAction=r.EndOfLineSequence=r.EndOfLinePreference=r.EditorOption=r.EditorAutoIndentStrategy=r.DocumentHighlightKind=r.DefaultEndOfLine=r.CursorChangeReason=r.ContentWidgetPositionPreference=r.CompletionTriggerKind=r.CompletionItemTag=r.CompletionItemKind=r.CompletionItemInsertTextRule=r.CodeActionTriggerType=r.AccessibilitySupport=void 0;var A;(function(n){n[n.Unknown=0]="Unknown",n[n.Disabled=1]="Disabled",n[n.Enabled=2]="Enabled"})(A=r.AccessibilitySupport||(r.AccessibilitySupport={}));var e;(function(n){n[n.Invoke=1]="Invoke",n[n.Auto=2]="Auto"})(e=r.CodeActionTriggerType||(r.CodeActionTriggerType={}));var E;(function(n){n[n.None=0]="None",n[n.KeepWhitespace=1]="KeepWhitespace",n[n.InsertAsSnippet=4]="InsertAsSnippet"})(E=r.CompletionItemInsertTextRule||(r.CompletionItemInsertTextRule={}));var l;(function(n){n[n.Method=0]="Method",n[n.Function=1]="Function",n[n.Constructor=2]="Constructor",n[n.Field=3]="Field",n[n.Variable=4]="Variable",n[n.Class=5]="Class",n[n.Struct=6]="Struct",n[n.Interface=7]="Interface",n[n.Module=8]="Module",n[n.Property=9]="Property",n[n.Event=10]="Event",n[n.Operator=11]="Operator",n[n.Unit=12]="Unit",n[n.Value=13]="Value",n[n.Constant=14]="Constant",n[n.Enum=15]="Enum",n[n.EnumMember=16]="EnumMember",n[n.Keyword=17]="Keyword",n[n.Text=18]="Text",n[n.Color=19]="Color",n[n.File=20]="File",n[n.Reference=21]="Reference",n[n.Customcolor=22]="Customcolor",n[n.Folder=23]="Folder",n[n.TypeParameter=24]="TypeParameter",n[n.User=25]="User",n[n.Issue=26]="Issue",n[n.Snippet=27]="Snippet"})(l=r.CompletionItemKind||(r.CompletionItemKind={}));var p;(function(n){n[n.Deprecated=1]="Deprecated"})(p=r.CompletionItemTag||(r.CompletionItemTag={}));var C;(function(n){n[n.Invoke=0]="Invoke",n[n.TriggerCharacter=1]="TriggerCharacter",n[n.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(C=r.CompletionTriggerKind||(r.CompletionTriggerKind={}));var o;(function(n){n[n.EXACT=0]="EXACT",n[n.ABOVE=1]="ABOVE",n[n.BELOW=2]="BELOW"})(o=r.ContentWidgetPositionPreference||(r.ContentWidgetPositionPreference={}));var f;(function(n){n[n.NotSet=0]="NotSet",n[n.ContentFlush=1]="ContentFlush",n[n.RecoverFromMarkers=2]="RecoverFromMarkers",n[n.Explicit=3]="Explicit",n[n.Paste=4]="Paste",n[n.Undo=5]="Undo",n[n.Redo=6]="Redo"})(f=r.CursorChangeReason||(r.CursorChangeReason={}));var S;(function(n){n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(S=r.DefaultEndOfLine||(r.DefaultEndOfLine={}));var t;(function(n){n[n.Text=0]="Text",n[n.Read=1]="Read",n[n.Write=2]="Write"})(t=r.DocumentHighlightKind||(r.DocumentHighlightKind={}));var w;(function(n){n[n.None=0]="None",n[n.Keep=1]="Keep",n[n.Brackets=2]="Brackets",n[n.Advanced=3]="Advanced",n[n.Full=4]="Full"})(w=r.EditorAutoIndentStrategy||(r.EditorAutoIndentStrategy={}));var h;(function(n){n[n.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",n[n.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",n[n.accessibilitySupport=2]="accessibilitySupport",n[n.accessibilityPageSize=3]="accessibilityPageSize",n[n.ariaLabel=4]="ariaLabel",n[n.autoClosingBrackets=5]="autoClosingBrackets",n[n.autoClosingDelete=6]="autoClosingDelete",n[n.autoClosingOvertype=7]="autoClosingOvertype",n[n.autoClosingQuotes=8]="autoClosingQuotes",n[n.autoIndent=9]="autoIndent",n[n.automaticLayout=10]="automaticLayout",n[n.autoSurround=11]="autoSurround",n[n.bracketPairColorization=12]="bracketPairColorization",n[n.guides=13]="guides",n[n.codeLens=14]="codeLens",n[n.codeLensFontFamily=15]="codeLensFontFamily",n[n.codeLensFontSize=16]="codeLensFontSize",n[n.colorDecorators=17]="colorDecorators",n[n.colorDecoratorsLimit=18]="colorDecoratorsLimit",n[n.columnSelection=19]="columnSelection",n[n.comments=20]="comments",n[n.contextmenu=21]="contextmenu",n[n.copyWithSyntaxHighlighting=22]="copyWithSyntaxHighlighting",n[n.cursorBlinking=23]="cursorBlinking",n[n.cursorSmoothCaretAnimation=24]="cursorSmoothCaretAnimation",n[n.cursorStyle=25]="cursorStyle",n[n.cursorSurroundingLines=26]="cursorSurroundingLines",n[n.cursorSurroundingLinesStyle=27]="cursorSurroundingLinesStyle",n[n.cursorWidth=28]="cursorWidth",n[n.disableLayerHinting=29]="disableLayerHinting",n[n.disableMonospaceOptimizations=30]="disableMonospaceOptimizations",n[n.domReadOnly=31]="domReadOnly",n[n.dragAndDrop=32]="dragAndDrop",n[n.dropIntoEditor=33]="dropIntoEditor",n[n.emptySelectionClipboard=34]="emptySelectionClipboard",n[n.experimentalWhitespaceRendering=35]="experimentalWhitespaceRendering",n[n.extraEditorClassName=36]="extraEditorClassName",n[n.fastScrollSensitivity=37]="fastScrollSensitivity",n[n.find=38]="find",n[n.fixedOverflowWidgets=39]="fixedOverflowWidgets",n[n.folding=40]="folding",n[n.foldingStrategy=41]="foldingStrategy",n[n.foldingHighlight=42]="foldingHighlight",n[n.foldingImportsByDefault=43]="foldingImportsByDefault",n[n.foldingMaximumRegions=44]="foldingMaximumRegions",n[n.unfoldOnClickAfterEndOfLine=45]="unfoldOnClickAfterEndOfLine",n[n.fontFamily=46]="fontFamily",n[n.fontInfo=47]="fontInfo",n[n.fontLigatures=48]="fontLigatures",n[n.fontSize=49]="fontSize",n[n.fontWeight=50]="fontWeight",n[n.fontVariations=51]="fontVariations",n[n.formatOnPaste=52]="formatOnPaste",n[n.formatOnType=53]="formatOnType",n[n.glyphMargin=54]="glyphMargin",n[n.gotoLocation=55]="gotoLocation",n[n.hideCursorInOverviewRuler=56]="hideCursorInOverviewRuler",n[n.hover=57]="hover",n[n.inDiffEditor=58]="inDiffEditor",n[n.inlineSuggest=59]="inlineSuggest",n[n.letterSpacing=60]="letterSpacing",n[n.lightbulb=61]="lightbulb",n[n.lineDecorationsWidth=62]="lineDecorationsWidth",n[n.lineHeight=63]="lineHeight",n[n.lineNumbers=64]="lineNumbers",n[n.lineNumbersMinChars=65]="lineNumbersMinChars",n[n.linkedEditing=66]="linkedEditing",n[n.links=67]="links",n[n.matchBrackets=68]="matchBrackets",n[n.minimap=69]="minimap",n[n.mouseStyle=70]="mouseStyle",n[n.mouseWheelScrollSensitivity=71]="mouseWheelScrollSensitivity",n[n.mouseWheelZoom=72]="mouseWheelZoom",n[n.multiCursorMergeOverlapping=73]="multiCursorMergeOverlapping",n[n.multiCursorModifier=74]="multiCursorModifier",n[n.multiCursorPaste=75]="multiCursorPaste",n[n.multiCursorLimit=76]="multiCursorLimit",n[n.occurrencesHighlight=77]="occurrencesHighlight",n[n.overviewRulerBorder=78]="overviewRulerBorder",n[n.overviewRulerLanes=79]="overviewRulerLanes",n[n.padding=80]="padding",n[n.parameterHints=81]="parameterHints",n[n.peekWidgetDefaultFocus=82]="peekWidgetDefaultFocus",n[n.definitionLinkOpensInPeek=83]="definitionLinkOpensInPeek",n[n.quickSuggestions=84]="quickSuggestions",n[n.quickSuggestionsDelay=85]="quickSuggestionsDelay",n[n.readOnly=86]="readOnly",n[n.renameOnType=87]="renameOnType",n[n.renderControlCharacters=88]="renderControlCharacters",n[n.renderFinalNewline=89]="renderFinalNewline",n[n.renderLineHighlight=90]="renderLineHighlight",n[n.renderLineHighlightOnlyWhenFocus=91]="renderLineHighlightOnlyWhenFocus",n[n.renderValidationDecorations=92]="renderValidationDecorations",n[n.renderWhitespace=93]="renderWhitespace",n[n.revealHorizontalRightPadding=94]="revealHorizontalRightPadding",n[n.roundedSelection=95]="roundedSelection",n[n.rulers=96]="rulers",n[n.scrollbar=97]="scrollbar",n[n.scrollBeyondLastColumn=98]="scrollBeyondLastColumn",n[n.scrollBeyondLastLine=99]="scrollBeyondLastLine",n[n.scrollPredominantAxis=100]="scrollPredominantAxis",n[n.selectionClipboard=101]="selectionClipboard",n[n.selectionHighlight=102]="selectionHighlight",n[n.selectOnLineNumbers=103]="selectOnLineNumbers",n[n.showFoldingControls=104]="showFoldingControls",n[n.showUnused=105]="showUnused",n[n.snippetSuggestions=106]="snippetSuggestions",n[n.smartSelect=107]="smartSelect",n[n.smoothScrolling=108]="smoothScrolling",n[n.stickyScroll=109]="stickyScroll",n[n.stickyTabStops=110]="stickyTabStops",n[n.stopRenderingLineAfter=111]="stopRenderingLineAfter",n[n.suggest=112]="suggest",n[n.suggestFontSize=113]="suggestFontSize",n[n.suggestLineHeight=114]="suggestLineHeight",n[n.suggestOnTriggerCharacters=115]="suggestOnTriggerCharacters",n[n.suggestSelection=116]="suggestSelection",n[n.tabCompletion=117]="tabCompletion",n[n.tabIndex=118]="tabIndex",n[n.unicodeHighlighting=119]="unicodeHighlighting",n[n.unusualLineTerminators=120]="unusualLineTerminators",n[n.useShadowDOM=121]="useShadowDOM",n[n.useTabStops=122]="useTabStops",n[n.wordBreak=123]="wordBreak",n[n.wordSeparators=124]="wordSeparators",n[n.wordWrap=125]="wordWrap",n[n.wordWrapBreakAfterCharacters=126]="wordWrapBreakAfterCharacters",n[n.wordWrapBreakBeforeCharacters=127]="wordWrapBreakBeforeCharacters",n[n.wordWrapColumn=128]="wordWrapColumn",n[n.wordWrapOverride1=129]="wordWrapOverride1",n[n.wordWrapOverride2=130]="wordWrapOverride2",n[n.wrappingIndent=131]="wrappingIndent",n[n.wrappingStrategy=132]="wrappingStrategy",n[n.showDeprecated=133]="showDeprecated",n[n.inlayHints=134]="inlayHints",n[n.editorClassName=135]="editorClassName",n[n.pixelRatio=136]="pixelRatio",n[n.tabFocusMode=137]="tabFocusMode",n[n.layoutInfo=138]="layoutInfo",n[n.wrappingInfo=139]="wrappingInfo"})(h=r.EditorOption||(r.EditorOption={}));var m;(function(n){n[n.TextDefined=0]="TextDefined",n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(m=r.EndOfLinePreference||(r.EndOfLinePreference={}));var L;(function(n){n[n.LF=0]="LF",n[n.CRLF=1]="CRLF"})(L=r.EndOfLineSequence||(r.EndOfLineSequence={}));var y;(function(n){n[n.None=0]="None",n[n.Indent=1]="Indent",n[n.IndentOutdent=2]="IndentOutdent",n[n.Outdent=3]="Outdent"})(y=r.IndentAction||(r.IndentAction={}));var _;(function(n){n[n.Both=0]="Both",n[n.Right=1]="Right",n[n.Left=2]="Left",n[n.None=3]="None"})(_=r.InjectedTextCursorStops||(r.InjectedTextCursorStops={}));var g;(function(n){n[n.Type=1]="Type",n[n.Parameter=2]="Parameter"})(g=r.InlayHintKind||(r.InlayHintKind={}));var v;(function(n){n[n.Automatic=0]="Automatic",n[n.Explicit=1]="Explicit"})(v=r.InlineCompletionTriggerKind||(r.InlineCompletionTriggerKind={}));var u;(function(n){n[n.DependsOnKbLayout=-1]="DependsOnKbLayout",n[n.Unknown=0]="Unknown",n[n.Backspace=1]="Backspace",n[n.Tab=2]="Tab",n[n.Enter=3]="Enter",n[n.Shift=4]="Shift",n[n.Ctrl=5]="Ctrl",n[n.Alt=6]="Alt",n[n.PauseBreak=7]="PauseBreak",n[n.CapsLock=8]="CapsLock",n[n.Escape=9]="Escape",n[n.Space=10]="Space",n[n.PageUp=11]="PageUp",n[n.PageDown=12]="PageDown",n[n.End=13]="End",n[n.Home=14]="Home",n[n.LeftArrow=15]="LeftArrow",n[n.UpArrow=16]="UpArrow",n[n.RightArrow=17]="RightArrow",n[n.DownArrow=18]="DownArrow",n[n.Insert=19]="Insert",n[n.Delete=20]="Delete",n[n.Digit0=21]="Digit0",n[n.Digit1=22]="Digit1",n[n.Digit2=23]="Digit2",n[n.Digit3=24]="Digit3",n[n.Digit4=25]="Digit4",n[n.Digit5=26]="Digit5",n[n.Digit6=27]="Digit6",n[n.Digit7=28]="Digit7",n[n.Digit8=29]="Digit8",n[n.Digit9=30]="Digit9",n[n.KeyA=31]="KeyA",n[n.KeyB=32]="KeyB",n[n.KeyC=33]="KeyC",n[n.KeyD=34]="KeyD",n[n.KeyE=35]="KeyE",n[n.KeyF=36]="KeyF",n[n.KeyG=37]="KeyG",n[n.KeyH=38]="KeyH",n[n.KeyI=39]="KeyI",n[n.KeyJ=40]="KeyJ",n[n.KeyK=41]="KeyK",n[n.KeyL=42]="KeyL",n[n.KeyM=43]="KeyM",n[n.KeyN=44]="KeyN",n[n.KeyO=45]="KeyO",n[n.KeyP=46]="KeyP",n[n.KeyQ=47]="KeyQ",n[n.KeyR=48]="KeyR",n[n.KeyS=49]="KeyS",n[n.KeyT=50]="KeyT",n[n.KeyU=51]="KeyU",n[n.KeyV=52]="KeyV",n[n.KeyW=53]="KeyW",n[n.KeyX=54]="KeyX",n[n.KeyY=55]="KeyY",n[n.KeyZ=56]="KeyZ",n[n.Meta=57]="Meta",n[n.ContextMenu=58]="ContextMenu",n[n.F1=59]="F1",n[n.F2=60]="F2",n[n.F3=61]="F3",n[n.F4=62]="F4",n[n.F5=63]="F5",n[n.F6=64]="F6",n[n.F7=65]="F7",n[n.F8=66]="F8",n[n.F9=67]="F9",n[n.F10=68]="F10",n[n.F11=69]="F11",n[n.F12=70]="F12",n[n.F13=71]="F13",n[n.F14=72]="F14",n[n.F15=73]="F15",n[n.F16=74]="F16",n[n.F17=75]="F17",n[n.F18=76]="F18",n[n.F19=77]="F19",n[n.NumLock=78]="NumLock",n[n.ScrollLock=79]="ScrollLock",n[n.Semicolon=80]="Semicolon",n[n.Equal=81]="Equal",n[n.Comma=82]="Comma",n[n.Minus=83]="Minus",n[n.Period=84]="Period",n[n.Slash=85]="Slash",n[n.Backquote=86]="Backquote",n[n.BracketLeft=87]="BracketLeft",n[n.Backslash=88]="Backslash",n[n.BracketRight=89]="BracketRight",n[n.Quote=90]="Quote",n[n.OEM_8=91]="OEM_8",n[n.IntlBackslash=92]="IntlBackslash",n[n.Numpad0=93]="Numpad0",n[n.Numpad1=94]="Numpad1",n[n.Numpad2=95]="Numpad2",n[n.Numpad3=96]="Numpad3",n[n.Numpad4=97]="Numpad4",n[n.Numpad5=98]="Numpad5",n[n.Numpad6=99]="Numpad6",n[n.Numpad7=100]="Numpad7",n[n.Numpad8=101]="Numpad8",n[n.Numpad9=102]="Numpad9",n[n.NumpadMultiply=103]="NumpadMultiply",n[n.NumpadAdd=104]="NumpadAdd",n[n.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",n[n.NumpadSubtract=106]="NumpadSubtract",n[n.NumpadDecimal=107]="NumpadDecimal",n[n.NumpadDivide=108]="NumpadDivide",n[n.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",n[n.ABNT_C1=110]="ABNT_C1",n[n.ABNT_C2=111]="ABNT_C2",n[n.AudioVolumeMute=112]="AudioVolumeMute",n[n.AudioVolumeUp=113]="AudioVolumeUp",n[n.AudioVolumeDown=114]="AudioVolumeDown",n[n.BrowserSearch=115]="BrowserSearch",n[n.BrowserHome=116]="BrowserHome",n[n.BrowserBack=117]="BrowserBack",n[n.BrowserForward=118]="BrowserForward",n[n.MediaTrackNext=119]="MediaTrackNext",n[n.MediaTrackPrevious=120]="MediaTrackPrevious",n[n.MediaStop=121]="MediaStop",n[n.MediaPlayPause=122]="MediaPlayPause",n[n.LaunchMediaPlayer=123]="LaunchMediaPlayer",n[n.LaunchMail=124]="LaunchMail",n[n.LaunchApp2=125]="LaunchApp2",n[n.Clear=126]="Clear",n[n.MAX_VALUE=127]="MAX_VALUE"})(u=r.KeyCode||(r.KeyCode={}));var d;(function(n){n[n.Hint=1]="Hint",n[n.Info=2]="Info",n[n.Warning=4]="Warning",n[n.Error=8]="Error"})(d=r.MarkerSeverity||(r.MarkerSeverity={}));var s;(function(n){n[n.Unnecessary=1]="Unnecessary",n[n.Deprecated=2]="Deprecated"})(s=r.MarkerTag||(r.MarkerTag={}));var a;(function(n){n[n.Inline=1]="Inline",n[n.Gutter=2]="Gutter"})(a=r.MinimapPosition||(r.MinimapPosition={}));var i;(function(n){n[n.UNKNOWN=0]="UNKNOWN",n[n.TEXTAREA=1]="TEXTAREA",n[n.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",n[n.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",n[n.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",n[n.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",n[n.CONTENT_TEXT=6]="CONTENT_TEXT",n[n.CONTENT_EMPTY=7]="CONTENT_EMPTY",n[n.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",n[n.CONTENT_WIDGET=9]="CONTENT_WIDGET",n[n.OVERVIEW_RULER=10]="OVERVIEW_RULER",n[n.SCROLLBAR=11]="SCROLLBAR",n[n.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",n[n.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(i=r.MouseTargetType||(r.MouseTargetType={}));var c;(function(n){n[n.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",n[n.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",n[n.TOP_CENTER=2]="TOP_CENTER"})(c=r.OverlayWidgetPositionPreference||(r.OverlayWidgetPositionPreference={}));var b;(function(n){n[n.Left=1]="Left",n[n.Center=2]="Center",n[n.Right=4]="Right",n[n.Full=7]="Full"})(b=r.OverviewRulerLane||(r.OverviewRulerLane={}));var N;(function(n){n[n.Left=0]="Left",n[n.Right=1]="Right",n[n.None=2]="None",n[n.LeftOfInjectedText=3]="LeftOfInjectedText",n[n.RightOfInjectedText=4]="RightOfInjectedText"})(N=r.PositionAffinity||(r.PositionAffinity={}));var M;(function(n){n[n.Off=0]="Off",n[n.On=1]="On",n[n.Relative=2]="Relative",n[n.Interval=3]="Interval",n[n.Custom=4]="Custom"})(M=r.RenderLineNumbersType||(r.RenderLineNumbersType={}));var R;(function(n){n[n.None=0]="None",n[n.Text=1]="Text",n[n.Blocks=2]="Blocks"})(R=r.RenderMinimap||(r.RenderMinimap={}));var P;(function(n){n[n.Smooth=0]="Smooth",n[n.Immediate=1]="Immediate"})(P=r.ScrollType||(r.ScrollType={}));var I;(function(n){n[n.Auto=1]="Auto",n[n.Hidden=2]="Hidden",n[n.Visible=3]="Visible"})(I=r.ScrollbarVisibility||(r.ScrollbarVisibility={}));var W;(function(n){n[n.LTR=0]="LTR",n[n.RTL=1]="RTL"})(W=r.SelectionDirection||(r.SelectionDirection={}));var O;(function(n){n[n.Invoke=1]="Invoke",n[n.TriggerCharacter=2]="TriggerCharacter",n[n.ContentChange=3]="ContentChange"})(O=r.SignatureHelpTriggerKind||(r.SignatureHelpTriggerKind={}));var q;(function(n){n[n.File=0]="File",n[n.Module=1]="Module",n[n.Namespace=2]="Namespace",n[n.Package=3]="Package",n[n.Class=4]="Class",n[n.Method=5]="Method",n[n.Property=6]="Property",n[n.Field=7]="Field",n[n.Constructor=8]="Constructor",n[n.Enum=9]="Enum",n[n.Interface=10]="Interface",n[n.Function=11]="Function",n[n.Variable=12]="Variable",n[n.Constant=13]="Constant",n[n.String=14]="String",n[n.Number=15]="Number",n[n.Boolean=16]="Boolean",n[n.Array=17]="Array",n[n.Object=18]="Object",n[n.Key=19]="Key",n[n.Null=20]="Null",n[n.EnumMember=21]="EnumMember",n[n.Struct=22]="Struct",n[n.Event=23]="Event",n[n.Operator=24]="Operator",n[n.TypeParameter=25]="TypeParameter"})(q=r.SymbolKind||(r.SymbolKind={}));var Y;(function(n){n[n.Deprecated=1]="Deprecated"})(Y=r.SymbolTag||(r.SymbolTag={}));var k;(function(n){n[n.Hidden=0]="Hidden",n[n.Blink=1]="Blink",n[n.Smooth=2]="Smooth",n[n.Phase=3]="Phase",n[n.Expand=4]="Expand",n[n.Solid=5]="Solid"})(k=r.TextEditorCursorBlinkingStyle||(r.TextEditorCursorBlinkingStyle={}));var U;(function(n){n[n.Line=1]="Line",n[n.Block=2]="Block",n[n.Underline=3]="Underline",n[n.LineThin=4]="LineThin",n[n.BlockOutline=5]="BlockOutline",n[n.UnderlineThin=6]="UnderlineThin"})(U=r.TextEditorCursorStyle||(r.TextEditorCursorStyle={}));var F;(function(n){n[n.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",n[n.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",n[n.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",n[n.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(F=r.TrackedRangeStickiness||(r.TrackedRangeStickiness={}));var V;(function(n){n[n.None=0]="None",n[n.Same=1]="Same",n[n.Indent=2]="Indent",n[n.DeepIndent=3]="DeepIndent"})(V=r.WrappingIndent||(r.WrappingIndent={}))}),X(Q[48],J([21,55]),function(T,r){return T.create("vs/base/common/platform",r)}),X(Q[5],J([0,1,48]),function(T,r,A){"use strict";var e;Object.defineProperty(r,"__esModule",{value:!0}),r.isAndroid=r.isEdge=r.isSafari=r.isFirefox=r.isChrome=r.isLittleEndian=r.OS=r.setTimeout0=r.setTimeout0IsFaster=r.language=r.userAgent=r.isMobile=r.isIOS=r.isWebWorker=r.isWeb=r.isNative=r.isLinux=r.isMacintosh=r.isWindows=r.globals=r.LANGUAGE_DEFAULT=void 0,r.LANGUAGE_DEFAULT="en";let E=!1,l=!1,p=!1,C=!1,o=!1,f=!1,S=!1,t=!1,w=!1,h=!1,m,L=r.LANGUAGE_DEFAULT,y,_;r.globals=typeof self=="object"?self:typeof global=="object"?global:{};let g;typeof r.globals.vscode<"u"&&typeof r.globals.vscode.process<"u"?g=r.globals.vscode.process:typeof process<"u"&&(g=process);const v=typeof((e=g?.versions)===null||e===void 0?void 0:e.electron)=="string",u=v&&g?.type==="renderer";if(typeof navigator=="object"&&!u)_=navigator.userAgent,E=_.indexOf("Windows")>=0,l=_.indexOf("Macintosh")>=0,t=(_.indexOf("Macintosh")>=0||_.indexOf("iPad")>=0||_.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,p=_.indexOf("Linux")>=0,h=_?.indexOf("Mobi")>=0,f=!0,m=A.getConfiguredDefaultLocale(A.localize(0,null))||r.LANGUAGE_DEFAULT,L=m;else if(typeof g=="object"){E=g.platform==="win32",l=g.platform==="darwin",p=g.platform==="linux",C=p&&!!g.env.SNAP&&!!g.env.SNAP_REVISION,S=v,w=!!g.env.CI||!!g.env.BUILD_ARTIFACTSTAGINGDIRECTORY,m=r.LANGUAGE_DEFAULT,L=r.LANGUAGE_DEFAULT;const c=g.env.VSCODE_NLS_CONFIG;if(c)try{const b=JSON.parse(c),N=b.availableLanguages["*"];m=b.locale,L=N||r.LANGUAGE_DEFAULT,y=b._translationsConfigFile}catch{}o=!0}else console.error("Unable to resolve platform.");let d=0;l?d=1:E?d=3:p&&(d=2),r.isWindows=E,r.isMacintosh=l,r.isLinux=p,r.isNative=o,r.isWeb=f,r.isWebWorker=f&&typeof r.globals.importScripts=="function",r.isIOS=t,r.isMobile=h,r.userAgent=_,r.language=L,r.setTimeout0IsFaster=typeof r.globals.postMessage=="function"&&!r.globals.importScripts,r.setTimeout0=(()=>{if(r.setTimeout0IsFaster){const c=[];r.globals.addEventListener("message",N=>{if(N.data&&N.data.vscodeScheduleAsyncWork)for(let M=0,R=c.length;M<R;M++){const P=c[M];if(P.id===N.data.vscodeScheduleAsyncWork){c.splice(M,1),P.callback();return}}});let b=0;return N=>{const M=++b;c.push({id:M,callback:N}),r.globals.postMessage({vscodeScheduleAsyncWork:M},"*")}}return c=>setTimeout(c)})(),r.OS=l||t?2:E?1:3;let s=!0,a=!1;function i(){if(!a){a=!0;const c=new Uint8Array(2);c[0]=1,c[1]=2,s=new Uint16Array(c.buffer)[0]===(2<<8)+1}return s}r.isLittleEndian=i,r.isChrome=!!(r.userAgent&&r.userAgent.indexOf("Chrome")>=0),r.isFirefox=!!(r.userAgent&&r.userAgent.indexOf("Firefox")>=0),r.isSafari=!!(!r.isChrome&&r.userAgent&&r.userAgent.indexOf("Safari")>=0),r.isEdge=!!(r.userAgent&&r.userAgent.indexOf("Edg/")>=0),r.isAndroid=!!(r.userAgent&&r.userAgent.indexOf("Android")>=0)}),X(Q[49],J([0,1,5]),function(T,r,A){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.platform=r.env=r.cwd=void 0;let e;if(typeof A.globals.vscode<"u"&&typeof A.globals.vscode.process<"u"){const E=A.globals.vscode.process;e={get platform(){return E.platform},get arch(){return E.arch},get env(){return E.env},cwd(){return E.cwd()}}}else typeof process<"u"?e={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:e={get platform(){return A.isWindows?"win32":A.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};r.cwd=e.cwd,r.env=e.env,r.platform=e.platform}),X(Q[50],J([0,1,49]),function(T,r,A){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.sep=r.extname=r.basename=r.dirname=r.relative=r.resolve=r.normalize=r.posix=r.win32=void 0;const e=65,E=97,l=90,p=122,C=46,o=47,f=92,S=58,t=63;class w extends Error{constructor(a,i,c){let b;typeof i=="string"&&i.indexOf("not ")===0?(b="must not be",i=i.replace(/^not /,"")):b="must be";const N=a.indexOf(".")!==-1?"property":"argument";let M=`The "${a}" ${N} ${b} of type ${i}`;M+=`. Received type ${typeof c}`,super(M),this.code="ERR_INVALID_ARG_TYPE"}}function h(s,a){if(s===null||typeof s!="object")throw new w(a,"Object",s)}function m(s,a){if(typeof s!="string")throw new w(a,"string",s)}const L=A.platform==="win32";function y(s){return s===o||s===f}function _(s){return s===o}function g(s){return s>=e&&s<=l||s>=E&&s<=p}function v(s,a,i,c){let b="",N=0,M=-1,R=0,P=0;for(let I=0;I<=s.length;++I){if(I<s.length)P=s.charCodeAt(I);else{if(c(P))break;P=o}if(c(P)){if(!(M===I-1||R===1))if(R===2){if(b.length<2||N!==2||b.charCodeAt(b.length-1)!==C||b.charCodeAt(b.length-2)!==C){if(b.length>2){const W=b.lastIndexOf(i);W===-1?(b="",N=0):(b=b.slice(0,W),N=b.length-1-b.lastIndexOf(i)),M=I,R=0;continue}else if(b.length!==0){b="",N=0,M=I,R=0;continue}}a&&(b+=b.length>0?`${i}..`:"..",N=2)}else b.length>0?b+=`${i}${s.slice(M+1,I)}`:b=s.slice(M+1,I),N=I-M-1;M=I,R=0}else P===C&&R!==-1?++R:R=-1}return b}function u(s,a){h(a,"pathObject");const i=a.dir||a.root,c=a.base||`${a.name||""}${a.ext||""}`;return i?i===a.root?`${i}${c}`:`${i}${s}${c}`:c}r.win32={resolve(...s){let a="",i="",c=!1;for(let b=s.length-1;b>=-1;b--){let N;if(b>=0){if(N=s[b],m(N,"path"),N.length===0)continue}else a.length===0?N=A.cwd():(N=A.env[`=${a}`]||A.cwd(),(N===void 0||N.slice(0,2).toLowerCase()!==a.toLowerCase()&&N.charCodeAt(2)===f)&&(N=`${a}\\`));const M=N.length;let R=0,P="",I=!1;const W=N.charCodeAt(0);if(M===1)y(W)&&(R=1,I=!0);else if(y(W))if(I=!0,y(N.charCodeAt(1))){let O=2,q=O;for(;O<M&&!y(N.charCodeAt(O));)O++;if(O<M&&O!==q){const Y=N.slice(q,O);for(q=O;O<M&&y(N.charCodeAt(O));)O++;if(O<M&&O!==q){for(q=O;O<M&&!y(N.charCodeAt(O));)O++;(O===M||O!==q)&&(P=`\\\\${Y}\\${N.slice(q,O)}`,R=O)}}}else R=1;else g(W)&&N.charCodeAt(1)===S&&(P=N.slice(0,2),R=2,M>2&&y(N.charCodeAt(2))&&(I=!0,R=3));if(P.length>0)if(a.length>0){if(P.toLowerCase()!==a.toLowerCase())continue}else a=P;if(c){if(a.length>0)break}else if(i=`${N.slice(R)}\\${i}`,c=I,I&&a.length>0)break}return i=v(i,!c,"\\",y),c?`${a}\\${i}`:`${a}${i}`||"."},normalize(s){m(s,"path");const a=s.length;if(a===0)return".";let i=0,c,b=!1;const N=s.charCodeAt(0);if(a===1)return _(N)?"\\":s;if(y(N))if(b=!0,y(s.charCodeAt(1))){let R=2,P=R;for(;R<a&&!y(s.charCodeAt(R));)R++;if(R<a&&R!==P){const I=s.slice(P,R);for(P=R;R<a&&y(s.charCodeAt(R));)R++;if(R<a&&R!==P){for(P=R;R<a&&!y(s.charCodeAt(R));)R++;if(R===a)return`\\\\${I}\\${s.slice(P)}\\`;R!==P&&(c=`\\\\${I}\\${s.slice(P,R)}`,i=R)}}}else i=1;else g(N)&&s.charCodeAt(1)===S&&(c=s.slice(0,2),i=2,a>2&&y(s.charCodeAt(2))&&(b=!0,i=3));let M=i<a?v(s.slice(i),!b,"\\",y):"";return M.length===0&&!b&&(M="."),M.length>0&&y(s.charCodeAt(a-1))&&(M+="\\"),c===void 0?b?`\\${M}`:M:b?`${c}\\${M}`:`${c}${M}`},isAbsolute(s){m(s,"path");const a=s.length;if(a===0)return!1;const i=s.charCodeAt(0);return y(i)||a>2&&g(i)&&s.charCodeAt(1)===S&&y(s.charCodeAt(2))},join(...s){if(s.length===0)return".";let a,i;for(let N=0;N<s.length;++N){const M=s[N];m(M,"path"),M.length>0&&(a===void 0?a=i=M:a+=`\\${M}`)}if(a===void 0)return".";let c=!0,b=0;if(typeof i=="string"&&y(i.charCodeAt(0))){++b;const N=i.length;N>1&&y(i.charCodeAt(1))&&(++b,N>2&&(y(i.charCodeAt(2))?++b:c=!1))}if(c){for(;b<a.length&&y(a.charCodeAt(b));)b++;b>=2&&(a=`\\${a.slice(b)}`)}return r.win32.normalize(a)},relative(s,a){if(m(s,"from"),m(a,"to"),s===a)return"";const i=r.win32.resolve(s),c=r.win32.resolve(a);if(i===c||(s=i.toLowerCase(),a=c.toLowerCase(),s===a))return"";let b=0;for(;b<s.length&&s.charCodeAt(b)===f;)b++;let N=s.length;for(;N-1>b&&s.charCodeAt(N-1)===f;)N--;const M=N-b;let R=0;for(;R<a.length&&a.charCodeAt(R)===f;)R++;let P=a.length;for(;P-1>R&&a.charCodeAt(P-1)===f;)P--;const I=P-R,W=M<I?M:I;let O=-1,q=0;for(;q<W;q++){const k=s.charCodeAt(b+q);if(k!==a.charCodeAt(R+q))break;k===f&&(O=q)}if(q!==W){if(O===-1)return c}else{if(I>W){if(a.charCodeAt(R+q)===f)return c.slice(R+q+1);if(q===2)return c.slice(R+q)}M>W&&(s.charCodeAt(b+q)===f?O=q:q===2&&(O=3)),O===-1&&(O=0)}let Y="";for(q=b+O+1;q<=N;++q)(q===N||s.charCodeAt(q)===f)&&(Y+=Y.length===0?"..":"\\..");return R+=O,Y.length>0?`${Y}${c.slice(R,P)}`:(c.charCodeAt(R)===f&&++R,c.slice(R,P))},toNamespacedPath(s){if(typeof s!="string"||s.length===0)return s;const a=r.win32.resolve(s);if(a.length<=2)return s;if(a.charCodeAt(0)===f){if(a.charCodeAt(1)===f){const i=a.charCodeAt(2);if(i!==t&&i!==C)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(g(a.charCodeAt(0))&&a.charCodeAt(1)===S&&a.charCodeAt(2)===f)return`\\\\?\\${a}`;return s},dirname(s){m(s,"path");const a=s.length;if(a===0)return".";let i=-1,c=0;const b=s.charCodeAt(0);if(a===1)return y(b)?s:".";if(y(b)){if(i=c=1,y(s.charCodeAt(1))){let R=2,P=R;for(;R<a&&!y(s.charCodeAt(R));)R++;if(R<a&&R!==P){for(P=R;R<a&&y(s.charCodeAt(R));)R++;if(R<a&&R!==P){for(P=R;R<a&&!y(s.charCodeAt(R));)R++;if(R===a)return s;R!==P&&(i=c=R+1)}}}}else g(b)&&s.charCodeAt(1)===S&&(i=a>2&&y(s.charCodeAt(2))?3:2,c=i);let N=-1,M=!0;for(let R=a-1;R>=c;--R)if(y(s.charCodeAt(R))){if(!M){N=R;break}}else M=!1;if(N===-1){if(i===-1)return".";N=i}return s.slice(0,N)},basename(s,a){a!==void 0&&m(a,"ext"),m(s,"path");let i=0,c=-1,b=!0,N;if(s.length>=2&&g(s.charCodeAt(0))&&s.charCodeAt(1)===S&&(i=2),a!==void 0&&a.length>0&&a.length<=s.length){if(a===s)return"";let M=a.length-1,R=-1;for(N=s.length-1;N>=i;--N){const P=s.charCodeAt(N);if(y(P)){if(!b){i=N+1;break}}else R===-1&&(b=!1,R=N+1),M>=0&&(P===a.charCodeAt(M)?--M===-1&&(c=N):(M=-1,c=R))}return i===c?c=R:c===-1&&(c=s.length),s.slice(i,c)}for(N=s.length-1;N>=i;--N)if(y(s.charCodeAt(N))){if(!b){i=N+1;break}}else c===-1&&(b=!1,c=N+1);return c===-1?"":s.slice(i,c)},extname(s){m(s,"path");let a=0,i=-1,c=0,b=-1,N=!0,M=0;s.length>=2&&s.charCodeAt(1)===S&&g(s.charCodeAt(0))&&(a=c=2);for(let R=s.length-1;R>=a;--R){const P=s.charCodeAt(R);if(y(P)){if(!N){c=R+1;break}continue}b===-1&&(N=!1,b=R+1),P===C?i===-1?i=R:M!==1&&(M=1):i!==-1&&(M=-1)}return i===-1||b===-1||M===0||M===1&&i===b-1&&i===c+1?"":s.slice(i,b)},format:u.bind(null,"\\"),parse(s){m(s,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return a;const i=s.length;let c=0,b=s.charCodeAt(0);if(i===1)return y(b)?(a.root=a.dir=s,a):(a.base=a.name=s,a);if(y(b)){if(c=1,y(s.charCodeAt(1))){let O=2,q=O;for(;O<i&&!y(s.charCodeAt(O));)O++;if(O<i&&O!==q){for(q=O;O<i&&y(s.charCodeAt(O));)O++;if(O<i&&O!==q){for(q=O;O<i&&!y(s.charCodeAt(O));)O++;O===i?c=O:O!==q&&(c=O+1)}}}}else if(g(b)&&s.charCodeAt(1)===S){if(i<=2)return a.root=a.dir=s,a;if(c=2,y(s.charCodeAt(2))){if(i===3)return a.root=a.dir=s,a;c=3}}c>0&&(a.root=s.slice(0,c));let N=-1,M=c,R=-1,P=!0,I=s.length-1,W=0;for(;I>=c;--I){if(b=s.charCodeAt(I),y(b)){if(!P){M=I+1;break}continue}R===-1&&(P=!1,R=I+1),b===C?N===-1?N=I:W!==1&&(W=1):N!==-1&&(W=-1)}return R!==-1&&(N===-1||W===0||W===1&&N===R-1&&N===M+1?a.base=a.name=s.slice(M,R):(a.name=s.slice(M,N),a.base=s.slice(M,R),a.ext=s.slice(N,R))),M>0&&M!==c?a.dir=s.slice(0,M-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null};const d=(()=>{if(L){const s=/\\/g;return()=>{const a=A.cwd().replace(s,"/");return a.slice(a.indexOf("/"))}}return()=>A.cwd()})();r.posix={resolve(...s){let a="",i=!1;for(let c=s.length-1;c>=-1&&!i;c--){const b=c>=0?s[c]:d();m(b,"path"),b.length!==0&&(a=`${b}/${a}`,i=b.charCodeAt(0)===o)}return a=v(a,!i,"/",_),i?`/${a}`:a.length>0?a:"."},normalize(s){if(m(s,"path"),s.length===0)return".";const a=s.charCodeAt(0)===o,i=s.charCodeAt(s.length-1)===o;return s=v(s,!a,"/",_),s.length===0?a?"/":i?"./":".":(i&&(s+="/"),a?`/${s}`:s)},isAbsolute(s){return m(s,"path"),s.length>0&&s.charCodeAt(0)===o},join(...s){if(s.length===0)return".";let a;for(let i=0;i<s.length;++i){const c=s[i];m(c,"path"),c.length>0&&(a===void 0?a=c:a+=`/${c}`)}return a===void 0?".":r.posix.normalize(a)},relative(s,a){if(m(s,"from"),m(a,"to"),s===a||(s=r.posix.resolve(s),a=r.posix.resolve(a),s===a))return"";const i=1,c=s.length,b=c-i,N=1,M=a.length-N,R=b<M?b:M;let P=-1,I=0;for(;I<R;I++){const O=s.charCodeAt(i+I);if(O!==a.charCodeAt(N+I))break;O===o&&(P=I)}if(I===R)if(M>R){if(a.charCodeAt(N+I)===o)return a.slice(N+I+1);if(I===0)return a.slice(N+I)}else b>R&&(s.charCodeAt(i+I)===o?P=I:I===0&&(P=0));let W="";for(I=i+P+1;I<=c;++I)(I===c||s.charCodeAt(I)===o)&&(W+=W.length===0?"..":"/..");return`${W}${a.slice(N+P)}`},toNamespacedPath(s){return s},dirname(s){if(m(s,"path"),s.length===0)return".";const a=s.charCodeAt(0)===o;let i=-1,c=!0;for(let b=s.length-1;b>=1;--b)if(s.charCodeAt(b)===o){if(!c){i=b;break}}else c=!1;return i===-1?a?"/":".":a&&i===1?"//":s.slice(0,i)},basename(s,a){a!==void 0&&m(a,"ext"),m(s,"path");let i=0,c=-1,b=!0,N;if(a!==void 0&&a.length>0&&a.length<=s.length){if(a===s)return"";let M=a.length-1,R=-1;for(N=s.length-1;N>=0;--N){const P=s.charCodeAt(N);if(P===o){if(!b){i=N+1;break}}else R===-1&&(b=!1,R=N+1),M>=0&&(P===a.charCodeAt(M)?--M===-1&&(c=N):(M=-1,c=R))}return i===c?c=R:c===-1&&(c=s.length),s.slice(i,c)}for(N=s.length-1;N>=0;--N)if(s.charCodeAt(N)===o){if(!b){i=N+1;break}}else c===-1&&(b=!1,c=N+1);return c===-1?"":s.slice(i,c)},extname(s){m(s,"path");let a=-1,i=0,c=-1,b=!0,N=0;for(let M=s.length-1;M>=0;--M){const R=s.charCodeAt(M);if(R===o){if(!b){i=M+1;break}continue}c===-1&&(b=!1,c=M+1),R===C?a===-1?a=M:N!==1&&(N=1):a!==-1&&(N=-1)}return a===-1||c===-1||N===0||N===1&&a===c-1&&a===i+1?"":s.slice(a,c)},format:u.bind(null,"/"),parse(s){m(s,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return a;const i=s.charCodeAt(0)===o;let c;i?(a.root="/",c=1):c=0;let b=-1,N=0,M=-1,R=!0,P=s.length-1,I=0;for(;P>=c;--P){const W=s.charCodeAt(P);if(W===o){if(!R){N=P+1;break}continue}M===-1&&(R=!1,M=P+1),W===C?b===-1?b=P:I!==1&&(I=1):b!==-1&&(I=-1)}if(M!==-1){const W=N===0&&i?1:N;b===-1||I===0||I===1&&b===M-1&&b===N+1?a.base=a.name=s.slice(W,M):(a.name=s.slice(W,b),a.base=s.slice(W,M),a.ext=s.slice(b,M))}return N>0?a.dir=s.slice(0,N-1):i&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},r.posix.win32=r.win32.win32=r.win32,r.posix.posix=r.win32.posix=r.posix,r.normalize=L?r.win32.normalize:r.posix.normalize,r.resolve=L?r.win32.resolve:r.posix.resolve,r.relative=L?r.win32.relative:r.posix.relative,r.dirname=L?r.win32.dirname:r.posix.dirname,r.basename=L?r.win32.basename:r.posix.basename,r.extname=L?r.win32.extname:r.posix.extname,r.sep=L?r.win32.sep:r.posix.sep}),X(Q[20],J([0,1,5]),function(T,r,A){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.StopWatch=void 0;const e=A.globals.performance&&typeof A.globals.performance.now=="function";class E{static create(p=!0){return new E(p)}constructor(p){this.a=e&&p,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?A.globals.performance.now():Date.now()}}r.StopWatch=E}),X(Q[7],J([0,1,8,10,14,20]),function(T,r,A,e,E,l){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.Relay=r.EventBufferer=r.MicrotaskEmitter=r.DebounceEmitter=r.PauseableEmitter=r.EventDeliveryQueue=r.Emitter=r.EventProfiling=r.Event=void 0;const p=!1,C=!1;var o;(function(a){a.None=()=>e.Disposable.None;function i(Z){if(C){const{onDidAddListener:H}=Z,G=w.create();let $=0;Z.onDidAddListener=()=>{++$===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),G.print()),H?.()}}}function c(Z,H){return q(Z,()=>{},0,void 0,void 0,H)}a.defer=c;function b(Z){return(H,G=null,$)=>{let x=!1,ee;return ee=Z(te=>{if(!x)return ee?ee.dispose():x=!0,H.call(G,te)},null,$),x&&ee.dispose(),ee}}a.once=b;function N(Z,H,G){return O(($,x=null,ee)=>Z(te=>$.call(x,H(te)),null,ee),G)}a.map=N;function M(Z,H,G){return O(($,x=null,ee)=>Z(te=>{H(te),$.call(x,te)},null,ee),G)}a.forEach=M;function R(Z,H,G){return O(($,x=null,ee)=>Z(te=>H(te)&&$.call(x,te),null,ee),G)}a.filter=R;function P(Z){return Z}a.signal=P;function I(...Z){return(H,G=null,$)=>(0,e.combinedDisposable)(...Z.map(x=>x(ee=>H.call(G,ee),null,$)))}a.any=I;function W(Z,H,G,$){let x=G;return N(Z,ee=>(x=H(x,ee),x),$)}a.reduce=W;function O(Z,H){let G;const $={onWillAddFirstListener(){G=Z(x.fire,x)},onDidRemoveLastListener(){G?.dispose()}};H||i($);const x=new m($);return H?.add(x),x.event}function q(Z,H,G=100,$=!1,x,ee){let te,ne,Ce,Le=0;const pe={leakWarningThreshold:x,onWillAddFirstListener(){te=Z(ce=>{Le++,ne=H(ne,ce),$&&!Ce&&(ve.fire(ne),ne=void 0),clearTimeout(Ce),Ce=setTimeout(()=>{const me=ne;ne=void 0,Ce=void 0,(!$||Le>1)&&ve.fire(me),Le=0},G)})},onDidRemoveLastListener(){te.dispose()}};ee||i(pe);const ve=new m(pe);return ee?.add(ve),ve.event}a.debounce=q;function Y(Z,H=0,G){return a.debounce(Z,($,x)=>$?($.push(x),$):[x],H,void 0,void 0,G)}a.accumulate=Y;function k(Z,H=($,x)=>$===x,G){let $=!0,x;return R(Z,ee=>{const te=$||!H(ee,x);return $=!1,x=ee,te},G)}a.latch=k;function U(Z,H,G){return[a.filter(Z,H,G),a.filter(Z,$=>!H($),G)]}a.split=U;function F(Z,H=!1,G=[]){let $=G.slice(),x=Z(ne=>{$?$.push(ne):te.fire(ne)});const ee=()=>{$?.forEach(ne=>te.fire(ne)),$=null},te=new m({onWillAddFirstListener(){x||(x=Z(ne=>te.fire(ne)))},onDidAddFirstListener(){$&&(H?setTimeout(ee):ee())},onDidRemoveLastListener(){x&&x.dispose(),x=null}});return te.event}a.buffer=F;class V{constructor(H){this.event=H,this.c=new e.DisposableStore}map(H){return new V(N(this.event,H,this.c))}forEach(H){return new V(M(this.event,H,this.c))}filter(H){return new V(R(this.event,H,this.c))}reduce(H,G){return new V(W(this.event,H,G,this.c))}latch(){return new V(k(this.event,void 0,this.c))}debounce(H,G=100,$=!1,x){return new V(q(this.event,H,G,$,x,this.c))}on(H,G,$){return this.event(H,G,$)}once(H,G,$){return b(this.event)(H,G,$)}dispose(){this.c.dispose()}}function n(Z){return new V(Z)}a.chain=n;function ae(Z,H,G=$=>$){const $=(...ne)=>te.fire(G(...ne)),x=()=>Z.on(H,$),ee=()=>Z.removeListener(H,$),te=new m({onWillAddFirstListener:x,onDidRemoveLastListener:ee});return te.event}a.fromNodeEventEmitter=ae;function oe(Z,H,G=$=>$){const $=(...ne)=>te.fire(G(...ne)),x=()=>Z.addEventListener(H,$),ee=()=>Z.removeEventListener(H,$),te=new m({onWillAddFirstListener:x,onDidRemoveLastListener:ee});return te.event}a.fromDOMEventEmitter=oe;function he(Z){return new Promise(H=>b(Z)(H))}a.toPromise=he;function we(Z,H){return H(void 0),Z(G=>H(G))}a.runAndSubscribe=we;function Se(Z,H){let G=null;function $(ee){G?.dispose(),G=new e.DisposableStore,H(ee,G)}$(void 0);const x=Z(ee=>$(ee));return(0,e.toDisposable)(()=>{x.dispose(),G?.dispose()})}a.runAndSubscribeWithStore=Se;class Ne{constructor(H,G){this.obs=H,this.c=0,this.d=!1;const $={onWillAddFirstListener:()=>{H.addObserver(this)},onDidRemoveLastListener:()=>{H.removeObserver(this)}};G||i($),this.emitter=new m($),G&&G.add(this.emitter)}beginUpdate(H){this.c++}handleChange(H,G){this.d=!0}endUpdate(H){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function _e(Z,H){return new Ne(Z,H).emitter.event}a.fromObservable=_e})(o=r.Event||(r.Event={}));class f{constructor(i){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${i}_${f.c++}`,f.all.add(this)}start(i){this.d=new l.StopWatch(!0),this.listenerCount=i}stop(){if(this.d){const i=this.d.elapsed();this.durations.push(i),this.elapsedOverall+=i,this.invocationCount+=1,this.d=void 0}}}r.EventProfiling=f,f.all=new Set,f.c=0;let S=-1;class t{constructor(i,c=Math.random().toString(18).slice(2,5)){this.threshold=i,this.name=c,this.d=0}dispose(){var i;(i=this.c)===null||i===void 0||i.clear()}check(i,c){const b=this.threshold;if(b<=0||c<b)return;this.c||(this.c=new Map);const N=this.c.get(i.value)||0;if(this.c.set(i.value,N+1),this.d-=1,this.d<=0){this.d=b*.5;let M,R=0;for(const[P,I]of this.c)(!M||R<I)&&(M=P,R=I);console.warn(`[${this.name}] potential listener LEAK detected, having ${c} listeners already. MOST frequent listener (${R}):`),console.warn(M)}return()=>{const M=this.c.get(i.value)||0;this.c.set(i.value,M-1)}}}class w{static create(){var i;return new w((i=new Error().stack)!==null&&i!==void 0?i:"")}constructor(i){this.value=i}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class h{constructor(i,c,b){this.callback=i,this.callbackThis=c,this.stack=b,this.subscription=new e.SafeDisposable}invoke(i){this.callback.call(this.callbackThis,i)}}class m{constructor(i){var c,b,N,M,R;this.j=!1,this.d=i,this.f=S>0||((c=this.d)===null||c===void 0?void 0:c.leakWarningThreshold)?new t((N=(b=this.d)===null||b===void 0?void 0:b.leakWarningThreshold)!==null&&N!==void 0?N:S):void 0,this.g=!((M=this.d)===null||M===void 0)&&M._profName?new f(this.d._profName):void 0,this.m=(R=this.d)===null||R===void 0?void 0:R.deliveryQueue}dispose(){var i,c,b,N;if(!this.j){if(this.j=!0,this.n){if(p){const M=Array.from(this.n);queueMicrotask(()=>{var R;for(const P of M)P.subscription.isset()&&(P.subscription.unset(),(R=P.stack)===null||R===void 0||R.print())})}this.n.clear()}(i=this.m)===null||i===void 0||i.clear(this),(b=(c=this.d)===null||c===void 0?void 0:c.onDidRemoveLastListener)===null||b===void 0||b.call(c),(N=this.f)===null||N===void 0||N.dispose()}}get event(){return this.l||(this.l=(i,c,b)=>{var N,M,R;if(this.n||(this.n=new E.LinkedList),this.f&&this.n.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),e.Disposable.None;const P=this.n.isEmpty();P&&((N=this.d)===null||N===void 0?void 0:N.onWillAddFirstListener)&&this.d.onWillAddFirstListener(this);let I,W;this.f&&this.n.size>=Math.ceil(this.f.threshold*.2)&&(W=w.create(),I=this.f.check(W,this.n.size+1)),p&&(W=W??w.create());const O=new h(i,c,W),q=this.n.push(O);P&&((M=this.d)===null||M===void 0?void 0:M.onDidAddFirstListener)&&this.d.onDidAddFirstListener(this),!((R=this.d)===null||R===void 0)&&R.onDidAddListener&&this.d.onDidAddListener(this,i,c);const Y=O.subscription.set(()=>{I?.(),this.j||(q(),this.d&&this.d.onDidRemoveLastListener&&(this.n&&!this.n.isEmpty()||this.d.onDidRemoveLastListener(this)))});return b instanceof e.DisposableStore?b.add(Y):Array.isArray(b)&&b.push(Y),Y}),this.l}fire(i){var c,b;if(this.n){this.m||(this.m=new y);for(const N of this.n)this.m.push(this,N,i);(c=this.g)===null||c===void 0||c.start(this.m.size),this.m.deliver(),(b=this.g)===null||b===void 0||b.stop()}}hasListeners(){return this.n?!this.n.isEmpty():!1}}r.Emitter=m;class L{constructor(){this.c=new E.LinkedList}get size(){return this.c.size}push(i,c,b){this.c.push(new _(i,c,b))}clear(i){const c=new E.LinkedList;for(const b of this.c)b.emitter!==i&&c.push(b);this.c=c}deliver(){for(;this.c.size>0;){const i=this.c.shift();try{i.listener.invoke(i.event)}catch(c){(0,A.onUnexpectedError)(c)}}}}r.EventDeliveryQueue=L;class y extends L{clear(i){this.c.clear()}}class _{constructor(i,c,b){this.emitter=i,this.listener=c,this.event=b}}class g extends m{constructor(i){super(i),this.c=0,this.h=new E.LinkedList,this.k=i?.merge}pause(){this.c++}resume(){if(this.c!==0&&--this.c===0)if(this.k){if(this.h.size>0){const i=Array.from(this.h);this.h.clear(),super.fire(this.k(i))}}else for(;!this.c&&this.h.size!==0;)super.fire(this.h.shift())}fire(i){this.n&&(this.c!==0?this.h.push(i):super.fire(i))}}r.PauseableEmitter=g;class v extends g{constructor(i){var c;super(i),this.o=(c=i.delay)!==null&&c!==void 0?c:100}fire(i){this.p||(this.pause(),this.p=setTimeout(()=>{this.p=void 0,this.resume()},this.o)),super.fire(i)}}r.DebounceEmitter=v;class u extends m{constructor(i){super(i),this.c=[],this.h=i?.merge}fire(i){!this.hasListeners()||(this.c.push(i),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(c=>super.fire(c)),this.c=[]}))}}r.MicrotaskEmitter=u;class d{constructor(){this.c=[]}wrapEvent(i){return(c,b,N)=>i(M=>{const R=this.c[this.c.length-1];R?R.push(()=>c.call(b,M)):c.call(b,M)},void 0,N)}bufferEvents(i){const c=[];this.c.push(c);const b=i();return this.c.pop(),c.forEach(N=>N()),b}}r.EventBufferer=d;class s{constructor(){this.c=!1,this.d=o.None,this.f=e.Disposable.None,this.g=new m({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(i){this.d=i,this.c&&(this.f.dispose(),this.f=i(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}r.Relay=s}),X(Q[51],J([0,1,7]),function(T,r,A){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.CancellationTokenSource=r.CancellationToken=void 0;const e=Object.freeze(function(C,o){const f=setTimeout(C.bind(o),0);return{dispose(){clearTimeout(f)}}});var E;(function(C){function o(f){return f===C.None||f===C.Cancelled||f instanceof l?!0:!f||typeof f!="object"?!1:typeof f.isCancellationRequested=="boolean"&&typeof f.onCancellationRequested=="function"}C.isCancellationToken=o,C.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:A.Event.None}),C.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:e})})(E=r.CancellationToken||(r.CancellationToken={}));class l{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?e:(this.b||(this.b=new A.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class p{constructor(o){this.a=void 0,this.b=void 0,this.b=o&&o.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new l),this.a}cancel(){this.a?this.a instanceof l&&this.a.cancel():this.a=E.Cancelled}dispose(o=!1){var f;o&&this.cancel(),(f=this.b)===null||f===void 0||f.dispose(),this.a?this.a instanceof l&&this.a.dispose():this.a=E.None}}r.CancellationTokenSource=p}),X(Q[12],J([0,1,50,5]),function(T,r,A,e){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.uriToFsPath=r.URI=void 0;const E=/^\w[\w\d+.-]*$/,l=/^\//,p=/^\/\//;function C(i,c){if(!i.scheme&&c)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!E.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!l.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(p.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function o(i,c){return!i&&!c?"file":i}function f(i,c){switch(i){case"https":case"http":case"file":c?c[0]!==t&&(c=t+c):c=t;break}return c}const S="",t="/",w=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{static isUri(c){return c instanceof h?!0:c?typeof c.authority=="string"&&typeof c.fragment=="string"&&typeof c.path=="string"&&typeof c.query=="string"&&typeof c.scheme=="string"&&typeof c.fsPath=="string"&&typeof c.with=="function"&&typeof c.toString=="function":!1}constructor(c,b,N,M,R,P=!1){typeof c=="object"?(this.scheme=c.scheme||S,this.authority=c.authority||S,this.path=c.path||S,this.query=c.query||S,this.fragment=c.fragment||S):(this.scheme=o(c,P),this.authority=b||S,this.path=f(this.scheme,N||S),this.query=M||S,this.fragment=R||S,C(this,P))}get fsPath(){return v(this,!1)}with(c){if(!c)return this;let{scheme:b,authority:N,path:M,query:R,fragment:P}=c;return b===void 0?b=this.scheme:b===null&&(b=S),N===void 0?N=this.authority:N===null&&(N=S),M===void 0?M=this.path:M===null&&(M=S),R===void 0?R=this.query:R===null&&(R=S),P===void 0?P=this.fragment:P===null&&(P=S),b===this.scheme&&N===this.authority&&M===this.path&&R===this.query&&P===this.fragment?this:new L(b,N,M,R,P)}static parse(c,b=!1){const N=w.exec(c);return N?new L(N[2]||S,a(N[4]||S),a(N[5]||S),a(N[7]||S),a(N[9]||S),b):new L(S,S,S,S,S)}static file(c){let b=S;if(e.isWindows&&(c=c.replace(/\\/g,t)),c[0]===t&&c[1]===t){const N=c.indexOf(t,2);N===-1?(b=c.substring(2),c=t):(b=c.substring(2,N),c=c.substring(N)||t)}return new L("file",b,c,S,S)}static from(c){const b=new L(c.scheme,c.authority,c.path,c.query,c.fragment);return C(b,!0),b}static joinPath(c,...b){if(!c.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let N;return e.isWindows&&c.scheme==="file"?N=h.file(A.win32.join(v(c,!0),...b)).path:N=A.posix.join(c.path,...b),c.with({path:N})}toString(c=!1){return u(this,c)}toJSON(){return this}static revive(c){if(c){if(c instanceof h)return c;{const b=new L(c);return b._formatted=c.external,b._fsPath=c._sep===m?c.fsPath:null,b}}else return c}}r.URI=h;const m=e.isWindows?1:void 0;class L extends h{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=v(this,!1)),this._fsPath}toString(c=!1){return c?u(this,!0):(this._formatted||(this._formatted=u(this,!1)),this._formatted)}toJSON(){const c={$mid:1};return this._fsPath&&(c.fsPath=this._fsPath,c._sep=m),this._formatted&&(c.external=this._formatted),this.path&&(c.path=this.path),this.scheme&&(c.scheme=this.scheme),this.authority&&(c.authority=this.authority),this.query&&(c.query=this.query),this.fragment&&(c.fragment=this.fragment),c}}const y={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function _(i,c,b){let N,M=-1;for(let R=0;R<i.length;R++){const P=i.charCodeAt(R);if(P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57||P===45||P===46||P===95||P===126||c&&P===47||b&&P===91||b&&P===93||b&&P===58)M!==-1&&(N+=encodeURIComponent(i.substring(M,R)),M=-1),N!==void 0&&(N+=i.charAt(R));else{N===void 0&&(N=i.substr(0,R));const I=y[P];I!==void 0?(M!==-1&&(N+=encodeURIComponent(i.substring(M,R)),M=-1),N+=I):M===-1&&(M=R)}}return M!==-1&&(N+=encodeURIComponent(i.substring(M))),N!==void 0?N:i}function g(i){let c;for(let b=0;b<i.length;b++){const N=i.charCodeAt(b);N===35||N===63?(c===void 0&&(c=i.substr(0,b)),c+=y[N]):c!==void 0&&(c+=i[b])}return c!==void 0?c:i}function v(i,c){let b;return i.authority&&i.path.length>1&&i.scheme==="file"?b=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?c?b=i.path.substr(1):b=i.path[1].toLowerCase()+i.path.substr(2):b=i.path,e.isWindows&&(b=b.replace(/\//g,"\\")),b}r.uriToFsPath=v;function u(i,c){const b=c?g:_;let N="",{scheme:M,authority:R,path:P,query:I,fragment:W}=i;if(M&&(N+=M,N+=":"),(R||M==="file")&&(N+=t,N+=t),R){let O=R.indexOf("@");if(O!==-1){const q=R.substr(0,O);R=R.substr(O+1),O=q.lastIndexOf(":"),O===-1?N+=b(q,!1,!1):(N+=b(q.substr(0,O),!1,!1),N+=":",N+=b(q.substr(O+1),!1,!0)),N+="@"}R=R.toLowerCase(),O=R.lastIndexOf(":"),O===-1?N+=b(R,!1,!0):(N+=b(R.substr(0,O),!1,!0),N+=R.substr(O))}if(P){if(P.length>=3&&P.charCodeAt(0)===47&&P.charCodeAt(2)===58){const O=P.charCodeAt(1);O>=65&&O<=90&&(P=`/${String.fromCharCode(O+32)}:${P.substr(3)}`)}else if(P.length>=2&&P.charCodeAt(1)===58){const O=P.charCodeAt(0);O>=65&&O<=90&&(P=`${String.fromCharCode(O+32)}:${P.substr(2)}`)}N+=b(P,!0,!1)}return I&&(N+="?",N+=b(I,!1,!1)),W&&(N+="#",N+=c?W:_(W,!1,!1)),N}function d(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+d(i.substr(3)):i}}const s=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function a(i){return i.match(s)?i.replace(s,c=>d(c)):i}}),X(Q[56],J([0,1,8,7,10,11,5,4]),function(T,r,A,e,E,l,p,C){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.create=r.SimpleWorkerServer=r.SimpleWorkerClient=r.logOnceWebWorkerWarning=void 0;const o="$initialize";let f=!1;function S(a){!p.isWeb||(f||(f=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(a.message))}r.logOnceWebWorkerWarning=S;class t{constructor(i,c,b,N){this.vsWorker=i,this.req=c,this.method=b,this.args=N,this.type=0}}class w{constructor(i,c,b,N){this.vsWorker=i,this.seq=c,this.res=b,this.err=N,this.type=1}}class h{constructor(i,c,b,N){this.vsWorker=i,this.req=c,this.eventName=b,this.arg=N,this.type=2}}class m{constructor(i,c,b){this.vsWorker=i,this.req=c,this.event=b,this.type=3}}class L{constructor(i,c){this.vsWorker=i,this.req=c,this.type=4}}class y{constructor(i){this.a=-1,this.g=i,this.b=0,this.c=Object.create(null),this.d=new Map,this.f=new Map}setWorkerId(i){this.a=i}sendMessage(i,c){const b=String(++this.b);return new Promise((N,M)=>{this.c[b]={resolve:N,reject:M},this.o(new t(this.a,b,i,c))})}listen(i,c){let b=null;const N=new e.Emitter({onWillAddFirstListener:()=>{b=String(++this.b),this.d.set(b,N),this.o(new h(this.a,b,i,c))},onDidRemoveLastListener:()=>{this.d.delete(b),this.o(new L(this.a,b)),b=null}});return N.event}handleMessage(i){!i||!i.vsWorker||this.a!==-1&&i.vsWorker!==this.a||this.h(i)}h(i){switch(i.type){case 1:return this.j(i);case 0:return this.k(i);case 2:return this.l(i);case 3:return this.m(i);case 4:return this.n(i)}}j(i){if(!this.c[i.seq]){console.warn("Got reply to unknown seq");return}const c=this.c[i.seq];if(delete this.c[i.seq],i.err){let b=i.err;i.err.$isError&&(b=new Error,b.name=i.err.name,b.message=i.err.message,b.stack=i.err.stack),c.reject(b);return}c.resolve(i.res)}k(i){const c=i.req;this.g.handleMessage(i.method,i.args).then(N=>{this.o(new w(this.a,c,N,void 0))},N=>{N.detail instanceof Error&&(N.detail=(0,A.transformErrorForSerialization)(N.detail)),this.o(new w(this.a,c,void 0,(0,A.transformErrorForSerialization)(N)))})}l(i){const c=i.req,b=this.g.handleEvent(i.eventName,i.arg)(N=>{this.o(new m(this.a,c,N))});this.f.set(c,b)}m(i){if(!this.d.has(i.req)){console.warn("Got event for unknown req");return}this.d.get(i.req).fire(i.event)}n(i){if(!this.f.has(i.req)){console.warn("Got unsubscribe for unknown req");return}this.f.get(i.req).dispose(),this.f.delete(i.req)}o(i){const c=[];if(i.type===0)for(let b=0;b<i.args.length;b++)i.args[b]instanceof ArrayBuffer&&c.push(i.args[b]);else i.type===1&&i.res instanceof ArrayBuffer&&c.push(i.res);this.g.sendMessage(i,c)}}class _ extends E.Disposable{constructor(i,c,b){super();let N=null;this.a=this.q(i.create("vs/base/common/worker/simpleWorker",W=>{this.c.handleMessage(W)},W=>{N?.(W)})),this.c=new y({sendMessage:(W,O)=>{this.a.postMessage(W,O)},handleMessage:(W,O)=>{if(typeof b[W]!="function")return Promise.reject(new Error("Missing method "+W+" on main thread host."));try{return Promise.resolve(b[W].apply(b,O))}catch(q){return Promise.reject(q)}},handleEvent:(W,O)=>{if(v(W)){const q=b[W].call(b,O);if(typeof q!="function")throw new Error(`Missing dynamic event ${W} on main thread host.`);return q}if(g(W)){const q=b[W];if(typeof q!="function")throw new Error(`Missing event ${W} on main thread host.`);return q}throw new Error(`Malformed event name ${W}`)}}),this.c.setWorkerId(this.a.getId());let M=null;typeof p.globals.require<"u"&&typeof p.globals.require.getConfig=="function"?M=p.globals.require.getConfig():typeof p.globals.requirejs<"u"&&(M=p.globals.requirejs.s.contexts._.config);const R=(0,l.getAllMethodNames)(b);this.b=this.c.sendMessage(o,[this.a.getId(),JSON.parse(JSON.stringify(M)),c,R]);const P=(W,O)=>this.h(W,O),I=(W,O)=>this.c.listen(W,O);this.g=new Promise((W,O)=>{N=O,this.b.then(q=>{W(u(q,P,I))},q=>{O(q),this.j("Worker failed to load "+c,q)})})}getProxyObject(){return this.g}h(i,c){return new Promise((b,N)=>{this.b.then(()=>{this.c.sendMessage(i,c).then(b,N)},N)})}j(i,c){console.error(i),console.info(c)}}r.SimpleWorkerClient=_;function g(a){return a[0]==="o"&&a[1]==="n"&&C.isUpperAsciiLetter(a.charCodeAt(2))}function v(a){return/^onDynamic/.test(a)&&C.isUpperAsciiLetter(a.charCodeAt(9))}function u(a,i,c){const b=R=>function(){const P=Array.prototype.slice.call(arguments,0);return i(R,P)},N=R=>function(P){return c(R,P)},M={};for(const R of a){if(v(R)){M[R]=N(R);continue}if(g(R)){M[R]=c(R,void 0);continue}M[R]=b(R)}return M}class d{constructor(i,c){this.a=c,this.b=null,this.c=new y({sendMessage:(b,N)=>{i(b,N)},handleMessage:(b,N)=>this.d(b,N),handleEvent:(b,N)=>this.f(b,N)})}onmessage(i){this.c.handleMessage(i)}d(i,c){if(i===o)return this.g(c[0],c[1],c[2],c[3]);if(!this.b||typeof this.b[i]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+i));try{return Promise.resolve(this.b[i].apply(this.b,c))}catch(b){return Promise.reject(b)}}f(i,c){if(!this.b)throw new Error("Missing requestHandler");if(v(i)){const b=this.b[i].call(this.b,c);if(typeof b!="function")throw new Error(`Missing dynamic event ${i} on request handler.`);return b}if(g(i)){const b=this.b[i];if(typeof b!="function")throw new Error(`Missing event ${i} on request handler.`);return b}throw new Error(`Malformed event name ${i}`)}g(i,c,b,N){this.c.setWorkerId(i);const P=u(N,(I,W)=>this.c.sendMessage(I,W),(I,W)=>this.c.listen(I,W));return this.a?(this.b=this.a(P),Promise.resolve((0,l.getAllMethodNames)(this.b))):(c&&(typeof c.baseUrl<"u"&&delete c.baseUrl,typeof c.paths<"u"&&typeof c.paths.vs<"u"&&delete c.paths.vs,typeof c.trustedTypesPolicy!==void 0&&delete c.trustedTypesPolicy,c.catchError=!0,p.globals.require.config(c)),new Promise((I,W)=>{(p.globals.require||T)([b],q=>{if(this.b=q.create(P),!this.b){W(new Error("No RequestHandler!"));return}I((0,l.getAllMethodNames)(this.b))},W)}))}}r.SimpleWorkerServer=d;function s(a){return new d(a,null)}r.create=s}),X(Q[52],J([0,1,7,10]),function(T,r,A,e){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.TokenizationRegistry=void 0;class E{constructor(){this.a=new Map,this.b=new Map,this.c=new A.Emitter,this.onDidChange=this.c.event,this.d=null}fire(C){this.c.fire({changedLanguages:C,changedColorMap:!1})}register(C,o){return this.a.set(C,o),this.fire([C]),(0,e.toDisposable)(()=>{this.a.get(C)===o&&(this.a.delete(C),this.fire([C]))})}registerFactory(C,o){var f;(f=this.b.get(C))===null||f===void 0||f.dispose();const S=new l(this,C,o);return this.b.set(C,S),(0,e.toDisposable)(()=>{const t=this.b.get(C);!t||t!==S||(this.b.delete(C),t.dispose())})}getOrCreate(C){return ue(this,void 0,void 0,function*(){const o=this.get(C);if(o)return o;const f=this.b.get(C);return!f||f.isResolved?null:(yield f.resolve(),this.get(C))})}get(C){return this.a.get(C)||null}isResolved(C){if(this.get(C))return!0;const f=this.b.get(C);return!!(!f||f.isResolved)}setColorMap(C){this.d=C,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}r.TokenizationRegistry=E;class l extends e.Disposable{get isResolved(){return this.c}constructor(C,o,f){super(),this.g=C,this.h=o,this.i=f,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}resolve(){return ue(this,void 0,void 0,function*(){return this.b||(this.b=this.j()),this.b})}j(){return ue(this,void 0,void 0,function*(){const C=yield Promise.resolve(this.i.createTokenizationSupport());this.c=!0,C&&!this.a&&this.q(this.g.register(this.h,C))})}}}),X(Q[53],J([0,1,24,12,2,52]),function(T,r,A,e,E,l){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.TokenizationRegistry=r.InlayHintKind=r.Command=r.FoldingRangeKind=r.SymbolKinds=r.isLocationLink=r.DocumentHighlightKind=r.SignatureHelpTriggerKind=r.InlineCompletionTriggerKind=r.CompletionItemKinds=r.EncodedTokenizationResult=r.TokenizationResult=r.Token=void 0;class p{constructor(v,u,d){this._tokenBrand=void 0,this.offset=v,this.type=u,this.language=d}toString(){return"("+this.offset+", "+this.type+")"}}r.Token=p;class C{constructor(v,u){this._tokenizationResultBrand=void 0,this.tokens=v,this.endState=u}}r.TokenizationResult=C;class o{constructor(v,u){this._encodedTokenizationResultBrand=void 0,this.tokens=v,this.endState=u}}r.EncodedTokenizationResult=o;var f;(function(g){const v=new Map;v.set(0,A.Codicon.symbolMethod),v.set(1,A.Codicon.symbolFunction),v.set(2,A.Codicon.symbolConstructor),v.set(3,A.Codicon.symbolField),v.set(4,A.Codicon.symbolVariable),v.set(5,A.Codicon.symbolClass),v.set(6,A.Codicon.symbolStruct),v.set(7,A.Codicon.symbolInterface),v.set(8,A.Codicon.symbolModule),v.set(9,A.Codicon.symbolProperty),v.set(10,A.Codicon.symbolEvent),v.set(11,A.Codicon.symbolOperator),v.set(12,A.Codicon.symbolUnit),v.set(13,A.Codicon.symbolValue),v.set(15,A.Codicon.symbolEnum),v.set(14,A.Codicon.symbolConstant),v.set(15,A.Codicon.symbolEnum),v.set(16,A.Codicon.symbolEnumMember),v.set(17,A.Codicon.symbolKeyword),v.set(27,A.Codicon.symbolSnippet),v.set(18,A.Codicon.symbolText),v.set(19,A.Codicon.symbolColor),v.set(20,A.Codicon.symbolFile),v.set(21,A.Codicon.symbolReference),v.set(22,A.Codicon.symbolCustomColor),v.set(23,A.Codicon.symbolFolder),v.set(24,A.Codicon.symbolTypeParameter),v.set(25,A.Codicon.account),v.set(26,A.Codicon.issues);function u(a){let i=v.get(a);return i||(console.info("No codicon found for CompletionItemKind "+a),i=A.Codicon.symbolProperty),i}g.toIcon=u;const d=new Map;d.set("method",0),d.set("function",1),d.set("constructor",2),d.set("field",3),d.set("variable",4),d.set("class",5),d.set("struct",6),d.set("interface",7),d.set("module",8),d.set("property",9),d.set("event",10),d.set("operator",11),d.set("unit",12),d.set("value",13),d.set("constant",14),d.set("enum",15),d.set("enum-member",16),d.set("enumMember",16),d.set("keyword",17),d.set("snippet",27),d.set("text",18),d.set("color",19),d.set("file",20),d.set("reference",21),d.set("customcolor",22),d.set("folder",23),d.set("type-parameter",24),d.set("typeParameter",24),d.set("account",25),d.set("issue",26);function s(a,i){let c=d.get(a);return typeof c>"u"&&!i&&(c=9),c}g.fromString=s})(f=r.CompletionItemKinds||(r.CompletionItemKinds={}));var S;(function(g){g[g.Automatic=0]="Automatic",g[g.Explicit=1]="Explicit"})(S=r.InlineCompletionTriggerKind||(r.InlineCompletionTriggerKind={}));var t;(function(g){g[g.Invoke=1]="Invoke",g[g.TriggerCharacter=2]="TriggerCharacter",g[g.ContentChange=3]="ContentChange"})(t=r.SignatureHelpTriggerKind||(r.SignatureHelpTriggerKind={}));var w;(function(g){g[g.Text=0]="Text",g[g.Read=1]="Read",g[g.Write=2]="Write"})(w=r.DocumentHighlightKind||(r.DocumentHighlightKind={}));function h(g){return g&&e.URI.isUri(g.uri)&&E.Range.isIRange(g.range)&&(E.Range.isIRange(g.originSelectionRange)||E.Range.isIRange(g.targetSelectionRange))}r.isLocationLink=h;var m;(function(g){const v=new Map;v.set(0,A.Codicon.symbolFile),v.set(1,A.Codicon.symbolModule),v.set(2,A.Codicon.symbolNamespace),v.set(3,A.Codicon.symbolPackage),v.set(4,A.Codicon.symbolClass),v.set(5,A.Codicon.symbolMethod),v.set(6,A.Codicon.symbolProperty),v.set(7,A.Codicon.symbolField),v.set(8,A.Codicon.symbolConstructor),v.set(9,A.Codicon.symbolEnum),v.set(10,A.Codicon.symbolInterface),v.set(11,A.Codicon.symbolFunction),v.set(12,A.Codicon.symbolVariable),v.set(13,A.Codicon.symbolConstant),v.set(14,A.Codicon.symbolString),v.set(15,A.Codicon.symbolNumber),v.set(16,A.Codicon.symbolBoolean),v.set(17,A.Codicon.symbolArray),v.set(18,A.Codicon.symbolObject),v.set(19,A.Codicon.symbolKey),v.set(20,A.Codicon.symbolNull),v.set(21,A.Codicon.symbolEnumMember),v.set(22,A.Codicon.symbolStruct),v.set(23,A.Codicon.symbolEvent),v.set(24,A.Codicon.symbolOperator),v.set(25,A.Codicon.symbolTypeParameter);function u(d){let s=v.get(d);return s||(console.info("No codicon found for SymbolKind "+d),s=A.Codicon.symbolProperty),s}g.toIcon=u})(m=r.SymbolKinds||(r.SymbolKinds={}));class L{constructor(v){this.value=v}}r.FoldingRangeKind=L,L.Comment=new L("comment"),L.Imports=new L("imports"),L.Region=new L("region");var y;(function(g){function v(u){return!u||typeof u!="object"?!1:typeof u.id=="string"&&typeof u.title=="string"}g.is=v})(y=r.Command||(r.Command={}));var _;(function(g){g[g.Type=1]="Type",g[g.Parameter=2]="Parameter"})(_=r.InlayHintKind||(r.InlayHintKind={})),r.TokenizationRegistry=new l.TokenizationRegistry}),X(Q[54],J([0,1,51,7,27,12,3,2,31,53,47]),function(T,r,A,e,E,l,p,C,o,f,S){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.createMonacoBaseAPI=r.KeyMod=void 0;class t{static chord(m,L){return(0,E.KeyChord)(m,L)}}r.KeyMod=t,t.CtrlCmd=2048,t.Shift=1024,t.Alt=512,t.WinCtrl=256;function w(){return{editor:void 0,languages:void 0,CancellationTokenSource:A.CancellationTokenSource,Emitter:e.Emitter,KeyCode:S.KeyCode,KeyMod:t,Position:p.Position,Range:C.Range,Selection:o.Selection,SelectionDirection:S.SelectionDirection,MarkerSeverity:S.MarkerSeverity,MarkerTag:S.MarkerTag,Uri:l.URI,Token:f.Token}}r.createMonacoBaseAPI=w}),X(Q[57],J([0,1,15,5,12,3,2,44,18,40,41,54,20,46,39,11]),function(T,r,A,e,E,l,p,C,o,f,S,t,w,h,m,L){"use strict";Object.defineProperty(r,"__esModule",{value:!0}),r.create=r.EditorSimpleWorker=void 0;class y extends C.MirrorTextModel{get uri(){return this.c}get eol(){return this.f}getValue(){return this.getText()}getLinesContent(){return this.d.slice(0)}getLineCount(){return this.d.length}getLineContent(u){return this.d[u-1]}getWordAtPosition(u,d){const s=(0,o.getWordAtText)(u.column,(0,o.ensureValidWordDefinition)(d),this.d[u.lineNumber-1],0);return s?new p.Range(u.lineNumber,s.startColumn,u.lineNumber,s.endColumn):null}words(u){const d=this.d,s=this.p.bind(this);let a=0,i="",c=0,b=[];return{*[Symbol.iterator](){for(;;)if(c<b.length){const N=i.substring(b[c].start,b[c].end);c+=1,yield N}else if(a<d.length)i=d[a],b=s(i,u),c=0,a+=1;else break}}}getLineWords(u,d){const s=this.d[u-1],a=this.p(s,d),i=[];for(const c of a)i.push({word:s.substring(c.start,c.end),startColumn:c.start+1,endColumn:c.end+1});return i}p(u,d){const s=[];let a;for(d.lastIndex=0;(a=d.exec(u))&&a[0].length!==0;)s.push({start:a.index,end:a.index+a[0].length});return s}getValueInRange(u){if(u=this.q(u),u.startLineNumber===u.endLineNumber)return this.d[u.startLineNumber-1].substring(u.startColumn-1,u.endColumn-1);const d=this.f,s=u.startLineNumber-1,a=u.endLineNumber-1,i=[];i.push(this.d[s].substring(u.startColumn-1));for(let c=s+1;c<a;c++)i.push(this.d[c]);return i.push(this.d[a].substring(0,u.endColumn-1)),i.join(d)}offsetAt(u){return u=this.r(u),this.k(),this.h.getPrefixSum(u.lineNumber-2)+(u.column-1)}positionAt(u){u=Math.floor(u),u=Math.max(0,u),this.k();const d=this.h.getIndexOf(u),s=this.d[d.index].length;return{lineNumber:1+d.index,column:1+Math.min(d.remainder,s)}}q(u){const d=this.r({lineNumber:u.startLineNumber,column:u.startColumn}),s=this.r({lineNumber:u.endLineNumber,column:u.endColumn});return d.lineNumber!==u.startLineNumber||d.column!==u.startColumn||s.lineNumber!==u.endLineNumber||s.column!==u.endColumn?{startLineNumber:d.lineNumber,startColumn:d.column,endLineNumber:s.lineNumber,endColumn:s.column}:u}r(u){if(!l.Position.isIPosition(u))throw new Error("bad position");let{lineNumber:d,column:s}=u,a=!1;if(d<1)d=1,s=1,a=!0;else if(d>this.d.length)d=this.d.length,s=this.d[d-1].length+1,a=!0;else{const i=this.d[d-1].length+1;s<1?(s=1,a=!0):s>i&&(s=i,a=!0)}return a?{lineNumber:d,column:s}:u}}class _{constructor(u,d){this.c=u,this.d=Object.create(null),this.f=d,this.g=null}dispose(){this.d=Object.create(null)}h(u){return this.d[u]}j(){const u=[];return Object.keys(this.d).forEach(d=>u.push(this.d[d])),u}acceptNewModel(u){this.d[u.url]=new y(E.URI.parse(u.url),u.lines,u.EOL,u.versionId)}acceptModelChanged(u,d){if(!this.d[u])return;this.d[u].onEvents(d)}acceptRemovedModel(u){!this.d[u]||delete this.d[u]}computeUnicodeHighlights(u,d,s){return ue(this,void 0,void 0,function*(){const a=this.h(u);return a?h.UnicodeTextModelHighlighter.computeUnicodeHighlights(a,d,s):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}})}computeDiff(u,d,s,a){return ue(this,void 0,void 0,function*(){const i=this.h(u),c=this.h(d);return!i||!c?null:_.k(i,c,s,a)})}static k(u,d,s,a){const i=a==="experimental"?m.linesDiffComputers.experimental:m.linesDiffComputers.smart,c=u.getLinesContent(),b=d.getLinesContent(),N=i.computeDiff(c,b,s);return{identical:N.changes.length>0?!1:this.l(u,d),quitEarly:N.quitEarly,changes:N.changes.map(R=>{var P;return[R.originalRange.startLineNumber,R.originalRange.endLineNumberExclusive,R.modifiedRange.startLineNumber,R.modifiedRange.endLineNumberExclusive,(P=R.innerChanges)===null||P===void 0?void 0:P.map(I=>[I.originalRange.startLineNumber,I.originalRange.startColumn,I.originalRange.endLineNumber,I.originalRange.endColumn,I.modifiedRange.startLineNumber,I.modifiedRange.startColumn,I.modifiedRange.endLineNumber,I.modifiedRange.endColumn])]})}}static l(u,d){const s=u.getLineCount(),a=d.getLineCount();if(s!==a)return!1;for(let i=1;i<=s;i++){const c=u.getLineContent(i),b=d.getLineContent(i);if(c!==b)return!1}return!0}computeMoreMinimalEdits(u,d){return ue(this,void 0,void 0,function*(){const s=this.h(u);if(!s)return d;const a=[];let i;d=d.slice(0).sort((c,b)=>{if(c.range&&b.range)return p.Range.compareRangesUsingStarts(c.range,b.range);const N=c.range?0:1,M=b.range?0:1;return N-M});for(let{range:c,text:b,eol:N}of d){if(typeof N=="number"&&(i=N),p.Range.isEmpty(c)&&!b)continue;const M=s.getValueInRange(c);if(b=b.replace(/\r\n|\n|\r/g,s.eol),M===b)continue;if(Math.max(b.length,M.length)>_.n){a.push({range:c,text:b});continue}const R=(0,A.stringDiff)(M,b,!1),P=s.offsetAt(p.Range.lift(c).getStartPosition());for(const I of R){const W=s.positionAt(P+I.originalStart),O=s.positionAt(P+I.originalStart+I.originalLength),q={text:b.substr(I.modifiedStart,I.modifiedLength),range:{startLineNumber:W.lineNumber,startColumn:W.column,endLineNumber:O.lineNumber,endColumn:O.column}};s.getValueInRange(q.range)!==q.text&&a.push(q)}}return typeof i=="number"&&a.push({eol:i,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),a})}computeLinks(u){return ue(this,void 0,void 0,function*(){const d=this.h(u);return d?(0,f.computeLinks)(d):null})}textualSuggest(u,d,s,a){return ue(this,void 0,void 0,function*(){const i=new w.StopWatch(!0),c=new RegExp(s,a),b=new Set;e:for(const N of u){const M=this.h(N);if(!!M){for(const R of M.words(c))if(!(R===d||!isNaN(Number(R)))&&(b.add(R),b.size>_.o))break e}}return{words:Array.from(b),duration:i.elapsed()}})}computeWordRanges(u,d,s,a){return ue(this,void 0,void 0,function*(){const i=this.h(u);if(!i)return Object.create(null);const c=new RegExp(s,a),b=Object.create(null);for(let N=d.startLineNumber;N<d.endLineNumber;N++){const M=i.getLineWords(N,c);for(const R of M){if(!isNaN(Number(R.word)))continue;let P=b[R.word];P||(P=[],b[R.word]=P),P.push({startLineNumber:N,startColumn:R.startColumn,endLineNumber:N,endColumn:R.endColumn})}}return b})}navigateValueSet(u,d,s,a,i){return ue(this,void 0,void 0,function*(){const c=this.h(u);if(!c)return null;const b=new RegExp(a,i);d.startColumn===d.endColumn&&(d={startLineNumber:d.startLineNumber,startColumn:d.startColumn,endLineNumber:d.endLineNumber,endColumn:d.endColumn+1});const N=c.getValueInRange(d),M=c.getWordAtPosition({lineNumber:d.startLineNumber,column:d.startColumn},b);if(!M)return null;const R=c.getValueInRange(M);return S.BasicInplaceReplace.INSTANCE.navigateValueSet(d,N,M,R,s)})}loadForeignModule(u,d,s){const a=(b,N)=>this.c.fhr(b,N),c={host:(0,L.createProxyObject)(s,a),getMirrorModels:()=>this.j()};return this.f?(this.g=this.f(c,d),Promise.resolve((0,L.getAllMethodNames)(this.g))):new Promise((b,N)=>{T([u],M=>{this.g=M.create(c,d),b((0,L.getAllMethodNames)(this.g))},N)})}fmr(u,d){if(!this.g||typeof this.g[u]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+u));try{return Promise.resolve(this.g[u].apply(this.g,d))}catch(s){return Promise.reject(s)}}}r.EditorSimpleWorker=_,_.n=1e5,_.o=1e4;function g(v){return new _(v,null)}r.create=g,typeof importScripts=="function"&&(e.globals.monaco=(0,t.createMonacoBaseAPI)())})}).call(this);

//# sourceMappingURL=../../../../min-maps/vs/base/worker/workerMain.js.map